;**********************************************************************;
;*                        D U M P A . A S M                           *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : ein, Filter der Zeichen von der Standardeingabe*;
;*                     einliest und sie als Hex- und ASCII-Dump auf   *;
;*                     dem Standardausgabe ausgibt                    *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  1.08.87                                       *;
;*    letztes Update : 20.10.91                                       *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM DUMPA;                                    *;
;*                     LINK DUMPA;                                    *;
;*                     EXE2BIN DUMPA DUMP.COM  oder                   *;
;*                                                                    *;
;*                     TASM DUMPA                                     *;
;*                     TLINK /T DUMPA                                 *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : DUMPA [<Eingabe] [>Ausgabe]                    *;
;**********************************************************************;
                                                                        
;== Konstanten =========================================================
                                                                        
      NUL    equ 0                ;ASCII-Code NUL-Zeichen
      BEL    equ 7                ;ASCII-Code Klingelzeichen
      BS     equ 8                ;ASCII-Code Backspace
      TAB    equ 9                ;ASCII-Code Tabulator
      LF     equ 10               ;ASCII-Code Linefeed
      CR     equ 13               ;ASCII-Code Carriage Return
      EOF    equ 26               ;ASCII-Code Datei-Ende
      ESCAPE equ 27               ;ASCII-Code Escape
                                                                        
;== hier beginnt das eigentliche Programm ==============================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          org 100h
                                                                        
          assume cs:code, ds:code, es:code, ss:code
                                                                        
;-- Startroutine -------------------------------------------------------
                                                                        
dump      label near
                                                                        
          ;-- 9 Bytes vom Standardeingabegert einlesen ----------------
                                                                        
          xor  bx,bx              ;Standardeingabe trgt den Handle 0
          mov  cx,9               ;9 Zeichen einlesen
          mov  dx,offset neunbyte ;Adresse des Puffers
          mov  ah,3Fh             ;Funktionscode fr Handle-lesen
          int  21h                ;DOS-Funktion aufrufen
          or   ax,ax              ;wurden Zeichen eingelesen?
          jne  dodump             ;JA --> Zeile bearbeiten
          jmp  dumpende           ;NEIN --> DUMPENDE
                                                                        
dodump:   mov  dx,ax              ;Anzahl der eingelesenen Zeichen merken
                                                                        
          ;-- Ausgabepuffer mit Spaces fllen --------------------------
                                                                        
          mov  cx,15              ;15 Words (30 Byte)
          mov  ax,2020h           ;ASCII-Code des " " nach AH und AL
          mov  di,offset dumppuf  ;die Adresse des Ausgabepuffers
          cld                     ;bei Stringbefehlen nach oben zhlen
          rep stosw               ;Puffer mit Spaces fllen
                                                                        
          ;-- Ausgabepuffer aufbauen -----------------------------------
                                                                        
          mov  cx,dx              ;Anzahl der eingelesenen Zeichen holen
          mov  di,offset dumppuf+31 ;Position fr Ascii-Codes im Puffer
          mov  bx,offset neunbyte ;Zeiger in den Eingabepuffer
          mov  si,offset dumppuf  ;Position fr Hex-Codes im Puffer
                                                                        
einbyte:  mov  ah,[bx]            ;Byte einlesen
          push si                 ;SI auf dem Stack merken
          mov  si,offset sotab    ;Adresse der Sonderzeichen-Tabelle
          mov  dx,offset sotext-6 ;Adresse der Sonderzeichen-Texte
sotest:   add  dx,6               ;nchsten Eintrag in den Sond.-Texten
          lodsb                   ;Code aus der Sonderzeichen-Tab. laden
          cmp  al,255             ;Ende der Tabelle erreicht?
          je   noso               ;JA --> kein Sonderzeichen
          cmp  ah,al              ;stimmen die Codes berein
          jne  sotest             ;NEIN --> nchstes Tab.-Element testen
                                                                        
          ;-- Code war ein Sonderzeichen -------------------------------
                                                                        
          push cx                 ;Zhler merken
          mov  si,dx              ;DX nach SI kopieren
          lodsb                   ;Anzahl Zeichen des Steuercodes lesen
          mov  cl,al              ;Anzahl Zeichen nach CL bertragen
          rep  movsb              ;Bezeichnung in Puffer kopieren
          pop  cx                 ;Zhler holen
          pop  si                 ;SI vom Stack zurckholen
          mov  al,ah              ;Zeichen nach AL kopieren
          jmp  short hex          ;Hex-Code berechnen
                                                                        
noso:     pop  si                 ;SI vom Stack zurckholen
          mov  al,ah              ;Zeichen nach AL kopieren
          stosb                   ;im Puffer abspeichern
                                                                        
hex:      mov  al,ah              ;Code des Zeichen nach AL
          and  ah,1111b           ;oberen 4 Bit in AH ausblenden
          shr  al,1               ;AL um insgesamt 4 Bits nach rechts
          shr  al,1               ;schieben
          shr  al,1
          shr  al,1
          or   ax,3030h           ;AH und AL in ASCII-Codes umwandeln
          cmp  al,"9"             ;reprsentiert AL einen Buchstaben?
          jbe  nobal              ;NEIN --> keine Korrektur
          add  al,"A"-"1"-9       ;AL korrigieren
nobal:    cmp  ah,"9"             ;reprsentiert AH einen Buchstaben?
          jbe  hexout             ;NEIN --> keine Korrektur
          add  ah,"A"-"1"-9       ;AH korrigieren
hexout:   mov  [si],ax            ;Hex-Code im Puffer ablegen
          add  si,3               ;auf nchste Position zeigen
                                                                        
          inc  bx                 ;Zeiger auf nchstes Byte setzen
          loop einbyte            ;nchstes Byte bearbeiten
                                                                        
          mov  al,219             ;Trennzeichen setzen
          stosb
                                                                        
          mov  ax,LF shl 8 + CR   ;CR und LF schlieen den Puffer ab
          stosw                   ;in Puffer schreiben
                                                                        
          ;-- Dump an das Standardausgabegert senden ------------------
                                                                        
          mov  bx,1               ;Standardausgabe trgt den Handle 1
          mov  cx,di              ;Anzahl der zu bertragenen Zeichen
          sub  cx,offset dumppuf  ;ermitteln
          mov  dx,offset dumppuf  ;Adresse des Puffers
          mov  ah,40h             ;Funktionscode fr Handle-schreiben
          int  21h                ;DOS-Funktion aufrufen
          jmp  dump               ;nchsten 9 Bytes einlesen
                                                                        
dumpende  label near
                                                                        
          mov  ax,4C00h           ;Fkt.Nr. fr Programm beenden
          int  21h                ;Programm mit Ende-Code beenden
                                                                        
;== Daten ==============================================================
                                                                        
neunbyte  db 9 dup (?)            ;die jeweils eingelesen 9 Bytes
dumppuf   db 30 dup (?), 219      ;der Ausgabepuffer
          db 49 dup (?)
                                                                        
sotab     db NUL,BEL,BS,TAB       ;Tabelle der Steuerzeichen
	  db LF,CR,EOF,ESCAPE
          db 255
                                                                        
sotext    equ this byte           ;Texte der Sonderzeichen
          db 5,"<NUL>"            ;NUL
          db 5,"<BEL>"            ;Klingelzeichen
          db 4,"<BS> "            ;Backspace
          db 5,"<TAB>"            ;Tabulator
          db 4,"<LF> "            ;Linefeed
          db 4,"<CR> "            ;Carriage-Return
          db 5,"<EOF>"            ;Dateiende
          db 5,"<ESC>"            ;Escape
                                                                        
;== Ende ===============================================================
                                                                        
code      ends                    ;Ende des CODE-Segments
          end  dump
