;**********************************************************************;
;*                       E G E R U E S T . A S M                      *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Gerst fr die Entwicklung eines EXE-Programms *;
;*                     in Assembler mit dem Turbo Assembler TASM      *;
;*                     oder Microsofts Macro Assembler MASM           *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  7.06.1987                                     *;
;*    letztes Update : 10.10.1991                                     *;
;*--------------------------------------------------------------------*;
;*    Entwicklung    : MASM:   masm egeruest;                         *;
;*                             link egeruest;                         *;
;*                                                                    *;
;*                     TASM:   tasm egeruest                          *;
;*                             tlink egeruest                         *;
;**********************************************************************;

;== Stack ==============================================================

stackseg  segment para STACK 'STACK'      ;Definition des Stack-Segments

          dw 256 dup (?)          ;der Stack umfat 256 Words

stackseg  ends                     ;Ende des Stack-Segments
        
;== Daten ==============================================================

data      segment para 'DATA'     ;Definition des Daten-Segments

          ;-- hier knnen Sie Ihre gesamten Daten, Puffer und ----------
          ;-- Variablen anlegen

          ;...
          ;...
          ;...

data      ends                    ;Ende des Daten-Segments

;== Code ===============================================================

code      segment para 'CODE'     ;Definition des CODE-Segments

          assume cs:code, ds:data, ss:stackseg

                                  ;CS bezieht sich auf das Code-, DS
                                  ;auf das Data- und SS auf das Stack-
                                  ;Segment. ES kann frei verwendet 
                                  ;werden

prog      proc far                ;diese Prozedur ist das eigentliche
                                  ;Hauptprogramm und wird nach dem
                                  ;Programmstart ausgefhrt

          ;-- CS und SS sind an dieser Stelle bereits initialisiert. ---
          ;-- Nur DS mu von Hand initialisiert werden, weil es genau
          ;-- wie ES noch auf den PSP zeigt
  
          mov  ax,data            ;Segmentadresse des Datensegments in
          mov  ds,ax              ;das DS-Register laden

          call setfree            ;nicht bentigten Speicher freimachen

          ;-- hier knnen Sie den Programmcode des Hauptprogramms ------
          ;-- unterbringen      

          ;...
          ;...
          ;...

          ;--- Programm mit Hilfe der DOS-Funktion 4Ch beenden ---------

          mov  ax,4C00h           ;Funktinosnummer laden, Fehlercode 0
          int  21h                ;DOS-Aufrufen                   
                                  
          ;--- hier kommt die Programmausfhrung nicht mehr hin, weil --
          ;--- der vorhergehende DOS-Aufruf das Programm beendet hat

prog      endp                    ;Ende der PROG-Prozedur

;-- Unterroutinen ------------------------------------------------------
;-- Hier ist Platz fr die verschiedenen Unterroutinen des Programms 

a_proc    proc near

          ;...
          ;...
          ;...
          ret

a_proc    endp 

b_proc    proc near

          ;...
          ;...
          ;...
          ret

b_proc    endp 

;-- SETFREE: den nicht belegten Speicherplatz freigeben ----------------
;-- Eingabe  : ES = Adresse des PSP
;-- Ausgabe  : keine
;-- Register : AX, BX, CL und FLAGS werden verndert
;-- Info     : Da das Stack-Segment immer das letzte Segment in einer
;              EXE-Datei ist, deutet ES:0000 auf den Anfang und SS:SP
;              auf das Ende des Programms im Speicher. Dadurch kann die
;              Lnge des Programms berechnet werden

setfree   proc near

          mov  bx,ss              ;Abstand zwsichen PSP und Stack in
          mov  ax,es              ;Paragraphen berechnen
          sub  bx,ax

          mov  ax,sp              ;Lge des Stack in Paragraphen
          add  ax,15              ;berechhnen
          mov  cl,4                         
          shr  ax,cl              ;Inhalt die Lnge des Stacks an

          add  bx,ax              ;die beiden Werte addieren

          mov  ah,4ah             ;nur diesen Speicher weiterh reser-
          int  21h                ;viert halten

          ret                     ;zurck zum Aufrufer

setfree   endp

;== Ende ===============================================================

code      ends                    ;Ende des CODE-Segments
          end  prog               ;Ausfhrung mit der Prozedur PROG
                                  ;beginnen

