;**********************************************************************;
;*                     F F . A S M    ( FileFind )                    *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : sucht auf einem angegebenen Laufwerk nach be-  *;
;*                     stimmten Dateien                               *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  : 12.09.1990                                     *;
;*    letztes Update : 14.10.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM FF;                                       *;
;*                     LINK FF;                                       *;
;*                     EXE2BIN FF FF.COM                  oder        *;
;*                                                                    *;
;*                     TASM FF                                        *;
;*                     TLINK FF /T                                    *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : FF [Lw:]Dateiname [+ oder - oder =Datum]       *;
;**********************************************************************;

;== Konstanten =========================================================
  
CMD_OFS      equ     81h          ;Start der Kommndozeile im PSP
CR           equ     13           ;Carriage Return
LF           equ     10           ;Linefeed
DELIMITER    equ     "."          ;Trennung fr Datumskomponenten

             ;-- DOS-Funktionen ----------------------------------------

GET_LW_NR    equ     19h          ;aktuelles Laufwerk ermitteln
WRT_CHAR     equ     02h          ;Zeichen auf STDOUT ausgeben
SEARCH_FIRST equ     4Eh          ;erste Datei suchen
SEARCH_NEXT  equ     4Fh          ;nchste Datei suchen
SET_DTA      equ     1Ah          ;neuen DTA-Bereich setzen
PRINT_STR    equ     09h          ;$-terminierten String ausgeben

ATTR_DIR     equ     10h          ;nach Unterverzeichnis suchen
ATTR_NRM     equ     00h          ;nach normalen Dateien suchen

DATCOMP_NO   equ     0            ;kein Datumsvergleich
DATCOMP_KL   equ     1            ;Datumsvergleich vor dem ....
DATCOMP_GL   equ     2            ;Datumsvergleich am ....
DATCOMP_GR   equ     3            ;Datumsvergleich nach dem ...

;== Strukturen =========================================================

PSP        struc                   ;bildet den Aufbau des PSP nach
             intcall  dw (?)       ;Interruptaufruf 20h
             endadr   dw (?)       ;Endadresse
                      db (?)       ;reserviert
             farcall  db 5 dup (?) ;FAR-CAL zum Interrupt 21h
             int22h   dd (?)       ;Kopie des Interrupts 22h
             int23h   dd (?)       ;Kopie des Interrupts 23h
             int24h   dd (?)       ;Kopie des Interrupts 24h
                      db 22 dup (?);reserviert
             envseg   dw (?)       ;Segmentadresse des Environment
                      db 46 dup (?);reserviert

             ;-- hier folgt der erste FCB ------------------------------

             drvcode1 db (?)       ;Gertenummer
             datname1 db 8 dup (?) ;Dateiname
             daterw1  db 3 dup (?) ;Dateierweiterung
             blocknr1 dw (?)       ;aktuelle Blocknummer
             datlen1  dd (?)       ;Dateilnge
             datmod1  dw (?)       ;Datum der letzten Modifikation
             timemod1 dw (?)       ;Uhrzeit der letzten Modifikation
                      dw 4 dup (?) ;reserviert
             aktset1  db (?)       ;aktuelle Datensatznummer
             setfree1 dd (?)       ;Datensatznummer fr freien Zugriff

             ;-- hier folgt der zweite FCB -----------------------------

             drvcode2 db (?)       ;Gertenummer
             datname2 db 8 dup (?) ;Dateiname
             daterw2  db 3 dup (?) ;Dateierweiterung
             blocknr2 dw (?)       ;aktuelle Blocknummer
             datlen2  dd (?)       ;Dateilnge
             datmod2  dw (?)       ;Datum der letzten Modifikation
             timemod2 dw (?)       ;Uhrzeit der letzten Modifikation
                      dw 4 dup (?) ;reserviert
             aktset2  db (?)       ;aktuelle Datensatznummer
             setfree2 dd (?)       ;Datensatznummer fr freien Zugriff

                      db 128 dup (?) ;Kommandozeile
PSP        ends

;----------------------------------------------------------------------

DTA        struc                   ;Aufbau der DTA bei der Dateisuche
                      db 21 dup (?);reserviert
             attr     db (?)       ;Attribut der gefundenen Datei
             timemod  dw (?)       ;Uhrzeit der letzten Modifikation
             datemod  dw (?)       ;Datum der letzten Modifikation
             datlen   dd (?)       ;Dateilnge
             datn     db 13 dup (?);Dateiname
DTA        ends

;----------------------------------------------------------------------

DATUM      struc                   ;nimmt Datumsinformationen auf
              tag     db (?)       ;Tag des Monats (1-31)
              monat   db (?)       ;Monat (1-12)
              jahr    dw (?)       ;Jahr, inklusive Jahrhundert
DATUM      ends

;== hier beginnt das eigentliche Programm ==============================

code      segment para 'CODE'     ;Definition des CODE-Segments

           org 100h                ;Start hinter PSP

           assume cs:code, ds:code, es:code, ss:code

start:     jmp startff        ;zum Programmstart springen

;== Daten ==============================================================

datcomp    db  DATCOMP_NO          ;Default ist keine Datumssuche
sdatum     DATUM < 0, 0, 0>        ;Datum aus der Kommandozeile
tdatum     DATUM < 0, 0, 0>        ;Datum der zu berprfenden Datei

verzname   db  64, ":\"            ;Name des aktuell durchlaufenen
firstdir   db  79 dup (0)          ;Verzeichnisses
suchname   db  "*.*", 0            ;Name der zu suchenden Dateien
           db  9 dup (0)

jokname    db  "*.*", 0            ;Name fr Unterverzeichnissuche
found      dw  0                   ;Anzahl der gefundenen Dateien

mes        db  CR, LF, "FF: Keine Datei(en) gefunden."
crlf       db  CR, LF, "$"

datpuffer  db "ddddd.dd.dddd  ",0  ;Puffer fr die Datumsumwandlung
datpend    equ this byte           ;nach ASCII

errmes     db "FF  -  (c) 1990, 91 by MICHAEL TISCHER", 13,10,10
           db "Aufruf: FF [Lw:]Dateiname [+ oder - oder =Datum]",13,10
           db "$"

;== eigentlicher Programmstart =========================================

startff:   ;-- Argumente aus der Kommandozeile auswerten ---------------

           cld                    ;Bei Stringbefehlen aufwrts
           mov     di,offset suchname
           mov     si,CMD_OFS     ;SI auf Anfang der Kommandozeile

arg1:      ;-- zunchst Gertebezeichnung auswerten --------------------

           lodsb                  ;Zeichen aus der Kommandozeile laden
           cmp     al,CR          ;Ende der Kommandozeile entdeckt?
           je      arg6           ;Ja ---> Auswertung beenden
           cmp     al," "         ;Nein, aber vielleich Leerzeichen?
           jbe     arg1           ;Nein, mu Tab sein, weiter

           ;-- es wurde ein Buchstabe gefunden -------------------------

           cmp     ds:[0].drvcode1,0 ;ist es Gertebezeichnung?
           je      arg2           ;Nein, sonst stnde sie schon im FCB
           lodsb                  ;Doppelpunkt laden
           lodsb                  ;nchstes Zeichen laden
           cmp     al," "         ;Leerzeichen oder kleiner?
           jbe     arg3           ;Ja, ---> Auswertung abgeschlossen

arg2:      ;-- Dateinamen in Puffer SUCHNAME eintragen -----------------

           stosb                  ;Zeichen in Suchname ablegen
           lodsb                  ;nchstes Zeichen laden
           cmp     al," "         ;Leerzeichen oder kleiner?
           ja      arg2           ;Nein, Buchstabe, weiter laden

arg3:      ;-- Auswertung des Dateinamen beendet -----------------------

           cmp     al,CR          ;Zeilenende erreicht?
           je      arg6

           ;-- Datumsangabe berprfen und ggf. auswerten --------------

arg4:      lodsb                  ;nchstes Zeichen laden
           cmp     al," "         ;Space und Tab sind erlaubt
           je      arg4
           cmp     al,9
           je      arg4
           cmp     al,CR          ;Zeilenende erreicht?
           je      arg6

           cmp     al,"="         ;gleiches Datum?
           jne     arg4a          ;Nein, weitertesten
           mov     al,DATCOMP_GL  ;Flag fr den Datumsvergleich
           jmp     short arg5

arg4a:     cmp     al,"-"         ;Datum vor dem ...
           jne     arg4b          ;Nein, weitertesten
           mov     al,DATCOMP_KL  ;Flag fr den Datumsvergleich
           jmp     short arg5

arg4b:     cmp     al,"+"         ;Datum nach dem ...
           jne     argerr         ;Nein, Fehler in der Kommandozeile
           mov     al,DATCOMP_GR  ;Flag fr den Datumsvergleich

arg5:      mov     datcomp,al     ;Datumsflag merken
           mov     di,offset sdatum ;Zeiger auf Datumsstruktur
           call    getdat         ;Datum aus der Kommandozeile lesen
           jc      argerr         ;Fehler ---> Programm beenden

arg6:      ;-- Auswertung der Kommandozeile abgeschlossen, alles o.k. --

           mov     al,ds:[0].drvcode1  ;Gertebezeichung laden
           or      al,al               ;wurde eine gefunden?
           jne     arg7                 ;Ja, ---> aktuelle nicht erm.

           ;-- keine Gertebezeichnung angegeben, aktuelle whlen ------

           mov     ah,GET_LW_NR   ;aktuelle Laufwerksnummer ermitteln
           int     21h            ;(0=A)
           inc     al             ;LW-Nr erhhen, weil 1 = A

arg7:      add     verzname,al        ;Laufwerksbez. nach ASCII
           mov     dx,offset startdta ;Adresse der ersten DTA
           mov     bx,offset firstdir ;hier kommt der Verzeichnsname hin
           call    go                 ;Suche starten

           mov     ax,found       ;Anzahl der gef. Dateien laden
           or      ax,ax          ;keine Dateien gefunden?
           je      arg8           ;Ja, String unverndert ausgeben
           mov     si,offset mes+6;Zeiger auf Puffer
           call    toint

arg8:      mov     ah,09h         ;Nachricht ausgeben
           mov     dx,offset mes
           int     21h

           mov     ax,4C00h       ;Programm ber die Funktion 4Ch
           int     21h            ;beenden

argerr:    ;-- Fehler bei Auswertung der Kommandozeile aufgetreten -----

           mov     ah,09h           ;Fehlerstring ausgeben
           mov     dx,offset errmes
           int     21h

           mov     ax,4C01h         ;Programm mit Fehlercode beenden
           int     21h

;-- GO: Steuert die Suche nach den angegebenen Dateien -----------------
;-- Eingabe  : BX = Zeiger auf Suchtstring zum Anhngen eines Verzeich-
;--                 nis- oder Dateinamens
;--            DX = Offset der bisherigen DTA
;-- Ausgabe  : keine
;-- Register : AX, SI, CX und FLAGS werden verndert
  
go         proc    near

           push    dx             ;Zeiger auf aktuelle DTA sichern

           mov     si,offset suchname  ;Name der gesuchten Datei
           call    strcopy             ;in Puffer kopieren

           mov     cx,ATTR_NRM     ;nur normale Dateien suchen
           call    startsearch     ;Suche beginnen
           jc      go2             ;keine gefunden ---> Verz. suchen

           call    printname       ;Datei gefunden

go1:       ;-- Suche nach allen weiteren Dateien durchfhren -----------

           call    nextfile        ;nchste Datei suchen
           jc      go2             ;keine mehr gefunden
           call    printname       ;Datei gefunden
           jmp     short go1       ;

go2:       ;-- das aktuelle Verzeichnis noch einmal durchlaufen, -------
           ;-- diesmal aber nach Unterverzeichnissen suchen

           pop     dx              ;Zeiger auf DTA zurckholen
           push    dx              ;und direkt wieder sichern
           mov     si,offset jokname ;*.* an Verzeichnisnamen anhngen
           call    strcopy

           mov     cx,ATTR_DIR     ;jetzt nach Unterverz. suchen
           call    startsearch     ;erstes Unterverzeichnis suchen
           jc      go_end          ;keins gefunden ---> Routine beenden

           mov     si,dx           ;gefunden, aber ist es ein Verz.
           test    [si].attr,ATTR_DIR
           jne     go4             ;Ja ---> auswerten

go3:       ;-- kein Verzeichnis, weitersuchen --------------------------

           call    nextfile        ;nchste Datei suchen
           jc      go_end          ;keins gefunden ---> Routine beenden
           mov     si,dx           ;gefunden, aber ist es ein Verz.
           test    [si].attr,ATTR_DIR
           je      go3             ; Jump if zero

go4:       ;-- Unterverzeichnis gefunden -------------------------------

           cmp     [si].datn,"."   ;"." oder ".."
           je      go3             ;Ja, nicht bearbeiten

           push    di              ;DX und BX auf dem Stack sichern
           push    bx
           mov     si,dx           ;SI auf den Dateinamen in DTA setzen
           add     si,offset datn  ;darin auf Verzeichnisnamen setzen
           mov     di,bx           ;DI auf bisherigen Verzeichnisnamen

go5:       ;-- Verzeichnisnamen an bisherigen Namen anhngen -----------

           lodsb                   ;Zeichen aus Verzeichnisnamen laden
           stosb                   ;und an bisherigen Namen anhngen
           or      al,al           ;letztes Byte bearbeitet?
           jne     go5             ;Nein ---> weiter

           mov     bx,di           ;neues Pufferende in BX merken
           stosb                   ;noch ein NUL-Byte schreiben
           mov     byte ptr [bx-1],"\"  ;davor einen Backslash setzen
           call    go              ;rekursiver Aufruf

           pop     bx              ;BX und DI wieder vom Stack holen
           pop     di
           mov     byte ptr [bx],0 ;letzten Verzeichnisnamen des vor-
                                   ;hergehenden Aufrufs wieder abhngen

           mov     ah,SET_DTA      ;DTA wieder auf alte Adresse in
           int     21h             ;DX setzen

           jmp     short go3

go_end:    pop     dx              ;Zeiger auf alte DTA zurckholen
           ret                     ;zurck zum Aufrufer

go         endp
  
;-- STARTSEARCH: Suche nach einer Datei starten ------------------------
;-- Eingabe  : CX = Attribut der gesuchten Datei
;--            DX = Offset der bisherigen DTA
;-- Ausgabe  : DX = neue Adresse der DTA
;--            Carry-Flag: 0 = o.k., 1 = keine Datei gefunden
;-- Register : AX, DX, BP und FLAGS werden verndert
;-- Info     : Der Name der zu suchenden Datei wird dem Puffer verzname
;--            entnommen

startsearch proc    near

           push    cx             ;CX auf dem Stack sichern

           ;-- zunchst neue DTA hinter aktuelle setzen ----------------

           add     dx,2ch         ;eine DTA ist 42 Bytes lang
           mov     ah,SET_DTA     ;neue DTA setzen
           int     21h

           ;-- jetzt erste Datei mit dem Namen im Puffer verzname suchen

           mov     bp,dx              ;DX sichern
           mov     ah,SEARCH_FIRST    ;erste Datei suchen
           mov     dx,offset verzname ;DS:DX = Zeiger auf Dateiname
           int     21h

           mov     dx,bp          ;DX wieder zurckholen
           pop     cx             ;CX wieder vom Stack holen
           ret                    ;zurck zum Aufrufer

startsearch           endp
  
;-- NEXTFILE: Sucht die nchste Datei ----------------------------------
;-- Eingabe  : keine
;-- Ausgabe  : Carry-Flag: 0 = o.k., 1 = keine Datei gefunden
;-- Register : AY und FLAGS werden verndert
  
nextfile   proc    near

           mov     bp,dx
           mov     ah,SEARCH_NEXT     ;nchste Datei suchen
           mov     dx,offset verzname ;Pfad steht in Puffer verzname
           int     21h
           mov     dx,bp
           ret                    ;zurck zum Aufrufer

nextfile   endp
  
;-- STRCOPY: Kopiert einen ASCII-String, der durch ein NUL-Byte termi- -
;--          niert wird
;-- Eingabe  : SI = Offset des Quell-Strings
;--            BX = Offset des Ziel-Strings
;--            DS = Segment des Source-Strings
;--            ES = Segment des Ziel-Strings
;-- Ausgabe  : keine
;-- Register : AL, DI, SI und FLAGS werden verndert
  
strcopy    proc    near

           mov     di,bx          ;DI auf Zielstring setzen

sc1:       ;-- Kopierschleife ------------------------------------------

           lodsb                  ;Zeichen aus Quell-String laden
           stosb                  ;in Ziel-String ablegen
           or      al,al          ;letztes Zeichen?
           jne     sc1            ;Nein ---> das ganze noch mal

           ret                    ;zurck zum Aufrufer

strcopy    endp
  
;-- PRINTNAME: Namen einer gefundenen Datei ausgeben -------------------
;-- Eingabe  : DX = Zeiger auf aktuelle DTA mit Namen
;--            BX = Offset des Ziel-Strings
;--            DS = Segment des Source-Strings
;--            ES = Segment des Ziel-Strings
;-- Ausgabe  : keine
;-- Register : AL, DI, SI und FLAGS werden verndert
;-- Info     : Der Name der Datei wird nur ausgegeben, wenn es sich
;--            nicht um ein Unterverzeichnis handelt und bei bei einer
;--            definierten Datumsberprfung die gewnschte Relation
;--            ermittelt wird

printname  proc    near
  
           mov     bp,dx          ;Zeiger auf DTA in BP sichern
           cmp     [bp].datn,"."  ;"." oder ".."
           je      prnend         ;Ja, keine Ausgabe

           ;-- Datumsvergleich durchfhren, falls gewnscht -----------

           cmp     datcomp,DATCOMP_NO ;Datumsberprfung?
           je      pn1                ;Nein, Namen direkt ausgeben

           mov     ax,[bp].datemod    ;Ja, Datum holen und entpacken
           mov     si,offset tdatum
           call    entpackdat

           mov     di,offset sdatum   ;jetzt mit Datum aus der Kommando-
           call    cmpdat             ;vergleichen
           cmp     al,datcomp         ;gewnschte Relation?
           jne     prnend             ;Nein, nicht ausgeben

           call    printdat           ;Datum o.k., ausgeben

           ;-- zunchst Verzeichnisnamen ausgeben ----------------------

pn1:       mov     dx,offset verzname  ;Zeiger auf Verzeichnisnamen
           xor     al,al          ;letztes Zeichen des Verz. holen
           xchg    al,[bx]        ;und danach auf 0 setzen
           mov     di,ax          ;Zeichen in DI merken
           call    printasciiz    ;Verzeichnisnamen ausgeben

           xchg    ax,di          ;AX wieder mit altem Wert laden
           mov     [bx],al        ;altes Zeichen zurck an seinen Platz

           ;-- jetzt Dateinamen anhngen -------------------------------

           mov     dx,bp          ;Zeiger auf DTA zurckholen
           add     dx,offset datn ;Dateinamen in DTA adressieren
           call    printasciiz    ;und ausgeben

           mov     ah,PRINT_STR   ;Zeilenvorschub mit Hilfe des DOS
           mov     dx,offset crlf ;ausgeben
           int     21h

           inc     found          ;eine Datei mehr gefunden
           mov     dx,bp          ;altes DX wieder zurckholen
  
prnend:    ret                    ;zurck zum Aufrufer

printname  endp
  
;-- PRINTASCIIZ: Gibt einen ASCII-String auf STDOUT aus, der durch ein -
;--              NUL-Byte terminiert wird
;-- Eingabe  : DX = Zeiger auf den Stringanfang
;--            DS = Segment des Strings
;-- Ausgabe  : keine
;-- Register : AX, DX, SI und FLAGS werden verndert
  
printasciiz proc    near

           mov     si,dx          ;String aus DX laden
           mov     ah,WRT_CHAR    ;Funktionsnummer fr Zeichenausgabe
           lodsb                  ;erstes Zeichen laden

pa1:       ;-- Ausgabeschleife ---------------------------------------

           mov     dl,al          ;Zeichen fr DOS-Funktion nach DL
           int     21h            ;und ausgeben

           lodsb                  ;nchstes Zeichen laden
           or      al,al          ;Ende des Strings erreicht?
           jne     pa1            ;Nein, Zeichen ausgeben

           ret                    ;zurck zum Aufrufer

printasciiz endp

;-- TOINT: verwandelt eine Binrzahl in eine ASCII-Zahl und legt sie ---
;--        einem Puffer des Aufrufers ab
;-- Eingabe  : DS:SI = Adresse des Pufferanfangs
;--            AX    = die umzuwandelnde Binrzahl
;-- Ausgabe  : DS:SI = Adresse der ersten Ziffer
;-- Register : AX, SI und FLAGS werden verndert
;-- Info     : - Der Puffer mu mindestens fnf Zeichen Platz bieten.
;--            - Die Zahl wird rechtsbndig in den Puffer eingetragen.

toint     proc near

          push dx                 ;vernderte Register zunchst auf dem
          push bx                 ;Stack sichern

          ;-- den Puffer zunchst mit Leerzeichen fllen ---------------

          mov  word ptr [si],   32 shl 8 + 32
          mov  word ptr [si+2], 32 shl 8 + 32
          mov  byte ptr [si+4], 32

          ;-- in einer Schleife die Zahl immer wieder durch 10 teilen ---
          ;-- und dabei die niederwertigste Stelle in das ASCII-Format
          ;-- umwandeln und in den Puffer eintragen

          add  si,5               ;SI auf das Ende des Puffers setzen
          mov  bx,10              ;Divisor ist immer 10

ti1:      dec  si                 ;SI auf vorhergehendes Zeichen
          xor  dx,dx              ;Dividend ist DX:AX
          div  bx                 ;DX:AX durch 10 teilen
          or   dl,'0'             ;DL in das ASCII-Format bringen
          mov  [si],dl            ;im Puffer ablegen
          or   ax,ax              ;bleibt noch ein Rest?
          jne  ti1                ;JA --> nchste Ziffer

          pop  bx                 ;Register zurckholen
          pop  dx

          ret                     ;zurck zum Aufrufer

toint     endp

;-- GETINT: liest eine positive Dezimalzahl aus der Kommandozeile und --
;--         wandelt sie in das Binrformat
;-- Eingabe  : SI = Zeiger auf nchstes zu lesendes Zeichen im Kommando-
;--                 zeilenpuffer
;-- Ausgabe  : Carry = 0: Zahl o.k., 1 = Fehler
;--            SI = Zeiger hinter das letzte gelesene Zeichen
;--            AX = Zahl (nur wenn Carry = 0)
;-- Register : AX, CX, SI und FLAGS werden verndert

getint    proc near

          push  bx                ;die vernderten Register sichern
          push  dx
          push  di

          mov  di,10              ;der Faktor ist immer 10
          xor  bx,bx              ;BX nimmt die Binrzahl auf
          mov  ah,bh              ;Hi-Byte von AH ist immer 0

          ;-- zunchst bis zum Anfang der Zahl vorarbeiten -------------

gi1:      lodsb                   ;das nchste Zeichen laden
          cmp  al,'0'             ;auf Ziffer testen
          jb   gi2
          cmp  al,'9'
          jbe  gi5                ;Ziffer gefunden --> GI5
gi2:      cmp  al,' '             ;keine Ziffer, dann nur SPACE und
          je   gi1                ;TAB erlaubt
          cmp  al,9
          je   gi1

          ;-- Zahl Ziffer fr Ziffer einlesen und nach binr wandeln ---

gi4:      lodsb                   ;nchstes Zeichen lesen
          cmp  al,'0'             ;ist es eine Ziffer?
          jb   gi7                ;NEIN --> nchstes Zeichen verarbeiten
          cmp  al,'9'
          ja   gi7                ;NEIN --> nchstes Zeichen verarbeiten

          ;-- JA, es ist eine Ziffer -----------------------------------

gi5:      xchg ax,bx              ;Zeichen nach BX, Zahl nach AX holen
          mul  di                 ;AX mit 10 multiplizieren
          or   dx,dx              ;Produkt grer als 65536?
          jne  gierr              ;JA --> Zahl zu gro
          and  bl,0Fh             ;nur die unteren 4 Bits stehen lassen
          add  ax,bx              ;Ziffer hinzuaddieren
          xchg ax,bx              ;AX und BX wieder vertauschen
          jmp  gi4                ;das nchste Zeichen einlesen

gi6:      clc                     ;Zahl korrekt eingelesen
          mov  ax,bx              ;Zahl nach AX holen
          jmp  short giend        ;zurck zum Aufrufer

gi7:      dec  si                 ;ein Zeichen zu weit gelesen, aber
          jmp  gi6                ;Zahl ist o.k

gierr:    stc                     ;Fehler anzeigen

giend:    pop  di                 ;die vernderten Register zurck-
          pop  dx                 ;holen
          pop  bx
          ret                     ;zurck zum Aufrufer

getint    endp

;-- GETDAT: liest ein Datum in der Form "Tag.Monat.Jahr" aus der   -----
;--         Kommandozeile, wandelt es nach binr und legt es dann
;--         in der angegebenen Struktur ab
;-- Eingabe  : SI = Zeiger auf nchstes zu lesendes Zeichen im Kommando-
;--                 zeilenpuffer
;--            DI = Zeiger auf die Datumsstruktur, die das umgewandelte
;--                 Datum eingetragen werden soll
;-- Ausgabe  : Carry = 0: Zahl o.k., 1 = Fehler
;--            SI    = Zeiger hinter das letzte gelesene Zeichen
;-- Register : AX, CX, SI und FLAGS werden verndert

getdat    proc near

          call getint             ;Tag holen
          jc   gderr              ;Fehler? ---> Routine abbrechen

          or   ax,ax              ;Tag o.k., aber auch gltig?
          je   gderr              ;Null ist nicht erlaubt --> Fehler
          cmp  ax,31              ;31 ist das Maximum
          ja   gderr              ;drber ---> Fehler

          mov  [di].tag,al        ;Tag o.k., merken und weiter auswerten

          lodsb                   ;jetzt mu ein Punkt kommen
          cmp  al,DELIMITER
          jne  gderr              ;war aber nicht ---> Fehler

          ;-- Tag war o.k., jetzt Monat auswerten ----------------------

          call getint             ;Monat holen
          jc   gderr              ;Fehler? ---> Routine abbrechen

          or   ax,ax              ;Monat o.k., aber auch gltig?
          je   gderr              ;Null ist nicht erlaubt --> Fehler
          cmp  ax,12              ;12 ist das Maximum
          ja   gderr              ;drber ---> Fehler

          mov  [di].monat,al      ;Monat o.k

          lodsb                   ;jetzt mu wieder ein Punkt kommen
          cmp  al,DELIMITER
          jne  gderr              ;war aber nicht ---> Fehler

          ;-- Monat war o.k., jetzt Jahr auswerten ---------------------

          call getint             ;Jahr holen
          jc   gderr              ;Fehler? ---> Routine abbrechen

          cmp  ax,100             ;Angabe ohne Jahrhundert?
          ja   gd1                ;Nein, --> auswerten#

          add  ax,1900            ;Ja, Jahrhundert dazurechnen

gd1:      cmp  ax,1980            ;vor 1980 luft nichts
          jb   gderr              ;davor ---> Fehler

          mov  [di].jahr,ax       ;Jahr o.k, alles o.k.
          clc
          ret

gderr:    stc                     ;Datum konte nicht verarbeitet werden
          ret                     ;zurck zum Aufrufer

getdat    endp

;-- ENTPACKDAT: entpackt ein Datum, das im DOS-Format gespeichert ist --
;--             und trgt es in eine Struktur vom Typ DATUM ein
;-- Eingabe  : AX = das zu entpackende Datum im DOS-Format
;--            SI = Zeiger auf den Datumsblock, in den die Informationen
;--                 eingetragen werden sollen
;-- Ausgabe  : keine
;-- Register : AX, CX und FLAGS werden verndert

entpackdat proc near

          push bx                 ;BX auf dem Stack sichern

          mov  bl,al              ;Lo-Byte des Datum nach BX holen
          and  bl,31              ;die oberen 3 Bits ausblenden
          mov  [si].tag,bl        ;den Tag des Monats merken

          mov  bx,ax              ;das gesamte Datum nach BX holen
          mov  cl,5               ;um 5 Bits nach rechts schieben
          shr  bx,cl
          and  bl,15              ;die oberen 4 Bits ausblenden
          mov  [si].monat,bl      ;Monat merken

          shr  ah,1               ;Hi-Byte um eine Stelle nach rechts
          mov  al,ah              ;Jahr relativ zu 1980 in das Lo-Byte
          xor  ah,ah              ;Hi-Byte auf 0
          add  ax,1980            ;absolutes Jahr bilden
          mov  [si].jahr,ax       ;in der Struktur ablegen

          pop  bx                 ;BX wieder zurckholen
          ret                     ;zurck zum Aufrufer

entpackdat endp

;-- CMPDAT: vergleicht zwei Datumsangaben ------------------------------
;-- Eingabe  : SI = Zeiger auf ersten Datumsblock
;--            DI = Zeiger auf zweiten Datumsblock
;-- Ausgabe  : keine
;-- Register : AX und FLAGS werden verndert

cmpdat    proc near

          ;-- zunchst die Jahreszahlen vergleichen --------------------

          mov  ax,[si].jahr       ;Jahr 1 laden
          cmp  ax,[di].jahr       ;und mit Jahr 2 vergleichen
          jb   vorher             ;Datum 1 vor Datum 2 --> VORHER
          ja   danach             ;Datum 1 nach Datum 2 --> DANACH

          ;-- Jahreszahlen sind identisch, jetzt Monate vergleichen ----

          mov  al,[si].monat      ;Monat 1 laden
          cmp  al,[di].monat      ;und mit Monat 2 vergleichen
          jb   vorher             ;Datum 1 vor Datum 2 --> VORHER
          ja   danach             ;Datum 1 nach Datum 2 --> DANACH

          ;-- auch Monate sind gleich, deshalb als letzte Entscheidungs-
          ;-- kriterium den Tag im Monat vergleichen

          mov  al,[si].tag        ;Tag 1 laden
          cmp  al,[di].tag        ;und mit Tag 2 vergleichen
          jb   vorher             ;Datum 1 vor Datum 2 --> VORHER
          ja   danach             ;Datum 1 nach Datum 2 --> DANACH

          mov  al,DATCOMP_GL      ;die beiden Daten sind identisch
          ret                     ;zurck zum Aufrufer

vorher:   mov  al,DATCOMP_KL      ;Datum 1 vor Datum 2
          ret                     ;zurck zum Aufrufer

danach:   mov  al,DATCOMP_GR      ;Datum 1 nach Datum 2
          ret                     ;zurck zum Aufrufer

cmpdat    endp

;-- PRINTDAT: gibt ein Datum aus einer Datumsstruktur auf dem Bildschirm
;--           aus
;-- Eingabe  : SI = Zeiger auf Datumsstruktur
;-- Ausgabe  : keine
;-- Register : AX, DX, SI und FLAGS werden verndert

printdat  proc    near

          push si                 ;SI, BX und DX auf dem Stack sichern
          push bx
          push dx

          mov  bx,si              ;BX auf die Datumsstruktur setzen
          mov  si,offset datpend-8 ;SI auf Platz fr Jahr
          mov  ax,[bx].jahr       ;Jahr laden
          call toint              ;und nach ASCII wandeln
          mov  byte ptr [si-1],DELIMITER ;einen Punkt vor das Jahr

          sub  si,6               ;SI auf Platz fr Monat
          mov  al,[bx].monat      ;Monat nach AX laden
          xor  ah,ah
          call toint              ;und nach ASCII wandeln
          cmp  [bx].monat,10      ;eine Null voranstellen?
          jae  pd1                ;Nein, so bernehmen

          dec  si
          mov  byte ptr [si],"0"

pd1:      mov  byte ptr [si-1],DELIMITER ;einen Punkt vor den Monat
          sub  si,6               ;SI auf Platz fr Tag
          mov  al,[bx].tag        ;Tag nach AX laden
          xor  ah,ah
          call toint              ;und nach ASCII wandeln

          cmp  [bx].tag,10        ;Leerstelle vor der ersten Ziffer?
          jae  pd2                ;Ja, unverndert bernehmen

          dec  si                 ;Nein, SI auf die ersten Ziffer
          mov  byte ptr [si]," "  ;und Leerstelle setzen

pd2:      mov  dx,si              ;Anfang nach DX
          call printasciiz        ;ASCII-String ausgeben

pd3:      pop  dx                 ;DX, BX und SI zurck vom Stack
          pop  bx
          pop  si

          ret

printdat  endp

;-- ab hier werden die DTAs whrend der rekursiven Aufrufe festgehallten

startdta   equ this byte

;== Ende ===============================================================

code       ends                   ;Ende des CODE-Segments
           end  start

