;**********************************************************************;
;*                           G E T S C A N                            *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : gibt die Scan-Codes der Tastatur aus, bevor    *;
;*                     sie durch einen Tastatur-Treiber gefiltert     *;
;*                     und verndert werden knnen                    *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  8.12.1990                                     *;
;*    letztes Update :  2.01.1992                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM GETSCAN                                   *;
;*                     LINK GETSCAN                                   *;
;*                     EXE2BIN GETSCAN GETSCAN.COM                    *;
;*                                                                    *;
;*                     oder                                           *;
;*                                                                    *;
;*                     TASM GETSCAN                                   *;
;*                     TLINK /T GETSCAN                               *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : GETSCAN                                        *;
;**********************************************************************;

;== Konstanten und Strukturen ==========================================

INT_CTR   = 20h                   ;Port des Interrupt-Controllers
EOI       = 20h                   ;End-of-Interrupt-Kommando
KB_PORT   = 60h                   ;Tastatur-Port

;== hier beginnt das eigentliche Programm ==============================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          org 100h
                                                                        
          assume cs:code, ds:code, es:code, ss:code
                                                                        
start:    jmp  getscan            ;Sprung zum eigentlichen Prg.-Start
                                                                        
;== Daten ==============================================================

int9_ptr  equ this dword          ;alter Interrupt-Vektor 9h
int9_ofs  dw 0                    ;Offsetadresse des alten Handlers
int9_seg  dw 0                    ;Segmentadresse des alten Handlers

allscan   db 0                    ;auch Release-Codes ausgeben?

scanbuf   db 32 dup (0)           ;Puffer fr Scan-Codes
scanend   equ this byte

scannext  dw offset scanbuf       ;nchstes Zeichen im Scan-Puffer
scanlast  dw offset scanbuf       ;letztes Zeichen im Scan-Puffer

copyr     db   "GETSCAN - (c) 1990, 92 by MICHAEL TISCHER",13,10,13,10
          db   "Bettigen Sie eine beliebige Taste, um deren Scan-Code"
          db   " in Erfahrung zu",13,10
          db   "bringen oder RETURN, um das Programm zu beenden."
          db   13,10,13,10, "$"

hexdigits db   "0123456789ABCDEF" ;Ziffern zur Umwandlung einer Hex-Zahl

scanmes   db   "Scancode: "       ;Meldung fr Scan-Code
scandez   db   "000 ("
scanhex   db   "xx)", 13, 10, "$"

;== Programmcode =======================================================

getscan:  mov  ah,09h             ;Copyright-Meldung ausgeben
          mov  dx,offset copyr
          int  21h

          ;-- nach Parameter /R fr die Ausgabe aller Codes suchen -----

          cmp  word ptr ds:[130], "R" * 256 + "/"
          je   gsall
          cmp  word ptr ds:[130], "r" * 256 + "/"
          jne  gsnall

gsall:    mov  allscan,1         ;auch Release-Codes ausgeben

gsnall:   ;-- die neuen Tastatur-Interrupt-Handler installieren --------

          mov  ax,3509h           ;Inhalt des Interruptvektors 9h holen
          int  21h                ;DOS-Funktion aufrufen
          mov  int9_seg,es        ;Segment- und Offsetadresse des
          mov  int9_ofs,bx        ;Interruptvektors 9h merken

          mov  dx,offset neui9    ;Offsetadresse neue Interrupt-Routine
          mov  ax,2509h           ;Interruptvektor 9h auf
          int  21h                ;eigene Routine verbiegen

gs1:      ;-- Abfrageschleife ------------------------------------------

          mov  ah,01h             ;feststellen, ob eine Taste bereit-
          int  16h                ;steht
          je   gs2                ;NEIN --> GS2

          xor  ah,ah              ;JA, das Zeichen auslesen
          int  16h
          cmp  al,13              ;ist es Return?
          je   gs4                ;JA --> Programm beenden

gs2:      mov  di,scannext        ;Zeiger auf nchsten Scan-Code
          cmp  di,scanlast        ;Puffer leer?
          je   gs1                ;JA --> wieder zum Schleifenanfang

          ;== den Scancode nach ASCII wandeln und ausgeben =============

          mov  word ptr scandez,   32 shl 8 + 32
          mov  byte ptr scandez+2, 32

          mov  si,offset scandez+2;SI auf die letzte Ziffer im Puffer
          mov  al,[di]            ;den Scancode nach AL laden
          mov  bl,10              ;Divisor ist immer 10

gs3:      xor  ah,ah              ;HI-Byte des Dividen auf 0
          div  bl                 ;AX durch 10 teilen
          or   ah,'0'             ;AH in das ASCII-Format bringen
          mov  [si],ah            ;im Puffer ablegen
          dec  si                 ;nchstes Zeichen adressieren
          or   al,al              ;bleibt noch ein Rest?
          jne  gs3                ;JA --> nchste Ziffer

          ;-- den Code auch in Hex-Form ausgeben -----------------------

          mov  bx,offset hexdigits ;BX auf Tabelle mit Hex-Ziffern
          mov  al,[di]             ;Lo-Nibble des Scan-Code isolieren
          and  al,15
          xlat                     ;Hex-Ziffer aus Tabelle holen
          mov  ah,al               ;Lo-Ziffer ins Hi-Byte

          mov  al,[di]             ;Hi-Nibble des Scan-Code isolieren
          mov  cl,4
          shr  al,cl
          xlat                     ;Hex-Ziffer aus Tabelle holen

          mov  word ptr scanhex,ax ;die beiden Ziffern im Puffer abl.

          ;-- Zeiger in Scan-Puffer vorrcken

          inc  di
          cmp  di,offset scanend  ;berlauf?
          jne  gsnowrap           ;Nein ---> merken

          mov  di,offset scanbuf  ;Ja, wieder auf den Anfang

gsnowrap: mov  scannext,di        ;nchste Zeichenposition merken

          ;-- Meldung ausgeben -----------------------------------------

          mov  ah,09h             ;String ausgeben
          mov  dx,offset scanmes
          int  21h

          jmp  gs1                ;zum Schleifenanfang springen

gs4:      ;-- Programmbeendigung vorbereiten ---------------------------

          lds  dx,int9_ptr        ;wieder den alten Tastatur-Interrupt-
          mov  ax,2509h           ;Handler installieren
          int  21h

          mov  ax,4C00h           ;alles o.k., Programm beenden
          int  21h

;== Interrupt-Handler 09h (Tastatur) ===================================

neui9     proc far

          assume cs:code, ds:nothing, es:nothing, ss:nothing

          push ax                 ;AX auf dem Stack sichern
          in   al,KB_PORT         ;Scan-Code vom Tastatur-Port holen

          cmp  al,128             ;Release-Code?
          jb   i9merke            ;Nein ---> merken

          cmp  allscan,0          ;Ja, trotzdem merken?
          je   i9end              ;Nein ---> zurck

i9merke:  ;-- Scan-Code im Scan-Puffer ablegen -------------------------

          push di                 ;Di wird gebraucht, daher sichern
          mov  di,scanlast        ;DI auf nchste Puffer-Position
          mov  cs:[di],al         ;Scan-Code dort ablegen
          inc  di                 ;DI auf nchste Position
          cmp  di,offset scanend  ;berlauf?
          jne  i9nowrap           ;Nein ---> merken

          mov  di,offset scanbuf  ;Ja, wieder auf den Anfang

i9nowrap: mov  scanlast,di        ;nchste Zeichenposition merken
          pop  di                 ;DI wieder zurck

i9end:    pop  ax                 ;Scancode an alten Tastatur-Handler
          jmp  [int9_ptr]         ;bergeben

neui9     endp


;== Ende ===============================================================

code      ends                    ;Ende des CODE-Segments
          end  start

