;**********************************************************************;
;*                              P R U M                               *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : TSR-Programm, das den BIOS-Drucker-Interrupt   *;
;*                     17h auf einen neuen Handler umleitet, um da-   *;
;*                     durch z.B. die Umsetzung von IBM-ASCII nach    *;
;*                     EPSON beim Drucken zu ermglichen              *;
;*                     Beim jeweils zweiten Aufruf wird das Programm  *;
;*                     wieder deaktiviert und aus dem Speicher ent-   *;
;*                     fernt.                                         *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  2.08.1987                                     *;
;*    letztes Update :  1.12.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM PRUM;                                     *;
;*                     LINK PRUM;                                     *;
;*                     EXE2BIN PRUM PRUM.COM;   oder                  *;
;*                                                                    *;
;*                     TASM PRUM                                      *;
;*                     TLINK PRUM /T                                  *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : PRUM                                           *;
;**********************************************************************;
                                                                        
;== hier beginnt das eigentliche Programm ==============================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          org 100h
                                                                        
          assume cs:code, ds:code, es:code, ss:code
                                                                        
start:    jmp prumini             ;der erste ausgefhrte Befehl
                                                                        
;== Daten (bleiben im Speicher) =======================================
                                                                        
alterint  equ this dword          ;alter Interruptvektor 17h
intaltofs dw (?)                  ;Offsetadresse Interruptvektor 17h
intaltseg dw (?)                  ;Segmentadresse Interruptvektor 17h
                                                                        
          ;-- die folgende Tabelle enthlt jeweils den neuen -----------
          ;-- Code gefolgt vom alten Code ------------------------------
                                                                        
codetab   db   64, 21             ; Paragraph ----> Klammeraffe
          db  125,129             ; '' ----------> '}'
          db  123,132             ; '' ----------> '{'
          db   91,142             ; '' ----------> '['
          db  124,148             ; '' ----------> '|'
          db   92,153             ; '' ----------> '\'
          db   93,154             ; '' ----------> ']'
          db  126,225             ; '' ----------> '~'
          db  0                   ;Ende der Tabelle
                                                                        
;== dies ist der neue Drucker-Interrupt (bleibt im Speicher) ===========
                                                                        
neupri    proc far
                                                                        
          jmp  short neupri_1
                                                                        
	  db "PR"                 ;Identifikation des Programms
                                                                        
neupri_1: or   ah,ah              ;Zeichen drucken (Funktion 0)?
          jne  aint               ;NEIN --> alten Interrupt aufrufen
                                                                        
          pushf                   ;alle im nachfolgenden vernderten
          push bx                 ;Register mssen gesichert werden
          push si
          push ds
                                                                        
          push cs                 ;CS auf Stack merken
          pop  ds                 ;als DS vom Stack holen
                                                                        
          ;-- mu der Code umgesetzt werden? ---------------------------
                                                                        
          cld                     ;bei Stringbefehlen aufwrts zhlen
          mov  si,offset codetab  ;Adresse der Code-Tabelle
          mov  bl,al              ;Code in BL merken
testcode: lodsw                   ;alten (AH) und neuen Code (AL) laden
          or   al,al              ;Ende der Tabelle erreicht?
          je   notfound           ;JA --> Code nicht gefunden
          cmp  ah,bl              ;ist es der umzusetzende Code
          jne  testcode           ;NEIN --> Tabelle weiter durchsuchen
          jmp  short umsetzen     ;es war ein umzusetzender Code
                                                                        
notfound: mov  al,bl              ;alten Code wieder nach AL holen
umsetzen: xor  ah,ah              ;Funktionsnummer 0 wieder setzen
          pop  ds                 ;gesicherte Register zurckholen
          pop  si
          pop  bx
          popf
                                                                        
aint:     jmp  cs:[alterint]      ;zur alten Drucker-Routine
                                                                        
neupri    endp
                                                                        
instend   equ this byte           ;bis zu dieser Speicherstelle mu
                                  ;alles resident bleiben
                                                                        
;== Daten (knnen vom DOS berschrieben werden) ========================
                                                                        
installm  db 13,10,"PRUM (c) 1987 by Michael Tischer",13,10,13,10
          db "PRUM wurde installiert und kann durch erneuten",13,10
          db "Aufruf wieder deaktiviert werden",13,10,"$"
                                                                        
entfernt  db "PRUM wurde deaktiviert$",13,10
                                                                        
;== Programm (kann vom DOS berschrieben werden) =======================
;-- Start und Initialisierungs-Routine ---------------------------------
                                                                        
prumini   label near
                                                                        
          mov  ax,3517h           ;Inhalt Interruptvektor 17h holen
          int  21h                ;DOS-Funktion aufrufen
	  cmp  word ptr es:[bx+2],"RP" ;testen ob PRUM-Programm
	  jne  install            ;kein PRUM istalliert --> INSTALL
                                                                        
          ;-- PRUM wird deaktiviert ------------------------------------
                                                                        
          mov  dx,es:intaltofs    ;Offsetadresse des Interrupts 17h
          mov  ax,es:intaltseg    ;Segmentadresse des Interrupts 17h
          mov  ds,ax              ;nach DS
          mov  ax,2517h           ;Inhalt des Interruptvektors 17h auf
          int  21h                ;alte Routine zurcklegen
                                                                        
          mov  bx,es              ;Segmentadresse des Programms merken
          mov  es,es:[2Ch]        ;Segadr. des Environment aus PSP holen
          mov  ah,49h             ;den Speicher des alten Environment
          int  21h                ;wieder freigeben
                                                                        
          mov  es,bx              ;den Speicher des alten PRUM
          mov  ah,49h             ;ber die DOS-Funktoin 49h
          int  21h                ;wieder freigeben
                                                                        
          push cs                 ;CS auf Stack speichern
          pop  ds                 ;als DS zurckholen
                                                                        
          mov  dx,offset entfernt ;Meldung: Programm enfernt
          mov  ah,9               ;Funktionsnummer fr String schreiben
          int  21h                ;DOS-Funktion aufrufen
                                                                        
          mov  ax,4C00h           ;Programm korrekt beenden
          int  21h                ;Funktion zu Prg.beendigung aufrufen
                                                                        
          ;-- PRUM wird installiert ------------------------------------
                                                                        
install   label near
                                                                        
          mov  ax,3517h           ;Inhalt des Interruptvektors 17h holen
          int  21h                ;DOS-Funktion aufrufen
          mov  intaltseg,es       ;Segment- und Offsetadresse des Inter-
          mov  intaltofs,bx       ;ruptvektors 17h merken
                                                                        
          mov  dx,offset neupri   ;Offsetadresse neue Interrupt-Routine
          mov  ax,2517h           ;Inhalt des Interruptvektors 17 auf
          int  21h                ;eigene Routine verbiegen
                                                                        
          mov  dx,offset installm ;Meldung: Programm installiert
          mov  ah,9               ;Funktionsnummer fr String ausgeben
          int  21h                ;DOS-Funktion aufrufen
                                                                        
          ;-- nur der PSP, die neue Interrupt-Routine und die ----------
          ;-- dazugehrigen Daten mssen resident bleiben.    ----------
                                                                        
          mov  dx,offset instend  ;Anzahl der Paragraphen (je 16 Byte)
          mov  cl,4               ;ber die das Programm verfgen soll
          shr  dx,cl              ;berechnen
          inc  dx
          mov  ax,3100h           ;Programm mit Ende-Code 0 (o.k) been-
          int  21h                ;den aber resident bleiben
                                                                        
;== Ende ===============================================================
                                                                        
code      ends                    ;Ende des CODE-Segments
          end  start
                                                                        
                                                                        
