;**********************************************************************;
;*                            V M O N O                               *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : stellt einige elementare Funktionen zum Zu-    *;
;*                     griff auf den monochromen Bildschirm zu        *;
;*                     Verfgung                                      *;
;*--------------------------------------------------------------------*;
;*    Info           : alle Funktionen unterteilen den Bildschirm     *;
;*                     in die Spalten 0 bis 79 und Zeilen 0 bis 24    *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  : 11.08.1987                                     *;
;*    letztes Update :  1.10.1988                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM VMONO;                                    *;
;*                     LINK VMONO;                                    *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : VMONO                                          *;
;**********************************************************************;
                                                                        
;== Konstanten =========================================================
                                                                        
STEUER_REG  = 03B8h               ;Portadr. des Steuerregisters
ADRESS_6845 = 03B4h               ;Adresseregister des 6845
DATA_6845   = 03B5h               ;Datenregister des 6845
VIO_SEG     = 0B000h              ;Segmentadresse des Video-RAM
CUR_START   = 10                  ;Registernr. CRTC: Startzeile Cursor
CUR_END     = 11                  ;Registernr. CRTC: Endzeile Cursor
CURPOS_HI   = 14                  ;Registernr. CRTC: Cursorpos. Hi-Byte
CURPOS_LO   = 15                  ;Registernr. CRTC: Cursorpos. Lo-Byte
                                                                        
DELAY       = 20000               ;Schleifenzhler fr Warteschleife
                                                                        
;== Stack ==============================================================
                                                                        
stack     segment para stack      ;Definition des Stack-Segments
                                                                        
          dw 256 dup (?)          ;der Stack ist 256 Words gro
                                                                        
stack     ends                    ;Ende des Stack-Segments
                                                                        
;== Daten ==============================================================
                                                                        
data      segment para 'DATA'     ;Definition des Daten-Segments
                                                                        
;== die Daten fr das Demo-Programm ====================================
                                                                        
str1      db "a" ,0
str2      db " >>> PC INTERN <<< ",0
str3      db "   Fenster 1   ",0
str4      db "   Fenster 2   ",0
str5      db "          das Programm wird durch Bettigung einer Taste "
          db "gestoppt....          ",0
                                                                        
initm   db 13,10
        db " VMONO (c) 1987,1988 by Michael Tischer "
        db 13,10,13,10
        db "Dieses Demonstrationsprogramm luft nur in Verbindung",13,10
        db "mit einer monochromen Bildschirmkarte (MDA). Wenn Ihr",13,10
        db "PC ber eine andere Art von Bildschirmkarte  verfgt,",13,10
        db "dann  geben Sie jetzt  bitte <S> ein, um das Programm",13,10
        db "zu stoppen.",13,10
        db "Ansonsten  bettigen Sie bitte eine beliebige  andere",13,10
        db "Taste, um das Programm zu starten ...",13,10,"$"
                                                                        
;== Tabelle mit den Offsetadressen der Zeilenanfnge ===================
                                                                        
zeilen    dw  0*160, 1*160, 2*160, 3*160, 4*160, 5*160, 6*160
          dw  7*160, 8*160, 9*160,10*160,11*160,12*160,13*160
          dw 14*160,15*160,16*160,17*160,18*160,19*160,20*160
          dw 21*160,22*160,23*160,24*160
                                                                        
data      ends                    ;Ende des Daten-Segments
                                                                        
;== Code ===============================================================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          assume cs:code, ds:data, es:data, ss:stack
                                                                        
;== dies ist nur das Demo-Programm =====================================
                                                                        
demo      proc far
                                                                        
          mov  ax,data            ;Segmentadr. des Datensegments holen
          mov  ds,ax              ;und nach DS laden
          mov  es,ax              ;ebenfalls nach ES
                                                                        
          ;-- Init-Meldung ausgeben und auf Einabe warten --------------
                                                                        
          mov  ah,9               ;Funktionsnummer fr String ausgeben
          mov  dx,offset initm    ;Adresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          xor  ah,ah              ;Funktionsnummer fr Taste holen
          int  16h                ;BIOS-Tastatur-Interrupt aufrufen
          cmp  al,"s"             ;wurde <s> eingegeben?
          je   ende               ;JA --> Programm wieder beenden
          cmp  al,"S"             ;wurde <S> eingeben
          jne  startdemo          ;NEIN --> Demo starten
                                                                        
ende:     mov  ax,4C00h           ;Funktionsnr. fr Programm beenden
          int  21h                ;DOS-Interrupt 21(h) aufrufen
                                                                        
          ;-- Demo-Programm, demonstriert Aufruf der Funktionen --------
                                                                        
startdemo label near
          mov  cx,0d00h           ;Voll-Cursor anschalten
          call cdef
          call cls                ;Bildschirm lschen
                                                                        
          ;-- Bildschirm mit den Zeichen des ASCII-Zeichens. fllen ----
                                                                        
          xor  di,di              ;in der o.l. Bildschirmecke beginnen
          mov  si,offset str1     ;Offsetadresse des String1
          mov  cx,2000            ;2000 Zeichen passen auf den Bilds.
          mov  al,07h             ;weie Schrift auf schwarzem Grund
demo1:    call print              ;String ausgeben
          inc  str1               ;Ascii-Zeichen im Test-String inkr.
          jne  demo2              ;NUL-Code mu verhindert werden
          inc  str1
demo2:    loop demo1              ;Ausgabe wiederholen
                                                                        
          ;-- Fenster 1 und Fenster 2 aufbauen -------------------------
                                                                        
          mov  bx,0508h           ;obere linke Ecke Fenster 1
          mov  dx,1316h           ;untere rechte Ecke Fenster 1
          mov  ah,07h             ;weie Schrift auf schwarzem Grund
          call clear              ;Fenster 1 lschen
          mov  bx,3C02h           ;obere linke Ecke Fenster 2
          mov  dx,4A10h           ;untere rechte Ecke Fenster 2
          call clear              ;Fenster 2 lschen
          mov  bx,0508h           ;obere linke Ecke Fenster 1
          call calo               ;in Offsetadresse umrechnen
          mov  si,offset str3     ;Offsetadresse String 3
          mov  ah,70h             ;schwarze Schrift auf weiem Grund
          call print              ;String 3 ausgeben
          mov  bx,3C02h           ;obere linke Ecke Fenster 2
          call calo               ;in Offsetadresse umrechnen
          mov  si,offset str4     ;Offsetadresse String 4
          call print              ;String 4 ausgeben
          xor  di,di              ;obere linke Bildschirmecke
          mov  si,offset str5     ;Offsetadresse String 5
          call print              ;String 5 ausgeben
                                                                        
          ;-- Programmlogo ausgeben ------------------------------------
                                                                        
          mov  bx,1E0Ch           ;Spalte 30, Zeile 12
          call calo               ;in Offsetadresse umrechnen
          mov  si,offset str2     ;Offsetadresse String 2
          mov  ah,0F0h            ;invers blinken
          call print              ;String 2 ausgeben
                                                                        
          ;-- die Fenster mit Pfeilen fllen ---------------------------
                                                                        
          xor  ch,ch              ;Hi-Byte des Counter auf 0
pfeil:    mov  bl,1               ;ein Sternchen
pfeil0:   push bx                 ;BX auf dem Stack merken
          mov  di,offset str3     ;Pfeil-Zeile in String 3 schreiben
          mov  cl,15              ;insgesamt 15 Zeichen in einer Zeile
          sub  cl,bl              ;Anzahl Leerzeichen berechnen
          shr  cl,1               ;durch 2 teilen (fr linke Hlfte)
          or   cl,cl              ;kein Leerzeichen?
          je   pfeil1             ;JA --> PFEIL1
          mov  al," "
          rep  stosb              ;Leerzeichen in String 3 schreiben
pfeil1:   mov  cl,bl              ;Anzahl der Sterne in den Counter
          mov  al,"*"
          rep  stosb              ;Sternchen in String 3 schreiben
          mov  cl,15              ;insgesamt 15 Zeichen in einer Zeile
          sub  cl,bl              ;Anzahl Leerzeichen berechnen
          shr  cl,1               ;durch 2 teilen (fr rechte Hlfte)
          or   cl,cl              ;kein Leerzeichen?
          je   pfeil2             ;JA --> PFEIL2
          mov  al," "
          rep  stosb              ;Leerzeichen in String 3 schreiben
pfeil2:   mov  bx,0509h           ;unter der ersten Zeile des Fenster 1
          call calo               ;in Offsetadresse umrechnen
          mov  si,offset str3     ;Offsetadresse String 3
          mov  ah,07h             ;weie Schrift auf schwarzem Grund
          call print              ;String 3 ausgeben
          mov  bx,3C10h           ;in die unterste Zeile von Fenster 2
          call calo               ;in Offsetadresse umrechnen
          call print              ;String 3 ausgeben
                                                                        
          ;-- kurze Pause einlegen -------------------------------------
                                                                        
          mov  cx,DELAY           ;Schleifenzhler laden
warten:   loop warten             ;Schleifenzhler auf 0 zhlen
                                                                        
          ;-- Fenster 1 eine Zeile nach unten scrollen -----------------
                                                                        
          mov  bx,0509h           ;obere linke Ecke Fenster 1
          mov  dx,1316h           ;untere rechte Ecke Fenster 1
          mov  cl,1               ;eine Zeile
          call scrolldn           ;runterscrollen
                                                                        
          ;-- Fenster 2 eine Zeile nach oben scrollen ------------------
                                                                        
          mov  bx,3C03h           ;obere linke Ecke Fenster 2
          mov  dx,4A10h           ;untere rechte Ecke Fenster 2
          call scrollup           ;raufscrollen
                                                                        
          ;-- wurde Taste bettigt? (Programm beenden) -----------------
                                                                        
          mov  ah,1               ;Funktionsnr. fr teste Taste
          int  16h                ;BIOS-Tastatur-Interrupt aufrufen
          jne  end_it             ;Taste bettigt --> Prg.ende vorb.
                                                                        
          ;-- NEIN, nchste Pfeil-Zeile ausgeben -----------------------
                                                                        
          pop  bx                 ;BX wieder vom Stack holen
          add  bl,2               ;2 Sternchen mehr in nchster Zeile
          cmp  bl,17              ;17 erreicht?
          jne  pfeil0             ;NEIN --> nchster Pfeil
          jmp  pfeil              ;JA --> neue Zeile
                                                                        
          ;-- Programmbeendigung vorbereiten ---------------------------
                                                                        
end_it:   xor  ah,ah              ;Funktionsnummer fr Taste holen
          int  16h                ;BIOS-Tastatur-Interrupt aufrufen
                                                                        
          mov  cx,0D0Ch           ;normalen Cursor wiederherstellen
          call cdef
          call cls                ;Bildschirm lschen
          jmp  ende               ;zum Programmende springen
                                                                        
demo      endp
                                                                        
;== jetzt folgen die eigentlichen Funktionen ===========================
                                                                        
;-- BAUS: schaltet die Bildschirmdarstellung aus -----------------------
;-- Eingabe  : keine
;-- Ausgabe  : keine
;-- Register : AX und DX werden verndert
                                                                        
baus      proc near
                                                                        
          mov  dx,STEUER_REG      ;Adresse des Bildschirmsteuerregisters
          in   al,dx              ;dessen Inhalt einlesen
          and  al,11110111b       ;Bit 3 = 0: Bildschirm aus
          out  dx,al              ;neuen Wert setzen (Bildschirm aus)
          ret                     ;zurck zum Aufrufer
                                                                        
baus      endp
                                                                        
;-- BAN: schaltet die Bildschirmdarstellung an -------------------------
;-- Eingabe  : keine
;-- Ausgabe  : keine
;-- Register : AX und DX werden verndert
                                                                        
ban       proc near
                                                                        
          mov  dx,STEUER_REG      ;Adresse des Bildschirmsteuerregisters
          in   al,dx              ;dessen Inhalt einlesen
          or   al,8               ;Bit 3 = 1: Bildschirm an
          out  dx,al              ;neuen Wert setzen (Bildschirm an)
          ret                     ;zurck zum Aufrufer
                                                                        
ban       endp
                                                                        
;-- CDEF: setzt die Start- und Endzeile des Cursor ---------------------
;-- Eingabe  : CL = Startzeile
;--            CH = Endzeile
;-- Ausgabe  : keine
;-- Register : AX und DX werden verndert
                                                                        
cdef      proc near
                                                                        
          mov  al,CUR_START       ;Register: Startzeile
          mov  ah,cl              ;Startzeile nach AH
          call setvk              ;an Video-Controller bermitteln
          mov  al,CUR_END         ;Register: Endzeile
          mov  ah,ch              ;Endzeile nach AH
          jmp  short setvk        ;an Video-Controller bermitteln
                                                                        
cdef      endp
                                                                        
;-- SETBLINK: setzt den blinkenden Bildschirmcurosr --------------------
;-- Eingabe  : DI = Offsetadresse des Cursor (in Zeicheneinheiten)
;-- Ausgabe  : keine
;-- Register : BX, AX und DX werden verndert
                                                                        
setblink  proc near
                                                                        
          mov  bx,di              ;Offset nach BX bertragen
          mov  al,CURPOS_HI       ;Register: Hi-Byte des Cursoroffset
          mov  ah,bh              ;HI-Byte des Offset
          call setvk              ;an Video-Controller bermitteln
          mov  al,CURPOS_LO       ;Register: Lo-Byte des Cursoroffset
          mov  ah,bl              ;Lo-Byte des Offset
                                                                        
          ;-- gergang in SETVK erfolgt automatisch --------------------
                                                                        
setblink  endp
                                                                        
;-- SETVK: setzt ein Byte in einem der Register des Video-Controllers --
;-- Eingabe  : AL = Nummer des Registers
;--            AH = neuer Inhalt des Registers
;-- Ausgabe  : keine
;-- Register : DX und AL werden verndert
                                                                        
setvk     proc near
                                                                        
          mov  dx,ADRESS_6845     ;Adresse des Indexregisters
          out  dx,al              ;Nummer des Registers senden
          jmp  short $+2          ;kleine I/O Pause
          inc  dx                 ;Adresse des Indexregisters
          mov  al,ah              ;Inhalt nach AL
          out  dx,al              ;neuen Inhalt setzen
          ret                     ;zurck zum Aufrufer
                                                                        
setvk     endp
                                                                        
;-- GETVK: liest ein Byte aus einem der Register des Video-Controllers -
;-- Eingabe  : AL = Nummer des Registers
;-- Ausgabe  : AL = Inhalt des Registers
;-- Register : DX und AL werden verndert
                                                                        
getvk     proc near
                                                                        
          mov  dx,ADRESS_6845     ;Adresse des Indexregisters
          out  dx,al              ;Nummer des Registers senden
          jmp  short $+2          ;kleine I/O Pause
          inc  dx                 ;Adresse des Indexregisters
          in   al,dx              ;Inhalt nach AL lesen
          ret                     ;zurck zum Aufrufer
                                                                        
getvk     endp
                                                                        
;-- SCROLLUP: scrollt ein Fenster um N Zeilen nach oben ----------------
;-- Eingabe  : BL = Zeile oben links
;--            BH = Spalte oben links
;--            DL = Zeile unten rechts
;--            DH = Spalte unten rechts
;--            CL = Anzahl der Zeilen um die gescrollt wird
;-- Ausgabe  : keine
;-- Register : nur FLAGS werden verndert
;-- Info     : die frei werdenden Bildschirmzeilen werden gelscht
                                                                        
scrollup  proc near
                                                                        
          cld                     ;bei Stringbefehlen aufwrts zhlen
                                                                        
          push ax                 ;alle vernderten Register auf dem
          push bx                 ;Stack sichern
          push di                 ;in diesem Fall mu die Reihenfolge
          push si                 ;beachtet werden!
                                                                        
          push bx                 ;diese drei Register werden schor vor
          push cx                 ;dem Ende der Routine wieder vom Stack
          push dx                 ;zurckgeholt
          sub  dl,bl              ;Anzahl Zeilen berechnen
          inc  dl
          sub  dl,cl              ;Anzahl der zu scr. Zeilen abziehen
          sub  dh,bh              ;Anzahl Spalten berechnen
          inc  dh
          call calo               ;oben links in Offset umrechnen
          mov  si,di              ;Adresse in SI merken
          add  bl,cl              ;erste Zeile im gescrollten Fenster
          call calo               ;erste Zeile in Offset umrechnen
          xchg si,di              ;SI und DI vertauschen
          push ds                 ;Segmentregister auf dem Stack
          push es                 ;sichern
          mov  ax,VIO_SEG         ;Segmentadresse des Video-RAM
          mov  ds,ax              ;nach DS
          mov  es,ax              ;und ES bringen
sup1:     mov  ax,di              ;DI in AX merken
          mov  bx,si              ;SI in BX merken
          mov  cl,dh              ;Anzahl Spalten in Counter
          rep movsw               ;eine Zeile verschieben
          mov  di,ax              ;DI aus AX zurckholen
          mov  si,bx              ;SI aus BX zurckholen
          add  di,160             ;jeweils in nchste Zeile setzen
          add  si,160
          dec  dl                 ;alle Zeilen verarbeitet?
          jne  sup1               ;NEIN --> noch eine Zeile verschieben
          pop  es                 ;Segmentregister wieder vom Stack
          pop  ds                 ;holen
          pop  dx                 ;untere rechte Ecke zurckholen
          pop  cx                 ;Anzahl Zeilen zurckholen
          pop  bx                 ;obere linke Ecke zurckholen
          mov  bl,dl              ;untere Zeile nach BL
          sub  bl,cl              ;Anzahl Zeilen abziehen
          inc  bl
          mov  ah,07h             ;Farbe : schwarz auf wei
          call clear              ;frei gewordenen Zeilen lschen
                                                                        
          pop  si                 ;CX und DX sind bereits wieder her-
          pop  di                 ;untergeholt worden
          pop  bx
          pop  ax
                                                                        
          ret                     ;zurck zum Aufrufer
                                                                        
scrollup  endp
                                                                        
;-- SCROLLDN: scrollt ein Fenster um N Zeilen nach unten ---------------
;-- Eingabe  : BL = Zeile oben links
;--            BH = Spalte oben links
;--            DL = Zeile unten rechts
;--            DH = Spalte unten rechts
;--            CL = Anzahl der Zeilen um die gescrollt wird
;-- Ausgabe  : keine
;-- Register : nur FLAGS werden verndert
;-- Info     : die frei werdenden Bildschirmzeilen werden gelscht
                                                                        
scrolldn  proc near
                                                                        
          cld                     ;bei Stringbefehlen aufwrts zhlen
                                                                        
          push ax                 ;alle vernderten Register auf dem
          push bx                 ;Stack sichern
          push di                 ;in diesem Fall mu die Reihenfolge
          push si                 ;beachtet werden!
                                                                        
          push bx                 ;diese drei Register werden schon vor
          push cx                 ;dem Ende der Routine wieder vom Stack
          push dx                 ;zurckgeholt
                                                                        
          sub  dh,bh              ;Anzahl Spalten berechnen
          inc  dh
          mov  al,bl              ;Zeile oben links in AL merken
          mov  bl,dl              ;Zeile u.r. nach Zeile u.l.
          call calo               ;oben links in Offset umrechnen
          mov  si,di              ;Adresse in SI merken
          sub  bl,cl              ;Anzahl zu scrollende Z. abziehen
          call calo               ;oben links in Offset umrechnen
          xchg si,di              ;SI und DI vertauschen
          sub  dl,al              ;Anzahl Zeilen berechnen
          inc  dl
          sub  dl,cl              ;Anzahl der zu scr. Zeilen abziehen
          push ds                 ;Segmentregister auf dem Stack
          push es                 ;sichern
          mov  ax,VIO_SEG         ;Segmentadresse des Video-RAM
          mov  ds,ax              ;nach DS
          mov  es,ax              ;und ES bringen
sdn1:     mov  ax,di              ;DI in AX merken
          mov  bx,si              ;SI in BX merken
          mov  cl,dh              ;Anzahl Spalten in Counter
          rep movsw               ;eine Zeile verschieben
          mov  di,ax              ;DI aus AX zurckholen
          mov  si,bx              ;SI aus BX zurckholen
          sub  di,160             ;jeweils in nchste Zeile setzen
          sub  si,160
          dec  dl                 ;alle Zeilen verarbeitet?
          jne  sdn1               ;NEIN --> noch eine Zeile verschieben
          pop  es                 ;Segmentregister wieder vom Stack
          pop  ds                 ;holen
          pop  dx                 ;untere rechte Ecke zurckholen
          pop  cx                 ;Anzahl Zeilen zurckholen
          pop  bx                 ;obere linke Ecke zurckholen
          mov  dl,bl              ;obere Zeile nach DL
          add  dl,cl              ;Anzahl Zeilen addeiren
          dec  dl
          mov  ah,07h             ;Farbe : schwarz auf wei
          call clear              ;frei gewordenen Zeilen lschen
                                                                        
          pop  si                 ;CX und DX sind bereits wieder her-
          pop  di                 ;untergeholt worden
          pop  bx
          pop  ax
                                                                        
          ret                     ;zurck zum Aufrufer
                                                                        
scrolldn  endp
                                                                        
;-- CLS: den gesamten Bildschirm lschen -------------------------------
;-- Eingabe  : keine
;-- Ausgabe  : keine
;-- Register : nur FLAGS werden verndert
                                                                        
cls       proc near
                                                                        
          mov  ah,07h             ;Farbe ist wei auf schwarz
          xor  bx,bx              ;oben links ist (0/0)
          mov  dx,4F18h           ;unten rechts ist (79/24)
                                                                        
          ;-- bergang in Clear erfolgt automatisch --------------------
                                                                        
cls       endp
                                                                        
;-- CLEAR: fllt einen bestimmten Bildschirmbereich mit Leerzeichen ----
;-- Eingabe  : AH = Attribut/Farbe
;--            BL = Zeile oben links
;--            BH = Spalte oben links
;--            DL = Zeile unten rechts
;--            DH = Spalte unten rechts
;-- Ausgabe  : keine
;-- Register : nur FLAGS werden verndert
                                                                        
clear     proc near
                                                                        
          cld                     ;bei Stringbefehlen aufwrts zhlen
          push cx                 ;alle, im nachfolgenden vernderten,
          push dx                 ;Register auf dem Stack sichern
          push si
          push di
          push es
          sub  dl,bl              ;Anzahl Zeilen berechnen
          inc  dl
          sub  dh,bh              ;Anzahl Spalten berechnen
          inc  dh
          call calo               ;Offsetadresse der oberen linken Ecke
          mov  cx,VIO_SEG         ;Segmentadresse des Video-RAM
          mov  es,cx              ;nach ES
          xor  ch,ch              ;Hi-Bytes des Counter auf 0
          mov  al," "             ;Leerzeichen
clear1:   mov  si,di              ;DI in SI merken
          mov  cl,dh              ;Anzahl Spalten in Counter
          rep stosw               ;Leerzeichen speichern
          mov  di,si              ;DI aus SI zurckholen
          add  di,160             ;in nchste Zeile setzen
          dec  dl                 ;alle Zeilen verarbeitet?
          jne  clear1             ;NEIN --> noch eine Zeile lschen
                                                                        
          pop  es                 ;die gesicherten Register wieder
          pop  di                 ;vom Stack holen
          pop  si
          pop  dx
          pop  cx
          ret                     ;zurck zum Aufrufer
                                                                        
clear     endp
                                                                        
;-- PRINT: gibt einen String auf dem Bildschirm aus --------------------
;-- Eingabe  : AH = Attribut/Farbe
;--            DI = Offsetadresse des ersten Zeichen
;--            SI = Offsetadresse des Strings zu DS
;-- Ausgabe  : DI zeigt hinter das letzte ausgegebene Zeichen
;-- Register : AL, DI und FLAGS werden verndert
;-- Info     : der String mu durch das NUL-Zeichen beendet werden.
;--            andere Steuerzeichen werden nicht erkannt
                                                                        
print     proc near
                                                                        
          cld                     ;bei Stringbefehlen aufwrts zhlen
          push si                 ;SI, DX und ES auf dem Stack sichern
          push es
          push dx
          mov  dx,VIO_SEG         ;Segmentadresse des Video-RAM erst
          mov  es,dx              ;nach DX und dann nach ES
          jmp  print1             ;erstes Zeichen aus dem String holen
                                                                        
print0:   stosw                   ;Attribut und Farbe in V-RAM speichern
print1:   lodsb                   ;nchstes Zeichen aus dem String holen
          or   al,al              ;ist es NUL
          jne  print0             ;NEIN --> ausgeben
                                                                        
printe:   pop  dx                 ;SI, DX und ES wieder vom Stack holen
          pop  es
          pop  si
          ret                     ;zurck zum Aufrufer
                                                                        
print     endp
                                                                        
;-- CALO: rechnet Zeile und Spalte in Offsetadresse um -----------------
;-- Eingabe  : BL = Zeile
;--            BH = Spalte
;-- Ausgabe  : DI = die Offsetadresse
;-- Register : DI und FLAGS werden verndert
                                                                        
calo      proc near
                                                                        
          push ax                 ;AX auf dem Stack sichern
          push bx                 ;BX auf dem Stack sichern
                                                                        
          shl  bx,1               ;Spalte und Zeile mal 2
          mov  al,bh              ;Spalte nach AL
          xor  bh,bh              ;Hi-Byte
          mov  di,[zeilen+bx]     ;Offsetadresse der Zeile holen
          xor  ah,ah              ;HI-Byte fr Spaltenoffset
          add  di,ax              ;Zeilen- und Spaltenoffset addieren
                                                                        
          pop  bx                 ;BX wieder vom Stack holen
          pop  ax                 ;AX wieder vom Stack holen
          ret                     ;zurck zum Aufrufer
                                                                        
calo      endp
                                                                        
                                                                        
;== Ende ===============================================================
                                                                        
code      ends                    ;Ende des CODE-Segments
          end  demo               ;Programmausfhrung mit DEMO beginnen
