'*****************************************************************************
'*                                 D I R B                                   *
'-----------------------------------------------------------------------------
'*  Aufgabe       : Zeigt alle Dateien in einem beliebigen Verzeichnis       *
'*                  inklusive Unterverzeichnissen und Volume-Namen auf       *
'*                  dem Bildschirm an                                        *
'-----------------------------------------------------------------------------
'*  Autor         : Michael Tischer                                          *
'*  entwickelt am :  8.07.1987                                               *
'*  letztes Update: 15.10.1991                                               *
'*****************************************************************************
DECLARE FUNCTION MakeWord& (Zahl AS INTEGER)
DECLARE FUNCTION Dat$ (Wert AS INTEGER)
DECLARE SUB SetDTA (Segment AS LONG, Offset AS LONG)
DECLARE SUB BildschirmAufbau ()
DECLARE FUNCTION Monat$ (Mon AS INTEGER)
DECLARE FUNCTION FindNext% ()
DECLARE FUNCTION FindFirst% (Dateiname AS STRING, Attr AS INTEGER)
DECLARE SUB PrintData (DirBuf AS ANY)
DECLARE SUB Dir (Pfad AS STRING, Attr AS INTEGER)

'$INCLUDE: 'QB.BI'                          'Includedatei fr Interruptaufrufe

'-- Struktur des Directory-Eintrags, wie in die DOS-Funktionen &H4E und ------
'-- &H4F zurckliefern

TYPE DirStruct
   Reserviert AS STRING * 21
   Attrib AS STRING * 1
   Time AS INTEGER
   Date AS INTEGER
   Size AS LONG
   DatName AS STRING * 13
END TYPE

'-- Konstanten ----

CONST TRUE = -1                                    'Wahrheitswerte deklarieren
CONST FALSE = NOT TRUE

CONST FCARRY = 1                                                   'Carry-Flag
CONST EINTR = 14                   'Soviel Eintrge sind gleichzeitig sichtbar
CONST BILDTOP = (20 - EINTR) \ 2            'Oberste Zeile des Ausgabefensters

CONST FAReadOnly = &H1                               ' Dateiattribute
CONST FAHidden = &H2
CONST FASysFile = &H4
CONST FAVolumeID = &H8
CONST FADirectory = &H10
CONST FAArchive = &H20
CONST FAAnyFile = &H3F

'-- Hauptprogramm -----

IF COMMAND$ = "" THEN 'kein Dateiname angegeben?
  CALL Dir("*.*", FAAnyFile)                                        'Nein, alle Dateien im aktuellen Verzeichnis anzeigen
ELSE
  CALL Dir(COMMAND$, FAAnyFile)                                        'Doch, angegebene Dateien anzeigen
END IF

'*****************************************************************************
'* BildschirmAufbau : Bereitet den Bildscirm fr die Ausgabe eines           *
'*                    Directorys vor                                         *
'* Eingabe          : Keine                                                  *
'* Ausgabe          : Keine                                                  *
'*****************************************************************************
SUB BildschirmAufbau
CONST LR = "              "  'Schiebt den linken Rand in die richtige Position
DIM Zaehler AS INTEGER                                        'Schleifenzhler

CLS                                                        'Bildschirm lschen
VIEW PRINT (BILDTOP + 1) TO (BILDTOP + 5 + EINTR)
PRINT LR + "ͻ"
PRINT LR + "  Dateiname     Gre      Datum       Zeit    RHSVD"
PRINT LR + "Ķ"
FOR Zaehler = 1 TO EINTR
  PRINT LR + "                                                    "
NEXT
PRINT LR + "ͼ"
VIEW PRINT (BILDTOP + 4) TO (BILDTOP + 3 + EINTR)
END SUB

'*****************************************************************************
'* Dat$    : Wandelt einen Wert in eine Zeichenkette um, die dem             *
'*           Format fr Datums- bzw. Zeitausgaben entspricht                 *
'* Eingabe : Der umzuwandelnde Wert                                          *
'* Ausgabe : Die dem Wert entsprechende Zeichenkette                         *
'* Info    : STR$ oder RPINT USING liefern keine fhrenden Nullen            *
'*****************************************************************************
FUNCTION Dat$ (Wert AS INTEGER)

DIM Speicher AS STRING                                 'Speichert Zwischenwert

Speicher = LTRIM$(STR$(Wert))
WHILE LEN(Speicher) < 2                    'Speicher hat weniger als 2 Ziffern
  Speicher = "0" + Speicher
WEND
Dat$ = Speicher
END FUNCTION

'*****************************************************************************
'* Dir     : Kontrolliert das Einlesen und die Ausgabe des Directorys        *
'* Eingabe : Keine                                                           *
'* Ausgabe : Keine                                                           *
'*****************************************************************************
SUB Dir (Pfad AS STRING, Attr AS INTEGER)

DIM AnzEintraege AS INTEGER             'Gesammtanzahl der gefundenen Eintrge
DIM AnzBild AS INTEGER                            'Anzahl der Eintrge im Bild
DIM DirBuf AS DirStruct 'nimmt Dateiinformationen auf

CALL SetDTA(VARSEG(DirBuf), VARPTR(DirBuf))               'DirBuf ist neue DTA
CLS                                                        'Bildschirm lschen
CALL BildschirmAufbau               'Bildschirm fr Directory-Ausgabe aufbauen

AnzBild = -1                           'Noch kein Eintrag im Fenster angezeigt
AnzEintraege = 0                                 'Noch keinen Eintrag gefunden
IF FindFirst(Pfad, Attr) THEN           'Ersten Eintrag suchen (Attribut egal)
  DO                                                   'Alle Eintrge anzeigen
    AnzEintraege = AnzEintraege + 1                 'Ein Eintrag mehr gefunden
    AnzBild = AnzBild + 1                          'Ein Eintrag mehr angezeigt
    IF AnzBild = EINTR THEN                                    'Fenster voll ?
      '-- Ja, auf Tastendruck warten, dann neue Tabellenseite anzeigen
      VIEW PRINT (BILDTOP + 5 + EINTR) TO (BILDTOP + 6 + EINTR)
      PRINT "                 Bitte Taste drcken "
      SLEEP                                            'Auf Tastendruck warten
      VIEW PRINT (BILDTOP + 4) TO (BILDTOP + 3 + EINTR)
      AnzBild = 0                           'Im Fenster neue Eintrge anzeigen
    END IF
    CALL PrintData(DirBuf)                                 'Daten des Eintrags ausgeben
  LOOP UNTIL NOT FindNext                          'Gibt es noch einen Eintrag
END IF
VIEW PRINT (BILDTOP + 5 + EINTR) TO (BILDTOP + 6 + EINTR)
CLS
SELECT CASE AnzEintraege
  CASE 0
    PRINT "Keine Datei gefunden"
  CASE 1
    PRINT " Eine Datei gefunden"
  CASE ELSE
    PRINT STR$(AnzEintraege); " Dateien gefunden"
END SELECT
VIEW PRINT 1 TO 25
END SUB

'*****************************************************************************
'* FindFirst : Den ersten Dirctory-Eintrag einlesen                          *
'* Eingabe  : Der Dateiname, die Dateiattribute                              *
'* Ausgabe  : TRUE, wenn der Eintrag gefunden wurde, sonst FALSE             *
'* Info     : Der Eintrag wird in die Variabele DirBuf eingelesen            *
'*****************************************************************************
FUNCTION FindFirst% (Dateiname AS STRING, Attr AS INTEGER)
DIM Datei AS STRING * 65             'Zwischenspeicher fr Dateiname (s. Text)
DIM Regs AS RegTypeX                                        'Prozessorregister

Datei = Dateiname                                         'Dateiname betragen
Datei = Datei + CHR$(0)                     'Dateiname durch <NUL> abschlieen
Regs.ax = &H4E00                    'AH = Funktionsnummer fr Search for first
Regs.cx = Attr                              'Attribute nach denen gesucht wird
Regs.ds = VARSEG(Datei)                        'Segmentadresse des Dateinamens
Regs.dx = VARPTR(Datei)                          'Ofsetadresse des Dateinamens
CALL INTERRUPTX(&H21, Regs, Regs)                      'DOS-Interrupt aufrufen
IF (Regs.flags AND FCARRY) = 0 THEN                         'Carry-Flag testen
  FindFirst = TRUE                               'nicht gesetzt: Datei gefunden
ELSE                                            'gesetzt: Datei nicht gefunden
  FindFirst = FALSE
END IF
END FUNCTION

'*****************************************************************************
'* FindNext : Liest den folgenden Directory-Eintrag aus                      *
'* Eingabe : Keine                                                           *
'* Ausgabe : TRUE, wenn der Eintrag gefunden wurde, sonst FALSE              *
'* Info    : Die Funktion darf erst nach erfolgreichem Aufruf                *
'*           von GetFirst ausgerufen werden, der Eintrag wird in             *
'*           die Variabele DirBuf eingelesen                                 *
'*****************************************************************************
FUNCTION FindNext%

DIM Regs AS RegType                    'Prozessorregister fr Interruptaufrufe

Regs.ax = &H4F00                 'AH = 4F: Funktionsnummer fr Search for next
CALL INTERRUPT(&H21, Regs, Regs)                       'DOS-Interrupt aufrufen
IF (Regs.flags AND FCARRY) = 0 THEN                         'Carry-Flag testen
  FindNext = TRUE                                'nicht gesetzt: Datei gefunden
ELSE                                            'gesetzt: Datei nicht gefunden
  FindNext = FALSE
END IF
END FUNCTION

'*****************************************************************************
'* Makeword : Macht aus einer Integerzahl eine Langzahl, da in BASIC         *
'*            ansonsten die durch Ganzzahldivisionen realisierten Bit-       *
'*            schiebeoperationen bei einer negativen Zahl fehlerhaft         *
'*            verlaufen.                                                     *
'* Eingabe  : Die Integerzahl                                                *
'* Ausgabe  : Die dem Bitmuster entsprechende Langzahl                       *
'*****************************************************************************
FUNCTION MakeWord& (Zahl AS INTEGER)

IF Zahl < 0 THEN
  MakeWord = 65536 + Zahl
ELSE
  MakeWord = Zahl
END IF
END FUNCTION

'*****************************************************************************
'* Monat   : Gibt einen Monatsnamen als String aus                           *
'* Eingabe : Die Nummer des Monats                                           *
'* Ausgabe : Der Monatsname des Monats als String                            *
'*****************************************************************************
FUNCTION Monat$ (Mon AS INTEGER)

SELECT CASE Mon
  CASE 1
    Monat$ = "Jan"
  CASE 2
    Monat$ = "Feb"
  CASE 3
    Monat$ = "Mr"
  CASE 4
    Monat$ = "Apr"
  CASE 5
    Monat$ = "Mai"
  CASE 6
    Monat$ = "Jun"
  CASE 7
    Monat$ = "Jul"
  CASE 8
    Monat$ = "Aug"
  CASE 9
    Monat$ = "Sep"
  CASE 10
    Monat$ = "Okt"
  CASE 11
    Monat$ = "Nov"
  CASE 12
    Monat$ = "Dez"
END SELECT
END FUNCTION

'*****************************************************************************
'* PrintData : Informationen ber einen Eintrag ausgeben                     *
'* Eingabe   : Der DirBufType mit den Dateiinformationen                     *
'* Ausgabe   : Keine                                                         *
'* Info      : Die Information ber den Eintrag entnimmt diese               *
'*             Prozedur der Variabelen DirBuf                                *
'*****************************************************************************
SUB PrintData (DirBuf AS DirStruct)

DIM Zaehler AS INTEGER                                        'Schleifenzhler

PRINT                                          'Neue Zeile in Tabelle ausgeben
LOCATE BILDTOP + EINTR + 3, 15     'Cursor in letzte Zeile des Ausgabefensters
PRINT "";
Zaehler = 1
WHILE MID$(DirBuf.DatName, Zaehler, 1) <> CHR$(0)       'Wiederholen bis <NUL>
  PRINT MID$(DirBuf.DatName, Zaehler, 1);         'Zeichen des Namens ausgeben
  Zaehler = Zaehler + 1                                      'nchstes Zeichen
WEND

'-- Dateilnge ermitteln und ausgeben ---------------------------------------

LOCATE BILDTOP + EINTR + 3, 30                           'Cursor positionieren
PRINT USING " ####### "; DirBuf.Size;

'-- Datum und Uhrzeit ausgeben ----------------------------------------------
LOCATE BILDTOP + EINTR + 3, 40
PRINT " "; Dat$(MakeWord(DirBuf.Date) AND 31); " ";           'Tag ermitteln
PRINT Monat((MakeWord(DirBuf.Date) \ 32) AND 15);            'Monat ermitteln
PRINT USING " ####"; (MakeWord(DirBuf.Date) \ 512) + 1980;    'Jahr ermitteln
LOCATE BILDTOP + EINTR + 3, 53
PRINT "  "; Dat$(MakeWord(DirBuf.Time) \ 2048); " Uhr";      'Stunde ermitteln
PRINT " "; Dat$((MakeWord(DirBuf.Time) \ 32) AND 63);        'Minute ermitteln

'-- Dateiattribute ausgeben -------------------------------------------------

LOCATE BILDTOP + EINTR + 3, 66
PRINT "";
Zaehler = 1
WHILE (Zaehler < 32)
  IF (ASC(DirBuf.Attrib) AND Zaehler) <> 0 THEN                        'Read- Only ?
    PRINT "X";
  ELSE
    PRINT " ";
  END IF
  Zaehler = Zaehler * 2
WEND
PRINT "";                                          'Rechter Rahmen des Feldes

END SUB

'*****************************************************************************
'* SetDTA  : Setzt die Adresse der DTA                                       *
'* Eingabe : Die Segment und Offsetadresse des Puffers fr die DTA           *
'* Ausgabe : Keine                                                           *
'*****************************************************************************
SUB SetDTA (Segment AS LONG, Offset AS LONG)

DIM Regs AS RegTypeX                                        'Prozessorregister

Regs.ax = &H1A00                     'AH = &H1A Funktionsnummer fr DTA setzen
Regs.ds = Segment                              'Segmentadresse ind DS-Register
Regs.dx = Offset                               'Offsetadresse ind DX-Register
CALL INTERRUPTX(&H21, Regs, Regs)                      'DOS-Interrupt aufrufen
END SUB

