'*****************************************************************************
'*                                 DVIB                                      *
'-----------------------------------------------------------------------------
'*  Aufgabe        : demonstriert den direkten Zugriff auf den               *
'*                   Video -RAM                                              *
'-----------------------------------------------------------------------------
'*  Autor          : MICHAEL TISCHER                                         *
'*  entwickelt am  : 06.05.1991                                              *
'*  letztes Update : 06.05.1991                                              *
'*****************************************************************************
DECLARE SUB InitDPrint ()
DECLARE SUB Demo ()
DECLARE SUB DPrint (Spalte%, Zeile%, Farbe%, StrOut AS STRING)

									      
CONST NORMAL = &H7                         'Definitionen der Zeichenattribute
CONST HELL = &HF                            'einer monochrome Bildschirmkarte
CONST INVERS = &H70
CONST UNTERSTRICHEN = &H1
CONST BLINKEN = &H80
										
CONST SCHWARZ = &H0                            'Farbattribute der Color-Karte
CONST BLAU = &H1
CONST GRUEN = &H2
CONST KOBALTBLAU = &H3
CONST ROT = &H4
CONST VIOLETT = &H5
CONST BRAUN = &H6
CONST HELLGRAU = &H7
CONST DUNKELGRAU = &H8
CONST HELLBLAU = &H9
CONST HELLGRUEN = &HA
CONST HELLKOBALT = &HB
CONST HELLROT = &HC
CONST HELLVIOLETT = &HD
CONST GELB = &HE
CONST WEISS = &HF
										
DIM SHARED VSeg AS LONG                         'Segmentadresse des Video-RAM
										
CALL InitDPrint                           'Ausgabe ber DPrint initialisieren
CALL Demo                                               'DPrint demonstrieren
END

'*****************************************************************************
'* Demo    : Demonstriert die Arbeit mit DPrint                              *
'* Eingabe : keine                                                           *
'* Ausgabe : keine                                                           *
'*****************************************************************************
SUB Demo
										
DIM Spalte AS INTEGER                                     'Spalte der Ausgabe
DIM Zeile AS INTEGER                                       'Zeile der Ausgabe
DIM Farbe AS INTEGER                          'Bildschirmattribut der Ausgabe
										
RANDOMIZE TIMER                              'Zufallsgenerator initialisieren

IF VSeg = &HB800 THEN                          'Color-Adapter angeschlossen ?
  CLS                                                     'Bildschirm lschen
  CALL DPrint(22, 0, WEISS, "DVIB - (c) 1988 by Michael Tischer ")
  DO
    Spalte = INT(76 * RND)                        'zufllige Spalte auswhlen
    Zeile = INT(22 * RND) + 1                      'zufllige Zeile auswhlen
    Farbe = INT(14 * RND) + 1                      'zufllige Farbe auswhlen
    CALL DPrint(Spalte, Zeile, Farbe, "")                  'Block ausgeben
  LOOP UNTIL INKEY$ <> ""                    'wiederholen, bis Taste bettigt
ELSE                                       'monochromer-Adapter angeschlossen
  CLS                                                     'Bildschirm lschen
  CALL DPrint(22, 0, INVERS, "DVIB - (c) 1988 by Michael Tischer ")
  DO
    Spalte = INT(76 * RND)                        'zufllige Spalte auswhlen
    Zeile = INT(22 * RND) + 1                      'zufllige Zeile auswhlen
    SELECT CASE INT(4 * RND)            'zuflliges Zeichenattribut auswhlen
       CASE 0
	 Farbe = NORMAL
       CASE 1
	 Farbe = HELL
       CASE 2
	 Farbe = INVERS
       CASE 3
	 Farbe = BLINKEN OR INVERS                'ist so deutlicher zu sehen
    END SELECT
    CALL DPrint(Spalte, Zeile, Farbe, "")                   'Block ausgeben
  LOOP UNTIL INKEY$ <> ""                    'wiederholen, bis Taste bettigt
END IF
END SUB

'*****************************************************************************
'* DPrint  : Schreibt einen String direkt in den Video-RAM                   *
'* Eingabe :  - Spalte : die Ausgabespalte                                   *
'*            - Zeile  : die Ausgabezeile                                    *
'*            - Farbe  : Farbe(Attribut) fr die einzelnen Zeichen           *
'*            - SrtOut : der auszugebende String
'* Ausgabe : keine                                                           *
'*****************************************************************************
SUB DPrint (Spalte%, Zeile%, Farbe%, StrOut AS STRING)
										
DIM Offset AS INTEGER        'OffsetAdresse an die Zeichen gepokt werden soll
DIM Zaehler AS INTEGER                                       'Schleifenzhler
										
DEF SEG = &H40                   'Segmentadresse des BIOS-Variabelen-Bereichs
Offset = PEEK(&H4E) + PEEK(&H4F) * 256      'Startadresse der Seite ermitteln
Offset = Offset + Zeile% * 160 + Spalte% * 2     'Offsetadresse erstes Zeichen
DEF SEG = VSeg                                 'Segmentaddresse des Video-RAM
FOR Zaehler = 1 TO LEN(StrOut)                        'den String durchlaufen
  POKE Offset, ASC(MID$(StrOut, Zaehler, 1))         'ASCII-Code in Video-RAM
  POKE Offset + 1, Farbe%                                 'Farbe in Video-RAM
  Offset = Offset + 2                     'Offset auf nchstes Zeichen setzen
NEXT
END SUB

'*****************************************************************************
'* InitDPrint : Ermittelt die Segmentadresse fr DPrint                      *
'* Eingabe    : keine                                                        *
'* Ausgabe    : Die Segmantadresse des Video-RAM ber die globale            *
'*              Variabele VSeg                                               *
'*****************************************************************************
SUB InitDPrint

DEF SEG = &H40                  'Segmentadresse des BIOS-Variabelen-Registers
IF PEEK(&H63) + PEEK(&H64) * 256 = &H3B4 THEN  'monochromer Adapter angeschl.
  VSeg = &HB000                                      'Video-RAM bei 8000:0000
ELSE                                             'Color-Adapter angeschlossen
  VSeg = &HB800                                      'Video-RAM bei B800:0000
END IF
END SUB

