'**********************************************************************'
'*                             J O Y S T B                            *'
'*--------------------------------------------------------------------*'
'*  Aufgabe        : Demonstriert die Abfrage des Joysticks mit Hilfe *'
'*                   des BIOS                                         *'
'*  Autor          : MICHAEL TISCHER                                  *'
'*  entwickelt am  : 25.02.1991                                       *'
'*  letztes Update : 26.02.1991                                       *'
'**********************************************************************'
DECLARE SUB GetJoyButton (j1b1%, j1b2%, j2b1%, j2b2%)
DECLARE SUB GetJoyPos (js1 AS ANY, js2 AS ANY)

REM $INCLUDE: 'qb.bi'

'-- Variablen- und Typen-Deklarationen --

TYPE JSPOS 'beschreibt Joystick-Position
  x AS INTEGER
  y AS INTEGER
END TYPE

DIM jsp(1 TO 2) AS JSPOS 'aktuelle Jostick-Position
DIM maxx AS INTEGER, maxy AS INTEGER 'maximale Jostick-Position
DIM minx AS INTEGER, miny AS INTEGER 'minimale Jostick-Position
DIM xold AS INTEGER, yold AS INTEGER 'letzte Jostick-Position
DIM aktstick AS INTEGER 'aktiver Joystick (1 oder 2)
DIM xfaktor AS SINGLE, yfaktor AS SINGLE 'Umrechnungsfaktoren
DIM j1but(1 TO 2) AS INTEGER 'Button 1 auf Joystick 1 und 2
DIM j2but(1 TO 2) AS INTEGER 'Button 1 auf Joystick 1 und 2

'-- Hier geht's los, zunchst maximale Joystick-Stellung ermitteln ---

CLS
PRINT "Bitte bewegen Sie den Joystick in die obere rechte Schalter-"
PRINT "stellung und bettigen Sie einen der beiden Buttons."

DO 'auf Bettigung einer Joystick-Taste warten
  CALL GetJoyButton(j1but(1), j2but(1), j1but(2), j2but(2))
LOOP WHILE (j1but(1) OR j2but(1) OR j1but(2) OR j2but(2)) = 0

IF j1but(1) OR j2but(1) <> 0 THEN 'welcher Jostick war's?
  aktstick = 1
ELSE
  aktstick = 2
END IF

CALL GetJoyPos(jsp(1), jsp(2)) 'Position auslesen
maxx = jsp(aktstick).x 'als maximale Position merken
miny = jsp(aktstick).y

DO 'auf Loslassen der Joystick-Tasten warten
  CALL GetJoyButton(j1but(1), j2but(1), j1but(2), j2but(2))
LOOP UNTIL (j1but(aktstick) = 0) AND (j2but(aktstick) = 0)

'-- Jetzt minimale Joystick-Stellung ermitteln ---

PRINT : PRINT
PRINT "Bitte bewegen Sie den Joystick jetzt in die untere linke "
PRINT "Schalterstellung und bettigen Sie einen der beiden Buttons."

DO 'auf Bettigung eines Buttons des gew. Joysticks warten
  CALL GetJoyButton(j1but(1), j2but(1), j1but(2), j2but(2))
LOOP WHILE (j1but(aktstick) = 0) AND (j2but(aktstick) = 0)

CALL GetJoyPos(jsp(1), jsp(2)) 'aktuelle Position auslesen
minx = jsp(aktstick).x 'und als minimale Position merken
maxy = jsp(aktstick).y

faktorx = 80 / (maxx - minx + 1) 'Umrechungsfaktoren in Bezug auf X-
faktory = 23 / (maxy - miny + 1) 'und Y-Achse berechnen            -

'-- Jostick abfragen und Position anzeigen, bis beide Joystick-Tasten --
'-- bettigt werden

CLS
LOCATE 2, 44
PRINT "JOYSTB  - (c) 1991 by MICHAEL TISCHER";
LOCATE 25, 1
PRINT "Bettigen Sie beide Joystick-Tasten, um das Programm ";
PRINT "zu beenden"
xold = 1 'alte Position vorgeben
yold = 1

DO
  '-- Position abfragen und ausgeben --
  CALL GetJoyPos(jsp(1), jsp(2))
  LOCATE 1, 1
  PRINT "("; jsp(aktstick).x; "/"; jsp(aktstick).y; ")  ";
 
  '-- neue X-Position des Josticks berechnen ----
  x% = faktorx * (jsp(aktstick).x - minx% + 1)
  IF x% < 1 THEN x% = 1
  IF x% > 80 THEN x% = 80
 
  '-- neue Y-Position des Josticks berechnen ----
  y% = faktory * (jsp(aktstick).y - miny% + 1)
  IF y% < 1 THEN y% = 1
  IF y% > 23 THEN y% = 23
 
  '-- bei vernderter Position neue Position anzeigen ---
  IF (x% <> xold) OR (y% <> yold) THEN
    LOCATE yold + 1, xold'X an alter Position einblenden
    PRINT " ";
    LOCATE y% + 1, x% 'und an neuer Position anzeigen
    PRINT "X";
    xold = x% 'neue Position als alte merken
    yold = y%
  END IF
 
  CALL GetJoyButton(j1but(1), j2but(1), j1but(2), j2but(2))
LOOP UNTIL (j1but(aktstick) = 1) AND (j2but(aktstick) = 1)

CLS

'**********************************************************************'
'* GetJoyButton: liefert die Stellung der Joystick-Knpfe             *'
'*--------------------------------------------------------------------*'
'* Eingabe: J1B1% = 1, wenn Button 1 des ersten Joysticks gedrckt,   *'
'*                  sonst 0                                           *'
'*          J1B2% = wie J1B1%, aber fr zweiten Button des ersten     *'
'*                  Joysticks                                         *'
'*          J2B1% = wie J1B1%, aber fr zweiten Joystick              *'
'*          J2B2% = wie J1B2%, aber fr zweiten Joystick              *'
'**********************************************************************'
'
SUB GetJoyButton (j1b1%, j1b2%, j2b1%, j2b2%)
  DIM regs AS RegType 'zur Aufnahme der Register beim Intr-Aufruf

  regs.ax = &H8400       'BIOS-Funktion 84h des Interrupts 15h aufrufen
  regs.dx = &H0          'Unterfunktion 00h
  CALL INTERRUPT(&H15, regs, regs)
  j1b1% = (regs.ax AND 16) \ 16 XOR 1   'Bit 4 von AX = J1B1
  j1b2% = (regs.ax AND 32) \ 32 XOR 1   'Bit 5 von AX = J1B2
  j2b1% = (regs.ax AND 64) \ 64 XOR 1   'Bit 6 von AX = J2B1
  j2b2% = (regs.ax AND 128) \ 128 XOR 1 'Bit 7 von AX = J2B2
END SUB

'**********************************************************************'
'* GetJoyPos : liest die Position der beiden Joysticks                *'
'*--------------------------------------------------------------------*'
'* Eingabe: JS1 = Struktur vom Typ JSPOS zur Aufnahme der Position    *'
'*                des ersten Joysticks                                *'
'*          JS2 = wie JS1, aber fr zweiten Joystick                  *'
'**********************************************************************'
'
SUB GetJoyPos (js1 AS JSPOS, js2 AS JSPOS)
  DIM regs AS RegType 'zur Aufnahme der Register beim Intr-Aufruf

  regs.ax = &H8400       'BIOS-Funktion 84h des Interrupts 15h aufrufen
  regs.dx = &H1          'Unterfunktion 01h
  CALL INTERRUPT(&H15, regs, regs)
  js1.x = regs.ax        'Joystick-Position ass den Registern in
  js1.y = regs.bx        'die bergebenen Variablen eintragen
  js2.x = regs.cx
  js2.y = regs.dx
END SUB

