'*****************************************************************************
'*                                 KONFIGB                                   *
'*---------------------------------------------------------------------------*
'*  Aufgabe        : gibt die Konfiguration ihres PC auf dem Bild-           *
'*                   schirm aus                                              *
'*---------------------------------------------------------------------------*
'*  Autor          : Michael Tischer                                         *
'*  entwickelt am  : 10.06.1991                                              *
'*  letztes Update : 10.06.1991                                              *
'*****************************************************************************
DECLARE SUB PrintKonfig ()
DECLARE FUNCTION GetWord& (Register AS INTEGER)
										
'$INCLUDE: 'QB.BI'                      'beinhaltet die Registerdeklarationen
										
CONST TRUE = -1                                   'Wahrheitswerte deffinieren
CONST FALSE = NOT TRUE
										
CALL PrintKonfig                                      'Konfiguration ausgeben
END

'*****************************************************************************
'* GetWord : wandelt eine Integerzahl (2 Byte aber mit Vorzeichen) in        *
'*           eine lange Ganzzahl um, damit die Bit-Verschiebeoperationen     *
'*           ber arithmetische Funktionen (\, MOD) funktionieren            *
'* Eingabe : s.u                                                             *
'* Ausgabe : s.u.                                                            *
'*****************************************************************************
FUNCTION GetWord& (Register AS INTEGER)

IF Register <= 0 THEN                                   'BIT 16 ist gesetzt ?
  GetWord = 65536 + Register  'ergibt das positive quivalent einer neg. Zahl
ELSE                                                    'BIT 16 nicht gesetzt
  GetWord = Register                                 'Integerzahl ist positiv
END IF
END FUNCTION

'*****************************************************************************
'* PrintKonfig : Ausgabe der Konfiguration eines PC                          *
'* Eingabe     : keine                                                       *
'* Ausgabe     : keine                                                       *
'* Info        : Die Konfiguration wird in Abhngigkeit des PC-Typs          *
'*               ausgegeben                                                  *
'*****************************************************************************
SUB PrintKonfig
										
DIM AT AS INTEGER                                          'Ist der PC ein AT
DIM Word AS LONG                                         'nimmt eine Word auf
DIM Register AS RegType               'Prozessorregister fr Interruptaufrufe
										
CLS                                                       'Bildschirm lschen
DEF SEG = &HF000               'Segmentadresse des Model-Identifikations-Byte
IF PEEK(&HFFFE) = &HFC THEN                                 'PC-Typ bestimmen
   AT = TRUE                                                   'es ist ein AT
ELSE                                                          'es ist kein AT
   AT = FALSE
END IF
PRINT "KONFIGB  -  (c) 1987, 1991 by Michael Tischer": PRINT
PRINT "Konfiguration ihres PC "
PRINT "------------------------------------------------------------"
PRINT "PC-Typ                  : ";
SELECT CASE PEEK(&HFFFE)                             'PC-Type erneut auslesen
    CASE &HFF                                                '&HFF ist ein PC
       PRINT "PC"
    CASE &HFE                                                '&HFE ist ein XT
       PRINT "XT"
    CASE &HFC                                                '&HFC ist ein AT
       PRINT "AT oder hher"
END SELECT
CALL INTERRUPT(&H12, Register, Register)       'RAM-Gre ber BIOS-Interrupt
PRINT "RAM-Speicher            :"; Register.ax; "KB"
IF AT THEN                                            'Wenn der PC ein AT ist
  Register.ax = &H8800                   'FunktionsNr. fr zustzl. RAM lesen
  CALL INTERRUPT(&H15, Register, Register) 'BIOS-Kassetten-Interrupt aufrufen
  PRINT "zustzlicher RAM        :"; Register.ax; "KB ber 1 MB"
END IF
CALL INTERRUPT(&H11, Register, Register) 'BIOS-Konfigurations-Interrupt aufr.
PRINT "Videomodus nach Start   : ";
SELECT CASE (Register.ax MOD 256) AND 48                'Videomodus ermitteln
    CASE 0
      PRINT "undefiniert"
    CASE 16
      PRINT "40*24 Zeichen Color-Karte"
    CASE 32
      PRINT "80*24 Zeichen Color-Karte"
    CASE 48
      PRINT "80*24 Zeichen Mono-Karte"
END SELECT
Word = GetWord(Register.ax)               'die Integerzahl in Word verwandeln
PRINT "Diskettenlaufwerke      :"; (((Word MOD 256) \ 64) AND 3) + 1
PRINT "Serielle Schnittstellen :"; ((Word \ 256) \ 2) AND 3
PRINT "Parallele Schnittstellen:"; (Word \ 256) \ 64
END SUB

