'*****************************************************************************
'*                              M C B B . B A S                              *
'-----------------------------------------------------------------------------
'*   Aufgabe        : Zeigt die ber das DOS allokierten Speicher-           *
'*                    Blcke an.                                             *
'-----------------------------------------------------------------------------
'*   Autor          : Michael Tischer                                        *
'*   entwickelt am  : 16.05.1991                                             *
'*   letztes Update : 20.10.1991                                             *
'*****************************************************************************
DECLARE SUB TraceMCB ()
DECLARE SUB FirstMCB (Adr AS ANY)
DECLARE SUB Dump (Adr AS ANY, Anz%)
DECLARE FUNCTION HexByte$ (HByte%)
DECLARE FUNCTION GetDosVer% ()
DECLARE FUNCTION GetWord& (SegAdr AS LONG, OfsAdr AS LONG)
DECLARE FUNCTION Hexstring$ (HexVal&)
										
'$INCLUDE: 'qb.bi'                                    'Includedatei einbinden

CONST TRUE = -1                                    'Wahrheitswerte definieren
CONST FALSE = NOT TRUE
							 
TYPE AdrType                                       'Pointer auf eine Adresse
   OfsAdr AS LONG                                             'Offsetadresse
   SegAdr AS LONG                                             'Segmentadresse
END TYPE
									       
CLS                                                       'Bildschirm lschen
PRINT "MCBB  -  (c) 1988, 91 by Michael Tischer": PRINT : PRINT
CALL TraceMCB                                   'die Kette der MCBs aufdecken
END

'*****************************************************************************
'* DUMP    : Gibt Hex und ASCII-Dump eines Speicherbereichs aus              *
'* Eingabe : SegAdr = Die Segmentadresse des zu dumpenden Speicherbereichs   *
'*           Anz    = Die Anzahl der zu dumpenden Zeilen (je 16 Byte)        *
'* Ausgabe : keine                                                           *
'*****************************************************************************
SUB Dump (SegAdr AS LONG, Anz AS INTEGER)

DIM HexStr AS STRING * 2                       'nimmt 2-Ziffrige Hex-Zahl auf
DIM Offset AS LONG                             'Offset in den Speicherbereich
										
HexStr = "zz"                                         'den Hex-String anlegen
PRINT
PRINT "DUMP  0123456789ABCDEF       00 01 02 03 ";
PRINT "04 05 06 07 08 09 0A 0B 0C 0D 0E 0F"
PRINT "";
PRINT ""
Offset = 0                                      'mit dem ersten Byte beginnen
DEF SEG = SegAdr                               'die Segmentadresse definieren
WHILE Anz > 0                               'die Schleife Anz-mal durchlaufen
  PRINT Hexstring$(Offset); "  ";
  FOR z = 0 TO 15                                 'Jeweils 16 Byte bearbeiten
    IF PEEK(Offset + z) >= 32 THEN                  'gltiges ASCII-Zeichen ?
       PRINT CHR$(PEEK(Offset + z));                       'Ja ,dann ausgeben
    ELSE
       PRINT " ";                                  'Nein, dann Space ausgeben
    END IF
  NEXT
  PRINT "       ";                                'Cursor auf Hex-Teil setzen
  FOR z = 0 TO 15                              'jeweils 16 Zeichen bearbeiten
    PRINT HexByte$(PEEK(Offset + z)); " ";      'Byte als Hex-String ausgeben
  NEXT
  PRINT                                                           'Neue Zeile
  Offset = Offset + 16                    'Offset in die nchste Zeile setzen
  Anz = Anz - 1               'Anzahl der verbleibenden Zeilen dekrementieren
WEND
PRINT
END SUB

'*****************************************************************************
'*  FirstMCB : liefert einen Zeiger auf den ersten MCB                       *
'*  Eingabe  : keine                                                         *
'*  Ausgabe  : Zeiger auf den ersten MCB in der Variabele MCBAdr             *
'*****************************************************************************
SUB FirstMCB (MCBAdr AS AdrType)
										
DIM Register AS RegTypeX               'Prozessorregister fr Interruptaufruf
										
Register.ax = &H52 * 256             'Fkt.Nr: Adresse des DOS-Infoblock holen
CALL INTERRUPTX(&H21, Register, Register)             'DOS-Interrupt aufrufen
'-- (ES:BX - &H4) = ES-1:12 liefert Adresse des Pointers auf den ersten MCB -
DEF SEG = Register.es - 1                          'Segmentadresse definieren
MCBAdr.OfsAdr = PEEK(Register.bx + 13) * 256& + PEEK(Register.bx + 12)
MCBAdr.SegAdr = PEEK(Register.bx + 15) * 256& + PEEK(Register.bx + 14)
END SUB

'*****************************************************************************
'*  GetDosVer : ermittelt die DosVersion                                     *
'*  Eingabe   : keine                                                        *
'*  Ausgabe   : die DOS-Versionsnummer (30 fr DOS 3.0 33 fr DOS 3.3 etc    *
'*****************************************************************************
FUNCTION GetDosVer%
										
DIM Register AS RegType                'Prozessorregister fr Interruptaufruf
										
Register.ax = &H30 * 256             'AH = Funkt.Nr fr DOS-Version ermitteln
CALL INTERRUPT(&H21, Register, Register)         'DOS-Interrupt &H21 aufrufen
GetDosVer = INT(Register.ax \ 256) + (Register.ax MOD 256) * 10
END FUNCTION

'*****************************************************************************
'* Getword  : liest ein Word aus einer Speicheraddresse als Langzahl aus     *
'* Eingabe  : SegAdr = die Segmantadresse des Words                          *
'*            OfsAdr = die Offsetadresse des Words                           *
'* Ausgabe  : der Inhalt des Words als Langzahl                              *
'*****************************************************************************
FUNCTION GetWord& (SegAdr AS LONG, OfsAdr AS LONG)
										
DEF SEG = SegAdr                                      'Segmentadresse setzten
GetWord& = PEEK(OfsAdr + 1) * 256& + PEEK(OfsAdr)   'Speicherstellen auslesen
END FUNCTION

'*****************************************************************************
'* Hexbyte  : Wandelt ein Byte in eine HEX-Zeichenkette um                   *
'* Eingabe  : Hbyte = das Byte                                               *
'* Ausgabe  : eine Zeichenkette                                              *
'* Info     : Die QBASIC-Funktion HEX$ liefert nicht immer Zeichenketten     *
'*            mit zwei Zeichen, wie hier erwnscht                           *
'*****************************************************************************
FUNCTION HexByte$ (HByte AS INTEGER)
										
DIM HexSt AS STRING * 2                                 'nimmt Hex-String auf
										
MID$(HexSt, 1, 1) = HEX$(HByte \ 16)                            'Erste Ziffer
MID$(HexSt, 2, 1) = HEX$(HByte MOD 16)                         'Zweite Ziffer
HexByte$ = HexSt                             ' den erzeugten String bergeben
END FUNCTION

'*****************************************************************************
'* HexString :gibt das Argument als Zeichenkette in Form einer Hex-Zahl aus  *
'* Eingabe   : der  Umzuwandelnde Wert                                       *
'* Ausgabe   : der umgesetzte Hex-String                                     *
'* Info      : Die QBASIC-Funktion HEX$ liefert nicht immer Zeichenketten    *
'*             mit vier Zeichen, wie hier erwnscht                          *
'*****************************************************************************
FUNCTION Hexstring$ (HexValVar AS LONG)
										
DIM Nibble AS INTEGER                 'das jeweils unterste Nibble des Wortes
DIM HexVal AS LONG         ' Das Argument mu abgespeichert werden da Q-Basic
					       'mit Referenzbergabe arbeitet
DIM HStr AS STRING * 4                           'Der umgewandelte Hex-String
									       
HexVal = HexValVar      ' Das Argument speicher, da men seinen Wert verndert
HStr = "xxxx"                                             'den String anlegen
FOR zaehler = 0 TO 3                               'Die 4 Ziffern durchlaufen
   Nibble = HexVal AND &HF                   'nur die oberen 4  BITs belassen
   MID$(HStr, 4 - zaehler, 1) = HEX$(Nibble)   'Nibble in Hexziffer umwandeln
   HexVal = HexVal \ 16    'HexVal um 4 Bitpositionen nach rechts verschieben
NEXT
Hexstring$ = HStr                             'den erzeugten String bergeben
END FUNCTION

'*****************************************************************************
'* TraceMCB : verfolgt die Liste der MCBs                                    *
'* Eingabe  : keine                                                          *
'* Ausgabe  : keine                                                          *
'*****************************************************************************
SUB TraceMCB

CONST kom = "COMSPEC="                  '"COMSPEC=" als Konstante deklarieren
										
DIM AktMCB  AS AdrType                                       'Pointer auf MCB
DIM ID      AS STRING * 1            '"M" es folgt noch ein Block, "Z" = Ende
DIM PSP     AS LONG                       'Segmentadresse des zugehrigen PSP
DIM Abstand AS LONG                              ' Anzahl der Paragraphen - 1
DIM MemPtr  AS LONG                                   'Pointer in den Speicher
DIM NrMCB   AS INTEGER                      'Nummer des gerade untersuchten MCB
DIM z       AS INTEGER                                             'Schleifenzhler
DIM Ende    AS INTEGER                                         'Abbruchbedingung
DIM AktOfs  AS LONG

DosVer = GetDosVer                                     'DOS-Version ermitteln
NrMCB = 1                                        'mit dem ersten MCB beginnen
Ende = FALSE
CALL FirstMCB(AktMCB)                            'Zeiger auf ersten MCB holen
DO
  AktOfs = AktMCB.OfsAdr 'Offsetadresse laden
  DEF SEG = AktMCB.SegAdr                'Segmentadresse festlegen fr Peek()
  ID = CHR$(PEEK(AktOfs))                         'erstes MCB auslesen
  PSP = GetWord&(AktMCB.SegAdr, AktOfs + &H1)
  Abstand = GetWord&(AktMCB.SegAdr, AktOfs + &H3)

  IF ID = "Z" THEN                                    'letzter MCB gelesen ?
    Ende = TRUE               'Schleife abbrechen und keinen neuen MCB holen
  END IF
  PRINT "MCB-Nummer       ="; NrMCB
  PRINT "MCB-Adresse      = "; Hexstring$(AktMCB.SegAdr); ":";
  PRINT Hexstring$(AktOfs)
  PRINT "Speicher-Adresse = "; Hexstring$(AktMCB.SegAdr + 1); ":";
  PRINT Hexstring$(AktOfs)
  PRINT "ID               = "; ID
  PRINT "PSP-Adresse      = "; Hexstring$(PSP); ":0000"
  PRINT "Gre            = "; Hexstring$(Abstand); " Paragraphen ( ";
  PRINT Abstand * 16; " Bytes )"
  PRINT "Inhalt           = ";
 
  '---- Handelt es sich um ein Environment ? --------------------------------
  z = 0                               'Vergleich mit dem ersten Byte beginnen
  MemPtr = AktMCB.SegAdr + 1                                  'Pointer in RAM
  DEF SEG = MemPtr                          'Segmentadresse fr Peek() setzen
  WHILE (z <= 7) AND MID$(kom, z + 1, 1) = CHR$(PEEK(AktMCB.OfsAdr + z))
    z = z + 1                                               'nchstes Zeichen
  WEND
  IF z > 7 THEN                              'COMSPEC = String wurde entdeckt
    PRINT "Environment "
    IF DosVer > 30 THEN                         'DOS-Version 3.0 oder hher ?
      PRINT "Programmname     = ";                'Ja, Programmname ermitteln
      z = 0                                         'mir erstem Byte beginnen
      DO
	z = z + 1                                          'Leerstring suchen
      LOOP UNTIL PEEK(AktOfs + z) = 0 AND PEEK(AktOfs + z + 1) = 0
      IF PEEK(AktOfs + z + 2) = 1 AND PEEK(AktOfs + z + 3) = 0 THEN
	'--- Programmnamen entdeckt -----------------------------------
	z = z + 4               'z auf erstes Zeichen des Programmnamens setzen
	DO                                 'den Programmnamen durchlaufen
	  PRINT CHR$(PEEK(AktOfs + z));              'Zeichen ausgeben
	  z = z + 1                                         'nchstes Zeichen
	LOOP UNTIL PEEK(AktOfs + z) = 0                'bis Stringende
	PRINT
      ELSE                                        'kein Programmname gefunden
	PRINT "unbekannt"
      END IF
    END IF
										
   '---- Die Environment-Strings ausgeben -----------------------------------
										
    PRINT "Environment-Strings"
    z = 0                'mit dem ersten Byte im allokierten Bereich beginnen
    WHILE PEEK(AktOfs + z) <> 0             'wiederhole bis Leerstring
      PRINT "      ";                                        'Zeile einrcken
      DO                                               'einen String ausgeben
	PRINT CHR$(PEEK(AktOfs + z));                'Zeichen ausgeben
	z = z + 1                                           'nchstes Zeichen
      LOOP UNTIL PEEK(AktOfs + z) = 0              'bis zum Stringende
      z = z + 1                    'auf den Anfang des nchsten String setzen
      PRINT                                                    'Zeile beenden
    WEND
  ELSE
  '---- handelt es sich um einen PSP ----------------------------------------
  '---- (Wird durch Befehl (INT 20) (Code &HCD &H20) eingeleitet)------------

    MemPtr = AktMCB.SegAdr + 1                         'Pointer in RAM setzen
    IF PEEK(AktOfs) = &HCD AND PEEK(AktOfs + 1) = &H20 THEN
      PRINT "PSP (mit Nachfolgendem Programm)"        'Es handelt sich um PSP
    ELSE                      'Der Befehl INT 20 konnte nicht enddeckt werden
      PRINT "Nicht identifizierbares Programm"
      CALL Dump(MemPtr, 5)                      'Die ersten 5*16 Bytes dumpen
    END IF
  END IF
										
  PRINT " Bitte Taste drcken "
  DO                                                     'Auf Taste warten
  a$ = INKEY$
  LOOP UNTIL a$ <> ""
  IF NOT Ende THEN                                    'Es gibt noch einen MCB
    AktMCB.SegAdr = AktMCB.SegAdr + Abstand + 1 'Pointer auf nchsten MCB
    NrMCB = NrMCB + 1
  END IF
LOOP UNTIL Ende                      'Durchlaufen bis es keinen MCB mehr gibt
END SUB

