'*****************************************************************************
'*                              M F 2 B                                      *
'-----------------------------------------------------------------------------
'*  Demonstriert die Abfrage der zustzlichen Tasten einer MF-II-            *
'*  Tastatur                                                                 *
'-----------------------------------------------------------------------------
'* Autor          : MICHAEL TISCHER                                          *
'* entwickelt am  : 01.01.1992                                               *
'* letztes Update : 01.01.1992                                               *
'*****************************************************************************
'
'$INCLUDE: 'QB.BI'              'Include-Datei enthlt Register-Deklarationen
																									    
DECLARE FUNCTION MakeWord! (Zahl AS INTEGER)
DECLARE FUNCTION HexByte$ (wert AS INTEGER)
DECLARE FUNCTION GetMFKey% ()
DECLARE FUNCTION TestMF% ()

CONST TRUE = -1                                     'Wahrheitswerte definieren
CONST FALSE = NOT TRUE
																									    
'-- Hauptprogramm ------------------------------------------------------------

DIM taste AS INTEGER
DIM ZW AS STRING

CLS
ZW = CHR$(13)
PRINT "MF2B  -  (c) 1992 by Michael Tischer"; ZW
IF TestMF THEN
  PRINT "Die BIOS-Erweiterungen fr MF-II-Tastaturen wurden ";
  PRINT "entdeckt! " + ZW + ZW + "Bettigen Sie nun beliebige ";
  PRINT "Tasten und Tastenkombinationen, deren Codes Sie "
  PRINT "in Erfahrung bringen mchten." + ZW
  PRINT "Die Bettigung von <Esc> beendet das Programm." + ZW

  DO                                                          ' Eigabeschleife
    taste = GetMFKey                                              'Taste holen
    PRINT "Scan : "; HexByte(MakeWord(taste) / 256); "  ";
    PRINT "ASCII: "; HexByte(taste AND 255);
    IF ((taste AND 255) = &HE0) AND ((taste / 256) <> 0) THEN
      PRINT "  <---- MF-II-Taste"
    ELSE
      PRINT
    END IF
  LOOP UNTIL (taste = &H11B)                          ' wiederholen bis ESCAPE
  PRINT ZW
ELSE
  PRINT "Keine BIOS-Erweiterungen fr MF-II-Tastaturen prsent!"
END IF
END

'*****************************************************************************
'* GetMFKey  : Fragt eine Taste mit Hilfe der erweiterten Tastatur-Funktion  *
'*             &h10 ab                                                       *
'* Eingabe : keine                                                           *
'* Ausgabe : der Code der empfangenen Taste                                  *
'*****************************************************************************
'
FUNCTION GetMFKey%

DIM reg AS RegType                      'Prozessorregister fr Interruptaufruf

reg.ax = &H1000                  'erweiterte Lesefunktion fr MF-II-Tastaturen
CALL INTERRUPT(&H16, reg, reg)               'BIOS-Tastatur-Interrupt aufrufen
GetMFKey% = reg.ax                                   'Tastencode zurckliefern

END FUNCTION

'*****************************************************************************
'* HexByte : Verwandelt ein Byte in einen zweiziffrigen Hex-String           *
'* Eingabe : WERT = das umzuwandelnde Byte                                   *
'* Ausgabe : der zweiziffrige Hex-String                                     *
'*****************************************************************************
'
FUNCTION HexByte$ (wert AS INTEGER)

IF wert < 16 THEN                                                 'ein Ziffer?
  HexByte$ = "0" + HEX$(wert)                            'Ja, erste 0 ergnzen
ELSE                                           'Nein, automatisch zwei Ziffern
  HexByte$ = HEX$(wert)
END IF
END FUNCTION

'*****************************************************************************
'* Makeword : Macht aus einer Integerzahl eine Langzahl, da in BASIC         *
'*            ansonsten die durch Ganzzahldivisionen realisierten Bit-       *
'*            schiebeoperationen bei einer negativen Zahl fehlerhaft         *
'*            verlaufen.                                                     *
'* Eingabe  : Die Integerzahl                                                *
'* Ausgabe  : Die dem Bitmuster entsprechende Langzahl                       *
'*****************************************************************************
'
FUNCTION MakeWord! (Zahl AS INTEGER)

IF Zahl < 0 THEN
  MakeWord = 65536! + Zahl
ELSE
  MakeWord = Zahl
END IF

END FUNCTION

'*****************************************************************************
'* TestMF: Prft, ob die erweiterten BIOS-Funktionen zur Abfrage der MF-     *
'*         II-Tastatur zur Verfgung stehen                                  *
'* Eingabe : keine                                                           *
'* Ausgabe : TRUE, wenn die Funktionen zur Verfgung stehen, sonst FALSE     *
'*****************************************************************************
'
FUNCTION TestMF%

DIM reg AS RegType                      'Prozessorregister fr Interruptaufruf

reg.ax = &H1200               'erweiterte Status-Funktion fr MF-II-Tastaturen
CALL INTERRUPT(&H16, reg, reg)               'BIOS-Tastatur-Interrupt aufrufen
PRINT HEX$(reg.ax)
TestMF% = (reg.ax <> &H1200)             'AX = &h1200 : Funktion nicht prsent

END FUNCTION

