'*****************************************************************************
'*                            W I N D A B . B A S                            *
'-----------------------------------------------------------------------------
'* Aufgabe       : Feststellen ob und in welchem Modus Windows               *
'*                 aktiv ist                                                 *
'-----------------------------------------------------------------------------
'* Autor         : Michael Tischer                                           *
'* entwickelt am : 22.08.1991                                                *
'* letztes Update: 22.10.1991                                                *
'*****************************************************************************
DECLARE FUNCTION Windows% (HVersion AS INTEGER, NVersion AS INTEGER)
										
'$INCLUDE: 'Qb.bi'                          'Includedatei fr Interruptaufrufe
										
CONST MULTIPLEX = &H2F               'Interrupt-Nummer des Multiplex-Interrupt
CONST NOWIN = &H0                                         'Windows nicht aktiv
CONST WIN386X = &H1                                    'Windows/386 V2.x luft
CONST WINREAL = &H81                              'Windows luft im Real-Modus
CONST WINSTANDARD = &H82                      'Windows luft im Standard-Modus
CONST WINENHANCED = &H83                   'Windows luft im erweiterten Modus
										
DIM WindowsAktiv AS INTEGER                                     'Windows-Modus
DIM HVer AS INTEGER                                  'Hauptversion von Windows
DIM NVer AS INTEGER                                  'Nebenversion von Windows
									       
PRINT " WINDAB  -  (c) 1991 by Michael Tischer "
PRINT                                                      'Leerzeile einfgen
WindowsAktiv = Windows(HVer, NVer)        'Windowsmodus und -version bestimmen
SELECT CASE WindowsAktiv
  CASE NOWIN
    PRINT "Windows nicht aktiv "
  CASE WIN2X
    PRINT "Windows /386 V 2.x aktiv "
  CASE WINREAL
    PRINT "Windows im Real-Modus "
  CASE WINSTANDARD
    PRINT "Windows aktiv im Standard-Modus "
  CASE WINENHANCED
    PRINT "Windows V"; LTRIM$(STR$(HVer)); ".";
    PRINT LTRIM$(STR$(NVer)); " aktiv im erweiterten Modus"
END SELECT

'*****************************************************************************
'* Windows : Stellt fest, ob Windows aktiv ist                               *
'* Eingabe : HVERSION = Integer-Variable zur Aufnahme der Hauptversionsnummer*     
'*           NVERSION = Integer-Variable zur Aufnahme der Unterversionsnummer*  
'* Ausgabe : Windows-Status, eine der Konstaten NOWIN, WIN386X, WINREAL,     *
'*           WINSTANDARD oder WINENAHNCED                                    *
'* Info    : Nur im Enhanced-Modus von Windows 3.0 kann die Versionsnummer   *
'*           ermittelt und zurckgeliefert werden                            *
'*****************************************************************************
FUNCTION Windows% (HVersion AS INTEGER, NVersion AS INTEGER)
										
DIM Regs AS RegTypeX                    'Prozessorregister fr Interruptaufruf
DIM Erg AS INTEGER                               'Zwischenspeicher fr Version
										
HVersion = 0                                    'Initialisiere Versionsnummern
NVersion = 0
										
Regs.ax = &H1600              'Funktionsnr. Instalationstest erweiterter Modus
CALL INTERRUPTX(MULTIPLEX, Regs, Regs)
Erg = Regs.ax                                                  'Regs.AX merken
										
SELECT CASE Erg MOD 256                                     'Lo-Byte auswerten
										
  CASE &H1, &HFF                                           'Windows /386 luft
    HVersion = 2                                                 'Hauptversion
    NVersion = 0                                       'Nebenversion unbekannt
    Windows = WIN386X
										
  CASE &H0, &H80         'Windows luft nicht oder im Real- oder Standartmodus
    Regs.ax = &H4680                   'Real oder Standartmodus identifizieren
    CALL INTERRUPTX(MULTIPLEX, Regs, Regs)
    IF (Regs.ax MOD 256) = &H80 THEN                          'Luft Windows ?
      Windows = NOWIN                                                  'Nein !
    ELSE                            'Windows luft im Real- oder Standartmodus
      Regs.ax = &H1605                    'Instalation DOS Extender simulieren
      Regs.bx = &H0
      Regs.si = &H0
      Regs.cx = &H0
      Regs.es = &H0
      Regs.ds = &H0
      Regs.dx = &H1
      CALL INTERRUPTX(MULTIPLEX, Regs, Regs)
      IF Regs.cx = &H0 THEN                           'Windows im Real-Modus ?
	Windows = WINREAL                                                  'Ja
      ELSE                              'Nein, Windows luft im Standart-Modus
	Windows = WINSTANDARD
      END IF
    END IF
  CASE ELSE          'Windows im erweiterten Modus, AX enthllt Versionsnummer
    HVersion = Erg AND &HF                           'Lo-Byte ist Hauptversion
    NVersion = Erg \ 256                             'Hi-Byte ist Nebenversion
    Windows = WINENHANCED
END SELECT
										
END FUNCTION

