/**********************************************************************/
/*                   I R Q _ U T I L  . H                             */
/**------------------------------------------------------------------**/
/*  Aufgabe        : Konstanten und Prototypen fr Interrupt-         */
/*                   Funktionen.                                      */
/**------------------------------------------------------------------**/
/*  Autor          : Michael Tischer / Bruno Jennrich                 */
/*  entwickelt am  : 12.03.1994                                       */
/*  letztes Update : 26.03.1994                                       */
/**********************************************************************/
#ifndef __INC_IRQ_UTIL_H
#define __INC_IRQ_UTIL_H

#include "types.h"

/*- IRQ-Controller Portadressen --------------------------------------*/
#define MASTER_PIC          0x20       /* Basisadresse des Master-PIC */
#define SLAVE_PIC           0xA0        /* Basisadresse des Slave-PIC */
#define IRQ_MASK            0x01         /* Offset zu Maskierungsport */

/*- IRQ-Kommandos ----------------------------------------------------*/
#define EOI                 0x20 /* Unspezifizierter End of Interrupt */

#define MASTER_FIRST_VECTOR 0x08   /* Software-Vektoren der Hardware- */
#define SLAVE_FIRST_VECTOR  0x70   /* Interrupts                      */

/*- Prototypen -------------------------------------------------------*/
VOID irq_Enable ( INT iIRQ );
VOID irq_Disable( INT iIRQ );
VOID irq_SendEOI( INT iIRQ );
VOID ( _interrupt _FP *irq_SetHandler( INT iIRQ,
                       VOID (_interrupt _FP *lpHandler)() ) ) ();
BYTE irq_ReadMask( INT iController );
BYTE irq_ReadIRR ( INT iController );
BYTE irq_ReadISR ( INT iController );
#endif

