/**********************************************************************/
/*                   S B U T I L . H                                  */
/**------------------------------------------------------------------**/
/*  Aufgabe        : Headerdatei fr SB_UTIL.C                        */
/**------------------------------------------------------------------**/
/*  Autor          : Michael Tischer / Bruno Jennrich                 */
/*  entwickelt am  : 20.03.1994                                       */
/*  letztes Update : 25.03.1994                                       */
/**********************************************************************/
#ifndef __INC_SB_UTIL_H
#define __INC_SB_UTIL_H

#include <dos.h>
#include <stdio.h>
#include "types.h"

typedef struct tagSBBASE
{  
  INT    iDspPort,                     /* Basisport des DS-Prozessors */
         iMixPort,                            /* Basisport des Mixers */
         iMpuPort;                        /* Basisport der MP-Einheit */
  INT    iDspDmaB;                     /* verwendeter 8-Bit DMA Kanal */
  INT    iDspDmaW;                    /* verwendeter 16-Bit DMA Kanal */
  INT    iDspIrq;                     /* verwendete Interrupt-Leitung */
  WORD   uDspVersion;                           /* DSP Versionsnummer */
  LPCHAR pDspName;                     /* Name der Soundblaster-Karte */
} SBBASE;
typedef SBBASE *PSBBASE;

INT  sb_GetEnviron  ( PSBBASE pSBBASE, PCHAR lpEnv );
VOID sb_Print       ( PSBBASE pSBBASE );
VOID sb_UnloadDriver( LPVOID  lpEntry );
LPVOID sb_LoadDriver( PCHAR pName );
#endif

