/**********************************************************************/
/*                             T Y P M C                              */
/*--------------------------------------------------------------------*/
/*    Aufgabe        : Stellt die Typematic-Rate auf der MF-II-Tas-   */
/*                     tatur nach den Wnschen des Anwenders ein.     */
/*--------------------------------------------------------------------*/
/*    Autor          : MICHAEL TISCHER                                */
/*    entwickelt am  : 28.08.1988                                     */
/*    letztes Update :  3.01.1992                                     */
/*--------------------------------------------------------------------*/
/*    Speichermodell : SMALL                                          */
/*--------------------------------------------------------------------*/
/*    Module         : TYPMC.C + TYPMCA.ASM                           */
/**********************************************************************/
                                                                        
/*== Include-Dateien einbinden =======================================*/
                                                                        
#include <stdlib.h>
#include <stdio.h>
                                                                        
/*== Typedefs ========================================================*/
                                                                        
typedef unsigned char BYTE;               /* wir basteln uns ein Byte */
typedef BYTE BOOL;                 /* nimmt immer TRUE oder FALSE auf */
                                                                        
/*== Konstanten ======================================================*/
                                                                        
#define TRUE  ( 1 == 1 )       /* werden zur Arbeit mit BOOL bentigt */
#define FALSE ( 0 == 1 )
                                                                        
/*== Einbindung externer Funktionen aus dem Assemblermodul ===========*/
                                                                        
extern BOOL set_typm( BYTE trate );       /* setzt die Typematic-Rate */
                                                                        
/**********************************************************************/
/**                           HAUPTPROGRAMM                          **/
/**********************************************************************/
                                                                        
void main(int argc, char *argv[] )
{
 int delay,                   /* nimmt die angegebene Verzgerung auf */
     speed;             /* nimmt die angegebene Wiederholfrequenz auf */
                                                                        
 printf("\nTYPMC  -  (c) 1988, 92 by MICHAEL TISCHER\n");
 if (argc!=3 || ( (delay = atoi(argv[1]))<0 || delay>3 ) ||
                ( (speed = atoi(argv[2]))<0 || speed>31 ))
  {        /* es wurden keine zwei oder ungltige Parameter bergeben */
   printf("Aufruf: TYPMC  Verzgerung  Wiederholfrequenz\n");
   printf("                     \x1e              \x1e\n");
   printf("                                   \n");
   printf("     ͻ  ͻ\n");
   printf("       0 : 1/4 Sekunde      0 : 30,0 W./Sek. \n");
   printf("       1 : 1/2 Sekunde      1 : 26,7 W./Sek. \n");
   printf("       2 : 3/4 Sekunde      2 : 24,0 W./Sek. \n");
   printf("       3 : 1 Sekunde        3 : 21,8 W./Sek. \n");
   printf("     Ķ           .         \n");
   printf("      alle Angaben 20%%            .         \n");
   printf("     ͼ           .         \n");
   printf("                             28 :  2,5 W./Sek. \n");
   printf("                             29 :  2,3 W./Sek. \n");
   printf("                             30 :  2,1 W./Sek. \n");
   printf("                             31 :  2,0 W./Sek. \n");
   printf("                            ͼ\n");
  }
 else                                       /* die Paramter sind o.k. */
  {
   if (set_typm( (BYTE) ((delay << 5) + speed ))) /* Typematic setzen */
    printf("Die Typematic-Rate wurde eingestellt.\n");
   else
    printf("ACHTUNG! Fehler bei Zugriff auf Tastatur-Contoller\n");
  }
}
