/**********************************************************************/
/*                   V O I C E . C                                    */
/**------------------------------------------------------------------**/
/*  Aufgabe        : Demonstriert den Zugriff auf die Creative-       */
/*                   Treiber unter Verwendung des "Text to Speach"    */
/*                   Treibers.                                        */
/**------------------------------------------------------------------**/
/*  Autor          : Michael Tischer / Bruno Jennrich                 */
/*  entwickelt am  : 20.03.1994                                       */
/*  letztes Update : 25.03.1994                                       */
/* COMPILER: Borland C++ 3.1, Micsosoft Visual C++ 1.5                */
/**********************************************************************/

/*- Include-Dateien einbinden ----------------------------------------*/
#include <stdio.h>
#include <process.h>

#include "sbutil.h"
#include "ctts.h"
#include "args.h"

/*- Folgende Zeilen innerhalb eines Projektes entfernen: -------------*/
#include "sbutil.c"
#include "ctts.c"
#include "args.c"

/**********************************************************************/
/*          H A U P T P R O G R A M M                                 */
/**********************************************************************/
VOID main( INT argc, PCHAR argv[] )
{ LPVOID lpEntry;                                 /* Treibereinsprung */
  INT iGender, iTone, iVolume, iPitch, iSpeed;
  PCHAR pText;

  iGender = 0;                                          /* Geschlecht */
  iGender = GetArg( argc, argv, "-FEMALE", _none, NULL, 0 );
  iTone = 0;                                                   /* Ton */
  iTone = GetArg( argc, argv, "-TREBLE", _none, NULL, 0 );
  iVolume = 5;                                          /* Lautstrke */
  GetArg( argc, argv, "-VOL:", _int, &iVolume, 1 );
  iPitch = 5;                                              /* Tonhhe */
  GetArg( argc, argv, "-PITCH:", _int, &iPitch, 1 );
  iSpeed = 5;                                      /* Geschwindigkeit */
  GetArg( argc, argv, "-SPEED:", _int, &iSpeed, 1 );

  pText = NULL;
  GetNArg( argc, argv, "-", ( PCHAR *)&pText, 1 );
  if( pText == NULL )
  {
    printf("Aufruf: voice TEXT [ -FEMALE][ -TREBLE]" );
    printf("[ -VOL:0-9][ -PITCH:0-9][ -SPEED:0-9 ]\n" );
    exit( 0 );
  }

  lpEntry = sb_LoadDriver( "CTTS.DRV" );         /* CTTS-Driver laden */

  if( !lpEntry )  printf("Konnte \"CTTS.DRV\" nicht finden!\n");
  else
  {
    if( ctts_GetEnvSettings( lpEntry ) )  /* Umgebungsvariable setzen */
      printf("Fehler in BLASTER-Environment Variable");
    else
    if( ctts_Init( lpEntry ) )              /* Treiber initialisieren */
        printf("CTTS konnte nicht initialisiert werden");
    else
    { WORD ver;
      ver = ctts_GetDrvVer( lpEntry );        /* Versionsnummer holen */
      printf(" CTTS-Version: %02d.%02d\n", ver >> 8, ver & 0xff);

      ctts_SetSpeechParam( lpEntry,         /* Sprachparameter setzen */
                           ( BYTE ) iGender,
                           ( BYTE ) iTone,
                           ( BYTE ) iVolume,
                           ( BYTE ) iPitch,
                           ( BYTE ) iSpeed );
      ctts_Say( lpEntry, pText );           /* Sprchlein aufsagen... */
      ctts_Terminate( lpEntry );                          /* und Ende */
    }
    sb_UnloadDriver( lpEntry );
  }
}

