{**********************************************************************}
{*                          D U M P P . P A S                         *}
{*--------------------------------------------------------------------*}
{*    Aufgabe        : ein Filter, der Zeichen von dem Standard-      *}
{*                     eingabegert einliest und sie als Hex- und     *}
{*                     ASCII-Dump auf dem Standardausgabegert        *}
{*                     ausgibt.                                       *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  :  8.08.1987                                     *}
{*    letztes Update : 28.10.1991                                     *}
{*--------------------------------------------------------------------*}
{*    Info           : dieses Programm darf nur von der DOS-Ebene     *}
{*                     aus aufgerufen werden, nicht innerhalb der     *}
{*                     Entwicklungsumgebung von Turbo Pascal          *}
{**********************************************************************}
                                                                        
program DUMPP;
                                                                        
Uses Dos;                                     { die DOS-Unit einbinden }
                                                                        
{$V-}                      { die Lngenprfung von Strings unterbleibt }
                                                                        
const NUL = 0;                            { ASCII-Code NUL-Zeichen     }
      BEL = 7;                            { ASCII-Code Klingelzeichen  }
      BS  = 8;                            { ASCII-Code Backspace       }
      TAB = 9;                            { ASCII-Code Tabulator       }
      LF  = 10;                           { ASCII-Code Linefeed        }
      CR  = 13;                           { ASCII-Code Carriage Return }
      EOF = 26;                           { ASCII-Code Datei-Ende      }
      ESC = 27;                           { ASCII-Code Escape          }
                                                                        
type SZText = string[3];  { dient zur bergabe des Namen eins Sonderz. }
     DumpPf = array[1..80] of char; { nimmt den auszugebenden Dump auf }
                                                                        
{**********************************************************************}
{* SZ: schreibt den Namen eines Steuerzeichens in einen Puffer        *}
{* Eingabe : s.u.                                                     *}
{* Ausgabe : keine                                                    *}
{* Info    : nach dem Aufruf dieser Porzedur zeigt der bergebene     *}
{*           Pointer hinter das letzte Zeichen des Steuerzeichen-     *}
{*           Namens im Dump-Puffer                                    *}
{**********************************************************************}
                                                                        
procedure SZ(var Puffer  : DumpPf;    { hier wird der Text eingetragen }
                 Text    : SZText;            { der einzutragende Text }
             var Pointer : integer);  { Anfangsadr. des Text im Puffer }
                                                                        
var Zaehler : integer;                               { Schleifenzhler }
                                                                        
begin
 Puffer[Pointer] := '<';                    { leitet Steuerzeichen ein }
 for Zaehler := 1 to length(Text) do       { Text in Puffer bertragen }
  Puffer[Pointer + Zaehler] := Text[Zaehler];
 Puffer[Pointer + Zaehler + 1] := '>';         { beendet Steuerzeichen }
 Pointer := Pointer + Zaehler + 2;      { Pointer auf nchstes Zeichen }
end;
                                                                        
{**********************************************************************}
{* DoDump: liest die Zeichen ein und gibt sie als Dump aus            *}
{* Eingabe : keine                                                    *}
{* Ausgabe : keine                                                    *}
{**********************************************************************}
                                                                        
procedure DoDump;
                                                                        
var Regs     : Registers;     { Prozessorregister fr Interrupt-Aufruf }
    NeunByte : array[1..9] of char;{nimmt die eingelesenen Zeichen auf }
    DumpPuf  : DumpPf;                 { nimmt eine Zeile des DUMP auf }
    HexZif,
    Zaehler,                                         { Schleifenzhler }
    NextA    : integer;              { Zeiger in Puffer fr ASCII-Code }
    Ende     : boolean;                   { kein Byte mehr eingelesen? }
                                                                        
begin
 Ende := false;                                       { noch kein Ende }
 repeat
  Regs.ah := $3F;                   { Funktionsnummer fr Handle Lesen }
  Regs.bx := 0;          { das Standardeingabegert trgt den Handle 0 }
  Regs.cx := 9;                                   { 9 Zeichen einlesen }
  Regs.ds := Seg(NeunByte);                { Segmentadresse des Puffer }
  Regs.dx := Ofs(NeunByte);                 { Offsetadresse des Puffer }
  MsDos( Regs);                           { DOS-Interrupt $21 aufrufen }
  if (Regs.ax = 0) then Ende := true;       { kein Zeichen eingelesen? }
  if not(Ende) then
   begin                                                        { NEIN }
    for Zaehler := 1 to 30             { Puffer mit Leerzeichen fllen }
     do DumpPuf [Zaehler] := ' ';
    DumpPuf[31] := #219;  { Trennzeichen zwischen Hex und ASCII setezn }
    NextA := 32;               { ASCII-Zeichen folgen auf Trennzeichen }
    for Zaehler := 1 to Regs.ax do             { die gelesenen Zeichen }
     begin                                     { verarbeiten           }
      HexZif := ord(NeunByte[Zaehler]) shr 4 + 48; { Byte in erste Hex }
      if (HexZif > 57) then HexZif := HexZif + 7;  { Ziffer umwandeln  }
      DumpPuf[Zaehler * 3 - 2] := chr(HexZif); { in Puffer abspeichern }
      HexZif := ord(NeunByte[Zaehler]) and 15 + 48;{Byte in zweite Hex }
      if (HexZif > 57) then HexZif := HexZif + 7;  { Ziffer umwandeln  }
      DumpPuf[Zaehler * 3 - 1] := chr(HexZif); { in Puffer abspeichern }
      case ord(NeunByte[Zaehler]) of               { ASCII-Code testen }
       NUL : SZ(DumpPuf, 'NUL', NextA);              { NUL-Zeichen     }
       BEL : SZ(DumpPuf, 'BEL', NextA);              { Klingelzeichen  }
       BS  : SZ(DumpPuf, 'BS' , NextA);              { Backspace       }
       TAB : SZ(DumpPuf, 'TAB', NextA);              { Tabulator       }
       LF  : SZ(DumpPuf, 'LF' , NextA);              { Linefeed        }
       CR  : SZ(DumpPuf, 'CR' , NextA);              { Carriage Return }
       EOF : SZ(DumpPuf, 'EOF', NextA);              { Datei-Ende      }
       ESC : SZ(DumpPuf, 'ESC', NextA);              { Escape          }
       else
        begin                                       { normales Zeichen }
         DumpPuf[NextA] := NeunByte[Zaehler];{ ASCII-Zeichen speichern }
         NextA := succ(NextA)     { Zeiger auf nchstes Zeichen setzen }
        end
      end;
     end;
    DumpPuf[NextA] := #219;                      { Ende-Zeichen setzen }
    DumpPuf[NextA+1] := chr(CR);   { Carriage-Return gefolgt von Line- }
    DumpPuf[NextA+2] := chr(LF);   { feed an das Pufferende            }
    Regs.ah := $40;             { Funktionsnummer fr Handle Schreiben }
    Regs.bx := 1;        { das Standardausgabegert trgt den Handle 1 }
    Regs.cx := NextA+2;                           { Anzahl der Zeichen }
    Regs.ds := Seg(DumpPuf);               { Segmentadresse des Puffer }
    Regs.dx := Ofs(DumpPuf);                { Offsetadresse des Puffer }
    MsDos( Regs );                        { DOS-Interrupt $21 aufrufen }
   end;
 until Ende;            { wiederholen, bis kein Zeichen mehr verfgbar }
end;
                                                                        
{**********************************************************************}
{*                            HAUPTPROGRAMM                           *}
{**********************************************************************}
                                                                        
begin
  DoDump;                                              { Dump ausgeben }
end.
