{***********************************************************************
*                           I S E V P . P A S                          *
**--------------------------------------------------------------------**
*  Aufgabe        : berprft, ob eine EGA- oder VGA-Karte aktiv ist.  *
*                   schlossen ist GA-Karten am Beispiel einer Routine  *
*                   zur Darstellung vo Logos innerhalb des Textmodus   *
**--------------------------------------------------------------------**
*  Autor          : MICHAEL TISCHER                                    *
*  entwickelt am  :  5.08.1990                                         *
*  letztes Update : 14.01.1991                                         *
***********************************************************************}

Program IsEgaVgaP;

uses DOS;                                       { zum Interrupt-Aufruf }

{-- Typedeklarationen -------------------------------------------------}

type KARTE = ( EGA_MONO, EGA_COLOR, VGA_MONO, VGA_COLOR, WEDERNOCH );

{***********************************************************************
*  IsEgaVga : Stellt fest, ob eine EGA- oder VGA-Karte installiert ist.*
**--------------------------------------------------------------------**
*  Eingabe : keine                                                     *
*  Ausgabe : Art der Video-Karte vom Typ KARTE                         *
***********************************************************************}

function IsEgaVga : KARTE;

var Regs : Registers;          { Prozessorregister fr Interruptaufruf }

begin
  Regs.AX := $1a00;                 { Funktion 1Ah gibt es nur bei VGA }
  Intr( $10, Regs );
  if ( Regs.AL = $1a ) then              { ist die Funktion verfgbar? }
    case Regs.BL of                               { Ja, Code auswerten }
         4 : IsEgaVga := EGA_COLOR;
         5 : IsEgaVga := EGA_MONO;
         7 : IsEgaVga := VGA_MONO;
         8 : IsEgaVga := VGA_COLOR;
      else IsEgaVga := WEDERNOCH;
    end
  else                                { keine VGA, aber vielleicht EGA }
    begin
      Regs.ah := $12;                     { Funktion 12h Unterfunktion }
      Regs.bl := $10;                     { 10h aufrufen               }
      intr($10, Regs);                           { Video-BIOS aufrufen }
      if ( Regs.bl <> $10 ) then                      { Ist EGA-Karte? }
        begin                            { Ja, aber an welchem Monitor }
          if Regs.BH = 0 then IsEgaVga := EGA_COLOR
                         else IsEgaVga := EGA_MONO;
        end
      else IsEgaVga := WEDERNOCH;
    end;
end;

{**********************************************************************}
{-- H A U P T P R O G R A M M                                        --}
{**********************************************************************}

begin
  writeln( 'ISEVP  -  (c) 1990 by MICHAEL TISCHER'#13#10 );
  case IsEgaVga of
    WEDERNOCH : writeln( 'Bei der aktiven Videokarte handelt es sich ' +
                         'weder um eine EGA-, noch um eine VGA-Karte.');

    EGA_MONO  : writeln( 'Es ist eine EGA-Karte an einem MDA-Monitor ' +
                         'aktiv.');

    EGA_COLOR : writeln( 'Es ist eine EGA-Karte an einem EGA- oder '+
                         ' Multiscan-Monitor aktiv.' );

    VGA_MONO  : writeln( 'Es ist eine VGA-Karte an einem analogen ' +
                         'Monochrom-Monitor aktiv.');

    VGA_COLOR : writeln( 'Es ist eine VGA-Karte an einem VGA- '+
                         ' oder Multiscan-Monitor aktiv.' );
  end;
end.
