{**********************************************************************}
{*                           K O N F I G P                            *}
{*--------------------------------------------------------------------*}
{*    Aufgabe        : gibt die Konfiguration des PC auf dem Bild-    *}
{*                     schirm aus                                     *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  :  7.07.1987                                     *}
{*    letztes Update : 18.10.1991                                     *}
{**********************************************************************}
                                                                        
program KONFIGP;
                                                                        
Uses Crt, Dos;                   { die CRT- und die DOS-Unit einbinden }
                                                                        
{**********************************************************************}
{* PrintKonfig: Ausgabe der Konfiguration eines PC                    *}
{* Eingabe : keine                                                    *}
{* Ausgabe : keine                                                    *}
{* Info    : die Konfiguration wird in Abhngigkeit des PC-Typs       *}
{*           ausgegeben                                               *}
{**********************************************************************}
                                                                        
procedure PrintKonfig;
                                                                        
var AT   : boolean;                               { ist der PC ein AT? }
    Regs : Registers;         { Prozessorregister fr Interrupt-Aufruf }
                                                                        
begin
 ClrScr;                                          { Bildschirm lschen }
 if Mem[$F000:$FFFE] = $FC then AT := true         { testen ob AT oder }
                           else AT := false;       { PC bzw. XT        }
 writeln('KONFIGP  -  (c) 1987, 1991 by Michael Tischer');
 writeln;
 writeln('Konfiguration Ihres PC');
 writeln('----------------------------------------------------');
 write('PC-Typ                  : ');
 case Mem[$F000:$FFFE] of                     { PC-Typ erneut auslesen }
  $FF : writeln('PC');                                { $FF ist ein PC }
  $FE : writeln('XT');                                { $FE ist ein XT }
  else writeln('AT oder hher')                       { $FC ist ein AT }
 end;

 Intr($12, Regs);       { RAM-Speicher-Gre ber BIOS-Interrupt lesen }
 writeln('RAM-Speicher            : ',Regs.ax,' KB');
 if AT then                                       { ist der PC ein AT? }
  begin                                                           { JA }
   Regs.ah := $88;         { Funktionsnr. fr zustzl. RAM-Gre lesen }
   Intr($15, Regs );               { BIOS-Kassetten-Interrupt aufrufen }
   writeln('zustzlicher RAM        : ',Regs.ax,' KB ber 1 MB');
  end;
 Intr($11, Regs);             { BIOS-Konfigurations-Interrupt aufrufen }
 write('Videomodus nach Start   : ');
 case Regs.al and 48 of                         { Videomodus ermitteln }
   0 : writeln('undefiniert');
  16 : writeln('40*25 Zeichen Color-Karte');
  32 : writeln('80*25 Zeichen Color-Karte');
  48 : writeln('80*25 Zeichen Mono-Karte')
 end;
 writeln('Diskettenlaufwerke      : ', succ(Regs.al shr 6 and 3));
 writeln('Serielle Schnittstellen : ', Regs.ah shr 1 and 3);
 writeln('Parallele Schnittstellen: ', Regs.ah shr 6)
end;
                                                                        
{**********************************************************************}
{*                            HAUPTPROGRAMM                           *}
{**********************************************************************}
                                                                        
begin
 PrintKonfig;                                 { Konfiguration ausgeben }
end.
