{**********************************************************************}
{*                           M C B P . P A S                          *}
{*--------------------------------------------------------------------*}
{*    Aufgabe        : zeigt die ber das DOS allokierten Speicher-   *}
{*                     Blcke an.                                     *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  : 22.08.1988                                     *}
{*    letztes Update : 20.10.1991                                     *}
{**********************************************************************}
                                                                        
program MCBP;
                                                                        
uses DOS, CRT;                   { die DOS- und die CRT-Unit einbinden }
                                                                        
type BytePtr = ^byte;                           { Pointer auf ein BYTE }
     Bereich = array[0..1000] of byte;  { ein Bereich, irgendwo im RAM }
     BerPtr  = ^Bereich;                   { Pointer auf einen Bereich }
     MCB     = record                       { ein Memory-Control-Block }
                 IdCode  : char;{ "M" = es folgt ein Block, "Z" = Ende }
                 PSP     : word;  { Segmentadresse des zugehrigen PSP }
                 Abstand : word;          { Anzahl der Paragraphen - 1 }
               end;
     MCBPtr  = ^MCB;                           { Pointer auf einen MCB }
     MCBPtr2 = ^MCBPtr;                     { Pointer auf einen MCBPtr }
     HexStr  = string[4];     { nimmt einen 4 ziffrigen Hex-String auf }
                                                                        
var  CvHStr  : HexStr;        { nimmt den umgewandelten Hex-String auf }
                                                                        
{**********************************************************************}
{* HexString: erzeugt aus der bergebenen Zahl einen 4-ziffrigen      *}
{*            Hex-String.                                             *}
{* Eingabe : - HexVal = Der umzuwandelnde Wert.                       *}
{* Ausgabe : Der umgesetzte Hex-String.                               *}
{**********************************************************************}
                                                                        
function HexString( HexVal : word ) : HexStr;
                                                                        
var zaehler,                                         { Schleifenzhler }
    Nibble  : byte;            { das jeweils unterste Nibble des Words }
                                                                        
begin
  CvHStr := 'xxxx';                             { den String 'anlegen' }
  for zaehler:=4 downto 1 do    { die 4 Ziffern des String durchlaufen }
    begin
      Nibble := HexVal and $000f;     { nur die oberen 4 Bits belassen }
      if ( Nibble > 9 ) then          { in einen Buchstaben umwandeln? }
        CvHStr[ zaehler ] := chr(Nibble - 10 + ord('A'))          { Ja }
      else                                    { in eine Zahl umwandeln }
        CvHStr[ zaehler ] := chr(Nibble + ord('0'));
      HexVal := HexVal shr 4;     { HexVal 4 Bitpositionen nach rechts }
    end;
  HexString := CvHStr;                { den erzeugten String bergeben }
end;
                                                                        
{**********************************************************************}
{* FirstMCB: Liefert einen Zeiger auf den ersten MCB.                 *}
{* Eingabe : keine                                                    *}
{* Ausgabe : Zeiger auf den ersten MCB.                               *}
{**********************************************************************}
                                                                        
function FirstMCB : MCBPtr;
                                                                        
var Regs : Registers;                { nimmt die Prozessorregister auf }
                                                                        
begin
  Regs.ah := $52;          { Fkt.nr.: Adresse des DOS-Info-Block holen }
  MsDos( Regs );                          { DOS-Interrupt $21 aufrufen }
                                                                        
  {*-- ES:(BX-4) zeigt auf den ersten MCB, Pointer erstellen ---------*}
                                                                        
  FirstMCB := MCBPtr2( ptr( Regs.ES-1, Regs.BX+12 ) )^;
end;
                                                                        
{**********************************************************************}
{* Dump: gibt Hex- und ASCII-Dump eines Speicherbereiches aus.        *}
{* Eingabe : - DPtr  = Pointer auf den zu dumpenden Speicherbereich.  *}
{*           - Anz   = Anzahl der zu dumpenden Zeilen (je 16 Byte)    *}
{* Ausgabe : keine                                                    *}
{**********************************************************************}
                                                                        
procedure Dump( DPtr : BerPtr; Anz : byte);
                                                                        
type HBStr = string[2];                { nimmt 2-ziffrige Hex-Zahl auf }
                                                                        
var  Offset,                           { Offset in den Speicherbereich }
     Z       : integer;                              { Schleifenzhler }
     HexStr  : HBStr;           { nimmt eine Hex-Zahl fr Hex-Dump auf }
                                                                        
procedure HexByte( HByte : byte );
                                                                        
begin
  HexStr[1] := chr( (HByte shr 4) + ord('0') );         { erste Ziffer }
  if HexStr[1] > '9' then                   { in Buchstaben umwandeln? }
    HexStr[1] := chr( ord(HexStr[1]) +  7 );                      { Ja }
  HexStr[2] := chr( (HByte and 15) + ord('0') );       { zweite Ziffer }
  if HexStr[2] > '9' then                   { in Buchstaben umwandeln? }
    HexStr[2] := chr( ord(HexStr[2]) +  7 );                      { Ja }
end;
                                                                        
begin
  HexStr := 'zz';                           { den Hex-String 'anlegen' }
  writeln;
  write('DUMP  0123456789ABCDEF        00 01 02 03 04 05 06 07 08');
  writeln(' 09 0A 0B 0C 0D 0E 0F');
  write('');
  writeln('');
  Offset := 0;               { mit dem ersten Byte im Bereich beginnen }
  while Anz>0 do                    { die Schleife ANZ-mal durchlaufen }
    begin
      write(HexString(Offset), '  ');
      for Z:=0 to 15 do                   { jeweils 15 Byte bearbeiten }
        if (Dptr^[Offset+Z] >= 32) then      { gltiges ASCII-Zeichen? }
          write( chr(Dptr^[Offset+Z]) )         { Ja, Zeichen ausgeben }
        else                                                    { Nein }
          write(' ');        { anstelle des Zeichen ein Space ausgeben }
      write('        ');              { Cursor auf den Hex-Teil setzen }
      for Z:=0 to 15 do                   { jeweils 15 Byte bearbeiten }
        begin
          HexByte( Dptr^[Offset+Z] );          { Byte nach Hex wandeln }
          write(HexStr, ' ');                { den Hex-String ausgeben }
        end;
      writeln;
      Offset := Offset + 16;      { Offset in die nchste Zeile setzen }
      Dec( Anz );     { Anzahl der verbleibenden Zeilen dekrementieren }
    end;
  writeln;
end;
                                                                        
{**********************************************************************}
{* TraceMCB: verfolgt die Liste der MCBs.                             *}
{* Eingabe : keine                                                    *}
{* Ausgabe : keine                                                    *}
{**********************************************************************}
                                                                        
procedure TraceMCB;
                                                                        
const ComSpec : array[0..7] of char = 'COMSPEC=';
                                                                        
var  AktMCB  : MCBPtr;
     Ende    : boolean;
     Taste   : char;
     NrMCB,                       { Nummer des gerade untersuchten MCB }
     Z       : integer;                              { Schleifenzhler }
     MemPtr  : BerPtr;

begin
  Ende := false;
  NrMCB := 1;                       { der erste MCB trgt die Nummer 1 }
  AktMCB := FirstMCB;                { Zeiger auf den ersten MCB holen }
  repeat                                { die Kette der MCBs verfolgen }
    if AktMCB^.IdCode = 'Z' then               { letzten MCB erreicht? }
      Ende := true;                                               { Ja }
    writeln('MCB-Nummer    = ', NrMCB);
    writeln('MCB-Adresse   = ', HexString(seg(AktMCB^)), ':',
                                HexString(ofs(AktMCB^)) );
    writeln('Speicher-Adr. = ', HexString(succ(seg(AktMCB^))), ':',
                                HexString(ofs(AktMCB^)) );
    writeln('ID            = ', AktMCB^.IdCode);
    writeln('PSP-Adresse   = ', HexString(AktMCB^.PSP), ':0000');
    writeln('Gre         = ', AktMCB^.Abstand, ' Paragraphen ',
            '( ', longint(AktMCB^.Abstand) shl 4, ' Bytes )');
    write('Inhalt        = ');
                                                                        
    {*-- handelt es sich um ein Environment? -------------------------*}
                                                                        
    Z := 0;                { mit dem Vergleich im ersten Byte anfangen }
    MemPtr := BerPtr(ptr(Seg(AktMCB^)+1, 0));         { Pointer in RAM }
    while ( (Z<=7) and (ord(ComSpec[Z]) = MemPtr^[Z]) ) do
    Inc(Z);                         { Z auf das nchste Zeichen setzen }
    if Z>7 then                           { wurde der String entdeckt? }
      begin                  { Ja, es handelt sich um ein Environment! }
        writeln('Environment');
        MemPtr := BerPtr(ptr(Seg(AktMCB^)+1, 0));
        if Lo(DosVersion) >= 3 then      { DOS Version 3.0 oder hher? }
          begin                          { Ja, Programmnamen ermitteln }
            write('Programmname  = ');
            Z := 0;                     { mit dem ersten Byte beginnen }
            while not( (MemPtr^[Z]=0) and (MemPtr^[Z+1]=0) ) do
              Inc( Z );                            { Leerstring suchen }
            if ( MemPtr^[Z+2]=1 ) and ( MemPtr^[Z+3]=0 ) then
              begin              { hier befindet sich ein Programmname }
                Z := Z + 4;    { Z auf den Anfang des Prg.namen setzen }
                repeat                 { den Programmnamen durchlaufen }
                  write( chr(MemPtr^[Z]) );         { Zeichen ausgeben }
                  Inc( Z );           { das nchste Zeichen bearbeiten }
                until ( MemPtr^[Z]=0 );           { bis zum Stringende }
                writeln;
              end
            else                         { Programmname nicht entdeckt }
             writeln('unbekannt');
          end;
                                                                        
        {*-- die Environment-Strings ausgeben ------------------------*}
                                                                        
        writeln(#13,#10, 'Environment-Strings');
        Z := 0;  { mit dem ersten Byte im allokierten Bereich beginnen }
        while MemPtr^[Z]<>0 do          { wiederholen, bis Leer-String }
          begin
            write('      ');
            repeat                             { einen String ausgeben }
              write( chr(MemPtr^[Z]) );         { ein Zeichen ausgeben }
              Inc( Z );               { das nchste Zeichen bearbeiten }
            until MemPtr^[Z]=0;                   { bis zum Stringende }
            Inc( Z );      { auf den Anfang des nchsten String setzen }
            writeln;                                   { Zeile beenden }
          end
      end
    else                                            { kein Envrionment }
      begin
                                                                        
        {*-- handelt es sich um einen PSP? ---------------------------*}
        {*-- (wird durch Befehl INT 20 (Code=$CD $20) eingeleitet) ---*}
                                                                        
        MemPtr := BerPtr(ptr(seg(AktMCB^)+1, 0));        { Ptr. setzen }
        if ( (MemPtr^[0]=$CD) and (MemPtr^[1]=$20) ) then
          begin                         { es handelt sich um einen PSP }
            writeln('PSP (mit nachfolgendem Programm)');
          end
        else          { der Befehl INT 20 konnte nicht entdeckt werden }
          begin
            writeln('nicht identifizierbar (Programm oder Daten)');
            Dump( MemPtr, 5);           { die ersten 5*16 Bytes dumpen }
          end;
      end;
                                                                        
    write('');
    writeln(' Bitte Taste drcken ');
    if ( not Ende ) then
     begin                       { Pointer auf den nchsten MCB setzen }
       AktMCB := MCBPtr(ptr(seg(AktMCB^) + AktMCB^.Abstand + 1, 0));
       Inc(NrMCB);                 { die Nummer des MCB inkrementieren }
       taste := ReadKey;
     end;
  until ( Ende )      { wiederholen, bis der letzte MCB bearbeitet ist }
end;
                                                                        
{**********************************************************************}
{**                           HAUPTPROGRAMM                          **}
{**********************************************************************}
                                                                        
begin
  ClrScr;                                     { den Bildschirm lschen }
  writeln( 'MCBP  -  (c) 1988, 91 by Michael Tischer' );
  writeln;
  writeln;
  TraceMCB;                             { die Kette der MCBs aufdecken }
end.
                                                                        
