{**********************************************************************}
{*                             N O K E Y P                            *}
{*--------------------------------------------------------------------*}
{*    Zeigt, wie man den Tastaturpuffer lscht, um den Anwender bei   *}
{*    wichtigen Abfragen (z.B. "Datei lschen?") Schutz vor vor-      *}
{*    eiligen Eingaben zu bieten.                                     *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  :  1.01.1992                                     *}
{*    letztes Update :  1.01.1992                                     *}
{**********************************************************************}
                                                                        
program NoKeyP;

uses Crt;

{**********************************************************************}
{* ClearKbBuffer : lscht den Inhalt des Tastaturpuffers              *}
{* Eingabe : keine                                                    *}
{* Ausgabe : keine                                                    *}
{**********************************************************************}

procedure ClearKbBuffer;

begin
  inline( $fa );                { CLI, keine Hardware-Interrupts jetzt }
  memw[$40:$1A] := memw[$40:$1C];        { kein Zeichen mehr im Puffer }
  inline( $fb );                  { STI, Hardware-Interrupts wieder an }
end;

{**********************************************************************}
{*                     H A U P T P R O G R A M M                      *}
{**********************************************************************}

var i,                                               { Schleifenzhler }
    ccount : integer;               { Anzahl Zeichen im Tastaturpuffer }
    ch     : char;                                  { nimmt Tasten auf }

begin
  clrscr;
  writeln( 'NOKEYP  -  (c) 1992 by Michael Tischer' );
  writeln;
  writeln( 'Bei 0 werden alle Zeichen im Tastaurpuffer gelscht.' );
  writeln;

  for i := 10 downto 0 do              { dem Anwender Zeit zur Eingabe }
    begin                              { einiger Tasten geben          }
      write( i:5 );
      delay( 750 );
    end;

  ClearKbBuffer;                               { Tastaturpuffer leeren }

  {-- Zeichen ausgeben, die sich noch im Tastaturpuffer befinden ------}

  ccount := 0;                            { noch kein Zeichen entdeckt }
  writeln;
  writeln;
  writeln( 'Zeichen im Tastaturpuffer :' );

  while KeyPressed do            { noch ein Zeichen im Tastaturpuffer? }
    begin                                   { Ja, auslesen und ausgben }
      ch := ReadKey;
      write( '   ', ord(ch):5 );          { zunchst nur Code ausgeben }
      if ord(ch) > 32 then                       { kein Sonderzeichen? }
        write ( '(', ch, ')' );          { Nein, dann auch als Zeichen }
      writeln;
      inc( ccount );                   { mehr als ein Zeichen gefunden }
    end;
  if ccount = 0 then                         { keine Zeichen gefunden? }
    writeln( '(Keine)' );                                       { Nein }
  writeln;
end.
