{**********************************************************************}
{*                              V I O S P                             *}
{*--------------------------------------------------------------------*}
{*    Aufgabe        : ermittelt die Art der installierten Video-     *}
{*                     Karten.                                        *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  :  2.10.1988                                     *}
{*    letztes Update : 14.01.1991                                     *}
{**********************************************************************}
                                                                        
program VIOSP;
                                                                        
                                                                        
{$L viospa}                            { das Assembler-Modul einbinden }
                                                                        
const NO_VIOS    = 0;                              { keine Video-Karte }
      VGA        = 1;                                      { VGA-Karte }
      EGA        = 2;                                      { EGA-Karte }
      MDA        = 3;                     { Monochrome Display Adapter }
      HGC        = 4;                         { Hercules Graphics Card }
      CGA        = 5;                         { Color Graphics Adapter }
                                                                        
      NO_MON     = 0;                                   { kein Monitor }
      MONO       = 1;                            { monochromer Monitor }
      COLOR      = 2;                                  { Color-Monitor }
      EGA_HIRES  = 3;                        { hochauflsender Monitor }
      ANAL_MONO  = 4;                     { monochromer Analog-Monitor }
      ANAL_COLOR = 5;                         { analoger Color-Monitor }
                                                                        
type Vios = record     { beschreibt Video-Karte samt angeschl. Monitor }
             Karte,
             Monitor : byte;
            end;
     ViosPtr = ^Vios;                 { Pointer auf eine VIOS-Struktur }
                                                                        
procedure GetVios( vp : ViosPtr ) ; external ;
                                                                        
var VidSys : array[1..2] of Vios;  { Array mit den beiden Video-Struk. }
                                                                        
{**********************************************************************}
{* PrintSys: gibt Informationen ber ein Video-System aus             *}
{* Eingabe : - KARTE: Codenummer der Video-Karte                      *}
{*           - MON  : Codenummer des angeschlossenen Monitor          *}
{* Ausgabe : keine                                                    *}
{**********************************************************************}
                                                                        
procedure PrintSys( Karte, Mon : byte );
                                                                        
begin
  write(' ');
  case Karte of
    VGA : write('VGA');
    EGA : write('EGA');
    MDA : write('MDA');
    CGA : write('CGA');
    HGC : write('HGC');
  end;
  write('-Karte an einem ');
  case Mon of
    MONO       : writeln('monochromen Monitor');
    COLOR      : writeln('Color-Monitor');
    EGA_HIRES  : writeln('hochauflsendem Monitor');
    ANAL_MONO  : writeln('monochromen Analog-Monitor');
    ANAL_COLOR : writeln('color Analog-Monitor');
  end;
end;
                                                                        
{**********************************************************************}
{**                           HAUPTPROGRAMM                          **}
{**********************************************************************}
                                                                        
begin
  GetVios( @VidSys );       { die installierten Video-Karten ermitteln }
  writeln('VIOSP  -  (c) 1988, 91 by MICHAEL TISCHER');
  write('primres Video-System:  ');
  PrintSys( VidSys[1].Karte, VidSys[1].Monitor );
  if VidSys[2].Karte <> NO_VIOS then  { auch ein zweites Video-System? }
    begin                                                         { JA }
      write('sekundres Video-System:');
      PrintSys( VidSys[2].Karte, VidSys[2].Monitor );
    end;
end.
                                                                        
                                                                        
                                                                        
