{********************************************************************}
{                           W I N . P A S                            }
{*------------------------------------------------------------------*}
{ Aufgabe        : Text-Modus Fenster verwalten                      }
{*------------------------------------------------------------------*}
{ Autor          : Michael Tischer / Bruno Jennrich                  }
{ entwickelt am  : 03.05.1994                                        }
{ letztes Update :  8.10.1994                                        }
{********************************************************************}
Unit WIN;

Interface

Const
 VM_COLOR       = 1;
 VM_MONO        = 2;

 VIOINT         = $10;
 VIOPAGE        = $00;
 VIOSETCURSOR   = $02;
 VIOGETCURSOR   = $03;
 VIOSETPAGE     = $05;
 VIOGETMODE     = $0F;

 WIN_CRLF       = $0001;
 WIN_SCROLL     = $0002;
 WIN_HASCURSOR  = $0004;
 WIN_ACTIVE     = $0008;

 OT_INT         = 1;                                 { OBJTYPE - INT }
 OT_BOOL        = 2;
 DT_TRUEFALSE   = 0;
 DT_ONOFF       = 1;
 DT_YESNO       = 2;
 MSG_LOSTFOCUS  = 0;
 MSG_GOTFOCUS   = 1;
 MSG_KEY        = 2;
 MSG_CHANGED    = 3;
 MSG_PRECHANGE  = 4;
 KBD_ESC        = 27;
 KBD_TAB        = 9;
 KBD_SHIFTTAB   = 15 * 256;
 KBD_BACK       = 8;
 KBD_CR         = 13;
 KBD_LF         = 10;
 KBD_F1         = 59 * 256;
 KBD_F2         = 60 * 256;
 KBD_F3         = 61 * 256;
 KBD_F4         = 62 * 256;
 KBD_F5         = 63 * 256;
 KBD_F6         = 64 * 256;
 KBD_F7         = 65 * 256;
 KBD_F8         = 66 * 256;
 KBD_F9         = 67 * 256;
 KBD_F10        = 68 * 256;
 KBD_UP         = 72 * 256;
 KBD_LEFT       = 75 * 256;
 KBD_DN         = 80 * 256;
 KBD_RIGHT      = 77 * 256;
 KBD_DEL        = 83 * 256;
 KBD_HOME       = 71 * 256;
 KBD_END        = 79 * 256;
 KBD_PGUP       = 73 * 256;
 KBD_PGDN       = 81 * 256;
 KBD_CTRLPGUP   = 132 * 256;
 KBD_CTRLPGDN   = 118 * 256;

 KBD_PLUS       = 43;
 KBD_MINUS      = 45;

Type
WINDOW = Record { beschreibt ein Fenster }
  iX,iY,             { Position zu bergeordnetem Fenster/Bildschirm }
  iW,iH,                                           { Breite und Hhe }
  iCX,iCY : Integer;                      { aktuelle Ausgabeposition }
  uFlags  : Word;                                       { s. WIN_??? }
  iAttr,                                        { aktuelles Attribut }
  iHiAttr,                                        { aktives Attribut }
  iLoAttr : Byte;                                 { passives Atribut }
End;
PWINDOW = ^WINDOW;

{-- Window-Procedure, beispielsweise fr das Handling von Tasta- ---}
{-- tureingaben                                                  ---}
winproc = Procedure( iNum, msg, iParam : Integer; lParam : Longint );

INTDATA = Record { beschreibt ein Integer-Eingabefeld }
  iMin, iMax : Integer;
  pValue     : ^Integer;
  pText      : String;
End;

BOOLDATA = Record { beschreibt ein BOOL-Eingabefeld }
  iDisplay : Integer;
  pValue   : ^Boolean;
  pText    : String;
End;

OBJ = Record { beschreibt ein Eingabefeld }
  X, Y, W, H,
  iType      : Integer;
  pData      : Pointer;
End;
OBJPTR = ^OBJ;

{-- Prototypen ----------------------------------------------}

Procedure win_Init( var Win            : WINDOW;
                        iX, iY, iW, iH : Integer;
                        iLA, iHA       : Byte;
                        uFlags         : Word );

Procedure win_LoVideo( var Win : WINDOW );

Procedure win_HiVideo( var Win : WINDOW );

Procedure win_GetVIOSMEM;

Function win_GetMode : Word;

Procedure win_GotoXY( var Win : WINDOW; iX, iY : Integer );

Procedure win_Clr( var Win : WINDOW );

Function win_Save( var Win : WINDOW ) : Pointer;

Procedure win_Restore( pMem : Pointer; bFree : Boolean );

Procedure win_GetScreenSettings( var Win : WINDOW );

Procedure win_ScrollUp( var Win : WINDOW ; NumRows : Integer );

Procedure _win_Print( var Win  : WINDOW;
                          Text : String;
                          iCnt : Integer );

Procedure win_Print( var Win : WINDOW; Text : String );

Procedure win_PrintAt( var Win    : WINDOW;
                           iX, iY : Integer;
                           Text   : String );

Procedure win_Beep;

Procedure win_ObjectInitINT( var Obj        : OBJ;
                             var Data       : INTDATA;
                                 x, y, w, h : Integer;
                                 Text      : String;
                                 iMin, iMax : Integer;
                                 pValue     : Pointer );

Procedure win_ObjectInitBOOL( var Obj     : OBJ ;
                              var Data    : BOOLDATA;
                              x, y, w, h  : Integer;
                              Text        : String;
                              iDisplay    : Integer;
                              pValue      : Pointer );

Procedure win_ObjectPrint( var Win : WINDOW; var Obj : OBJ );

Function win_ObjectQueryValue( var Obj : OBJ ) : Longint;

Procedure win_ObjectPrintArray( var Win     : WINDOW ;
                                    pOArray : pointer;
                                    iNum,
                                    iAct    : Integer );

Procedure win_ObjectProcessKey( var Win  : WINDOW;
                                    Obj  : OBJ ;
                                    iKey : Integer );

Function win_ObjectWantsKey( Obj : OBJ; iKey : Integer ) : Boolean;

Procedure win_ObjectProcessArray( var Win     : WINDOW;
                                      pOArray : pointer;
                                      iNum    : Integer;
                                      lpFunc  : winproc );

Implementation
Uses DOS,CRT;

const MAXOBS = 100;

type ObjArray = array [0..MAXOBS-1] of OBJ; { fr Zugriff auf }
type ObjArrayPtr = ^ObjArray;               { OBJ-Arrays      }

{- Globale Variablen ------------------------------------------------}
Const
_lpVIOSMEM : ^Integer = NIL;       { Adresse des Bildschirmspeichers }
_wVIOSMODE : Word     = 0;                    { Aktueller Videomodus }
_Columns   : Integer  = 0;         { Anzahl der dargestellten Zeilen }

{********************************************************************}
{ win_Init : Initialisiert WINDOW-Strutkur                           }
{*------------------------------------------------------------------*}
{ Eingabe : Win      - die zu intialisierende WINDOW-Struktur        }
{           iX, iY   - Position des Fensters relativ zu bergeord-   }
{                      netem Fenster bzw. Bildschirm.                }
{                      Ursprung : ( 0,0 )                            }
{           iW, iH   - Breite und Hhe des Fensters                  }
{           iLA, iHA - Textattribute ( passiv, aktiv )               }
{           uFlags   - Flags                                         }
{********************************************************************}
Procedure win_Init( var Win            : WINDOW;
                        iX, iY, iW, iH : Integer;
                        iLA, iHA       : Byte;
                        uFlags         : Word );
Begin
  Win.iX      := iX;                             { Parameter setzen }
  Win.iY      := iY;
  Win.iW      := iW;
  Win.iH      := iH;
  Win.iLoAttr := iLA;
  Win.iHiAttr := iHA;

  Win.uFlags := uFlags;

  Win.iCX := 0;           { Cursorposition := Ursprung des Fensters }
  Win.iCY := 0;
  win_LoVideo( Win );
End;

{********************************************************************}
{ win_LoVideo : Ausgabe auf niedrige Intensitt umschalten           }
{*------------------------------------------------------------------*}
{ Eingabe : Win - das Fenster, in dem folgende Ausgaben mit niedri-  }
{                 ger Intensitt stattfinden sollen.                 }
{********************************************************************}
Procedure win_LoVideo( var Win : WINDOW );

Begin
  Win.iAttr := Win.iLoAttr;
End;

{********************************************************************}
{ win_HiVideo  :  Ausgabe auf hohe Intensitt umschalten             }
{*------------------------------------------------------------------*}
{ Eingabe : Win - das Fenster, in dem folgende Ausgaben mit hoer     }
{                 Intensitt stattfinden sollen.                     }
{********************************************************************}
Procedure win_HiVideo( var Win : WINDOW );

Begin
  Win.iAttr := Win.iHiAttr;
End;

{********************************************************************}
{ win_GetVIOSMEM : Ermittelt Startadresse des Bildschrimspeichers    }
{                  und aktuellen Videomodus.                         }
{*------------------------------------------------------------------*}
{ Info : Die Adresse des Bildschirmspeichers wird in der globalen    }
{        Variablen _lpVIOSMEM gespeichert. Der Videomodus wird in    }
{        _iVIOSMODE verzeichnet.                                     }
{********************************************************************}
Procedure win_GetVIOSMEM;

var regs : Registers;

Begin
 if _lpVIOSMEM = NIL then           { Adresse schon ermittelt ? }
   Begin { Nein, noch nicht }
     regs.ah := VIOSETPAGE;
     regs.al := VIOPAGE;
     intr( VIOINT, regs );

     regs.ah := VIOGETMODE;
     regs.al := VIOPAGE;
     intr( VIOINT, regs );
     _Columns := regs.ah;                        { Anzahl der Spalten }
     _wVIOSMODE := regs.al;
     if _wVIOSMODE = $07 then _lpVIOSMEM := ptr( $B000, 0 )
                         else _lpVIOSMEM := ptr( $B800, 0 );
   End;
End;

{********************************************************************}
{ win_GetMode : Ermittelt aktuellen Bildschirmmodus.                 }
{*------------------------------------------------------------------*}
{ Ausgabe : VM_COLOR ( 1 ) - Farbbildschirm                          }
{           VM_MONO  ( 2 ) - Monochrombildschirm                     }
{           sonst.         - unbekannt!                              }
{********************************************************************}
Function win_GetMode : Word;

Begin
  win_GetVIOSMEM;
  win_GetMode :=_wVIOSMODE;
End;

{********************************************************************}
{ win_GotoXY : Setze Ausgabeposition innerhalb eines Fensters        }
{*------------------------------------------------------------------*}
{ Eingabe : Win    - das Fenster, in dem eine neue Ausgabeposition   }
{                    position gesetzt werden soll.                   }
{           iX, iY - Neue Position                                   }
{*------------------------------------------------------------------*}
{ Info : Ist das Flag "WIN_HASCURSOR" gesetzt, wird durch diese      }
{        Funktion auch der blinkende Bildschirmcursor gesetzt.       }
{********************************************************************}
Procedure win_GotoXY( var Win : WINDOW; iX, iY : Integer );

var regs : Registers;

Begin
  if iX < 0 then iX := 0;     { Gltigkeit der neuen Position prfen }
  if iY < 0 then iY := 0;
  if iX > Win.iW then iX := Win.iW - 1;
  if iY > Win.iH then iY := Win.iH - 1;

  Win.iCX := iX; { neue Cursorposition einstellen }
  Win.iCY := iY;

  if( Win.uFlags and WIN_ACTIVE ) <> 0 then { Fenster aktiv ? }
    Begin
      if( Win.uFlags and WIN_HASCURSOR ) <> 0 then
        Begin { Fenster besitzt den Cursor }
          regs.dh := Byte  ( Win.iY + Win.iCY );
          regs.dl := Byte  ( Win.iX + Win.iCX );
        End
        else
        Begin
          regs.dh := $FF;                                        { Nein! }
          regs.dl := $FF;
        End;
      regs.ah := VIOSETCURSOR; { Cursor ber BIOS setzen }
      regs.bh := VIOPAGE;
      intr( VIOINT, regs );
    End;
End;

{********************************************************************}
{ win_Clr : Fensterinhalt lschen                                    }
{*------------------------------------------------------------------*}
{ Eingabe : Win - das Fenster, dessen Inhalt gelscht werden soll   *}
{********************************************************************}
Procedure win_Clr( var Win:WINDOW );

var  iX, iY : Integer;
     lpRow  : ^Word;
     iAdr   : Word;

Begin
  win_GetVIOSMEM;
  for iY := 0 to Win.iH - 1 do { alle Zeilen durchlaufen }
  Begin
    iAdr := ( Win.iX + ( iY + Win.iY ) * _Columns ) * 2;
    lpRow := ptr( seg( _lpVIOSMEM^ ), iAdr );
    iAdr :=  Win.iAttr * 256 + 32;
    for iX := 0 to Win.iW - 1 do { alle Spalten der Zeile durchl. }
      Begin
        lpRow^ := iAdr; { Leerzeichen schreiben }
        Inc( lprow );
      End;
  End;

  Win.iCX := 0; { Cursor in obere linke Fensterecke }
  Win.iCY := 0;
End;

{********************************************************************}
{ win_Save : Fensterinhalt speichern                                 }
{*------------------------------------------------------------------*}
{ Eingabe : Win - das Fenster, dessen Inhalt gespeichert werden soll }
{ Ausgabe : Adresse des Speichers, der Fensterinformationen samt     }
{           Inhalt aufgenommen hat, oder NULL falls kein freier      }
{           Speicher mehr verfgbar.                                 }
{********************************************************************}
Function win_Save( var Win : WINDOW ) : Pointer;

var  pMem,
     pWinData    : pWINDOW;
     lpRows, lpR : ^Word;
     iY, iX      : Integer;
     iAdr        : Word;

Begin
  win_GetVIOSMEM;
  GetMem( pMem, ( Win.iW  *  Win.iH  *  2 ) + sizeof( WINDOW ) );
  if pMem <> NIL then
  Begin { es konnte gengend Speicher allokiert werden }
    pWinData := pMem;   { Fensterbeschreiber an den Anfang }
    pWinData^ := Win;  { des Puffers kopieren             }

    {-- den Fensterinhalt zeilenweise in den Puffer kopieren -----}
    lpRows :=  Pointer ( Longint ( pWinData ) + sizeof( WINDOW ) );
    for iY := 0 to Win.iH - 1 do
    Begin
      iAdr := ( Win.iX + ( iY + Win.iY ) * _Columns ) * 2;
      lpR := ptr( seg( _lpVIOSMEM^ ), iAdr );
      for iX := 0 to Win.iW - 1 do
       Begin
         lpRows^ := lpR^;
         Inc( lpRows );
         Inc( lpR );
       End;
    End;
  End;
  win_Save:=pMem; { Zeiger auf Puffer zurckliefern }
End;

{********************************************************************}
{ win_Restore : Fensterinhalt wiederherstellen                       }
{*------------------------------------------------------------------*}
{ Eingabe : pMem - Adresse des vorher durch win_Save ermittelten     }
{                  Speichers, der sowohl Fenster-Informationen       }
{                  ( Position, Dimension, Cursor ), als auch Inhalt  }
{                  enthlt.                                          }
{           bFree- Soll Speicher nach Wiederherstellung frei-        }
{                  gegeben werden? ( in diesem Fall bFree: = TRUE )  }
{********************************************************************}
Procedure win_Restore( pMem : Pointer; bFree : Boolean );

var lpRows, lpR : ^Word;
    pWinData    : PWINDOW;
    iX, iY      : Integer;
    iAdr        : Word;

Begin
  win_GetVIOSMEM;
  if pMem <> NIL then
  Begin { Pufferzeiger zeigt nichts ins Leere }
    pWinData := pMem;
    lpRows :=  Pointer ( Longint ( pWinData ) + sizeof( WINDOW ) );

    {-- den Puffer zeilenweise durchlaufen und Fensterinhalt ----------}
    {-- restaurieren                                         ----------}
    for iY := 0 to pWinData^.iH do
      Begin
        iAdr := ( pWinData^.iX + ( iY + pWinData^.iY ) * _Columns ) * 2;
        lpR := ptr( seg( _lpVIOSMEM^ ), iAdr );
        for iX := 0 to pWinData^.iW - 1 do { die Spalten der Zeile }
          Begin                            { durchlaufen           }
           lpR^ := lpRows^;
           Inc( lpR );
           Inc( lpRows );
         End;
      End;
    win_GotoXY( pWinData^, pWinData^.iCX, pWinData^.iCY );

    if bFree then dispose( pMem ); { Speicher auf Wunsch freigeben }
  End;
End;

{********************************************************************}
{ win_GetActScreenSettings : Aktuelle Bildschirmeinstellungen er-    }
{                            mitteln                                 }
{*------------------------------------------------------------------*}
{ Eingabe : Win - WINDOW-Struktur, die Bildschirmeinstellungen auf-  }
{                 nehmen soll                                        }
{*------------------------------------------------------------------*}
{ Info : Aktueller Videomodus und aktuelle Videoseite werden nicht   }
{        in WINDOW-Struktur gespeichert.                             }
{********************************************************************}
Procedure win_GetScreenSettings( var Win : WINDOW );

var regs : Registers;

Begin
  win_GetVIOSMEM;

  win_Init( Win, 0, 0, _Columns, 25,
            $00, $00, WIN_HASCURSOR or WIN_ACTIVE );

  regs.ah := VIOGETCURSOR;
  regs.bh := VIOPAGE;
  intr( VIOINT, regs );

  Win.iCX := regs.dl;
  Win.iCY := regs.dh;
End;

{********************************************************************}
{ win_ScrollUp : Fensterinhalt nach oben scrollen                    }
{*------------------------------------------------------------------*}
{ Eingabe : Win     - das Fenster                                    }
{           NumRows - Anzahl der nach oben zu scrollenden Zeilen     }
{*------------------------------------------------------------------*}
{ Info : Der durch das Scrollen frei werdende Bereich wird durch     }
{        Leerzeichen im aktuellen Textattribut besetzt.              }
{********************************************************************}
Procedure win_ScrollUp( var Win : WINDOW ; NumRows : Integer );

var iX, iY    :Integer;
    lpRow,
    lpRowDest : ^Word;
    Clear     : WINDOW;
    iDAdr,
    iAdr      : Word;
Begin
  win_GetVIOSMEM;

  for iY := NumRows to Win.iH - 1 do { die Zeilen durchlaufen }
    Begin
      iDAdr := ( Win.iX + ( ( iY-NumRows ) + Win.iY ) * _Columns ) * 2;
      iAdr := ( Win.iX + ( iY + Win.iY ) * _Columns ) * 2 ;
      lpRowDest := ptr( seg( _lpVIOSMEM^ ), iDAdr );
      lpRow     := ptr( seg( _lpVIOSMEM^ ), iAdr );
      for iX := 0 to Win.iW do { Spalten durchlaufen }
        Begin
          lpRowDest^ := lpRow^;
          Inc( lpRowDest );
          Inc( lpRow );
        End;
    End;
  win_Init( Clear, Win.iX, Win.iY + ( Win.iH - NumRows ),
            Win.iW, NumRows, Win.iLoAttr, Win.iHiAttr,
            WIN_CRLF or WIN_SCROLL );
  win_Clr( Clear );
End;

{********************************************************************}
{ _win_PrINT : Textausgabe-Engine                                    }
{*------------------------------------------------------------------*}
{ Eingabe : Win   - das Fenster in das Text ausgegeben werden soll   }
{           Text  - der auszugebende Text                            }
{           iCnt  - Anzahl der auszugebenden Zeichen.                }
{                   ( - 1 := ganzer Text )                           }
{********************************************************************}
Procedure _win_Print( var Win : WINDOW; Text : String; iCnt : Integer );

var i     : Integer;
    lpRow : ^Byte;
    iAdr  : Word;
    c     : Char;
Begin
  i := 1;

  win_GetVIOSMEM;

  iAdr := ( Win.iX + Win.iCX + ( Win.iCY + Win.iY ) * _Columns ) * 2;
  lpRow := ptr( seg( _lpVIOSMEM^ ), iAdr );

  while( ( i <= Length( Text ) ) and ( iCnt <> 0 ) ) do
    Begin
      c := Text[i];
      case c of
        #13:                                       
          if( ( not ( Win.uFlags and WIN_CRLF ) <> 0 ) ) then
            Begin
              Win.iCX := 0;         { An den Anfang der aktuellen Zeile }
              iAdr := ( Win.iX + Win.iCX + ( Win.iCY + Win.iY )
                        * _Columns ) * 2;
              lpRow := ptr( seg( _lpVIOSMEM^ ),iAdr );
           End;

        #10:
          Begin                                                    { LF }
            while Win.iCX < Win.iW do         { Rest der Zeile lschen }
              Begin
                lpRow^:= 32; Inc( lpRow );
                lpRow^ := Win.iAttr; Inc( lpRow );
                Inc( Win.iCX );
              End;
            Inc( Win.iCY );                             { Nchste Zeile }
            if Win.iCY >= Win.iH then         { Letzte Zeile erreicht? }
              Begin
                Win.iCY := Win.iH - 1;
                if( Win.uFlags and WIN_SCROLL ) <> 0 then
                  win_ScrollUp( Win, 1 );           { Inhalt scrollen }
              End;
            Win.iCX := 0;
            iAdr := ( Win.iX + Win.iCX + ( Win.iCY + Win.iY )
                     * _Columns ) * 2;
            lpRow := ptr( seg( _lpVIOSMEM^ ), iAdr );
          End;
      else                          { normales Zeichen ausgeben }
        Begin
          lpRow^ := Byte ( c ); Inc( lpRow );
          lpRow^ := Win.iAttr; Inc( lpRow );
          Inc( Win.iCX );
          if Win.iCX >= Win.iW then
            Begin
              Inc( Win.iCY );                           { Nchste Zeile }
              if Win.iCY >= Win.iH then       { Letzte Zeile erreicht? }
                Begin
                  Win.iCY := Win.iH - 1;
                  if( Win.uFlags and WIN_SCROLL ) <> 0 then
                    win_ScrollUp( Win, 1 ); { Inhalt scrollen }
                End;
              Win.iCX := 0;
              iAdr := ( Win.iX + Win.iCX + ( Win.iCY + Win.iY )
                       * _Columns ) * 2;
              lpRow := ptr( seg( _lpVIOSMEM^ ), iAdr );
          End;
        End;
      End;

      Inc( i ); { nchstes Zeichen }
      if iCnt > 0 then Dec( iCnt );
                              { Zhler dekrementieren, falls positiv }
    End;
  win_GotoXY( Win, Win.iCX, Win.iCY );
End;

{********************************************************************}
{ win_Print : String in Fenster ausgeben                             }
{*------------------------------------------------------------------*}
{ Eingabe : Win  - Fenster, in das String ausgegeben werden soll     }
{           Text - auszugebender String.                             }
{*-------------------------------------------------------------------}
{ Info : Diese Funktion verwendet _win_Print zur Ausgabe.            }
{********************************************************************}
Procedure win_Print( var Win : WINDOW; Text : String );

Begin
  _win_Print( Win, Text,  - 1 );
End;

{********************************************************************}
{ win_PrintAT : Text an beliebiger Stelle im Fenster ausgeben        }
{*-------------------------------------------------------------------}
{ Eingabe : Win    - Fenster, in das String ausgegeben werden soll   }
{           iX, iY - Ausgabeposition                                 }
{           Text   - auszugebender String.                           }
{********************************************************************}
Procedure win_PrintAt( var Win    : WINDOW;
                           iX, iY : Integer;
                           Text   : String );
Begin
  win_GotoXY( Win, iX, iY );
  _win_Print( Win, Text, -1 );
End;

{********************************************************************}
{ win_Beep : Warnton erzeugen                                        }
{********************************************************************}
Procedure win_Beep;

Const uFrq : Word = 400;
var   l    : Longint;

Begin
  Sound(uFrq);                                              { Doop! }
  for l := 0 to 9999 do
  NoSound;
End;

{********************************************************************}
{ win_ObjectInitINT - Object mit INT-Typinformationen verbinden      }
{*------------------------------------------------------------------*}
{ Eingabe: Object     - Typfreies Object                             }
{          Data       - Typinformationen ( PINTDATA )                }
{          x, y, w, h - Position, Dimension des Objects              }
{          Text       - Auszugebender Text                           }
{          iMin, iMax - Grenzwerte des Integers                      }
{          pValue     - Adresse der Variablen, die INT aufnimmt      }
{********************************************************************}
Procedure win_ObjectInitINT( var Obj        : OBJ ;
                             var Data       : INTDATA;
                                 x, y, w, h : Integer;
                                 Text       : String;
                                 iMin, iMax : Integer;
                                 pValue     : Pointer );

Begin
  Obj.X := x;
  Obj.Y := y;
  Obj.W := w;
  Obj.H := h;

  Obj.iType := OT_INT;
  Obj.pData := @Data;

  Data.iMin    := iMin;
  Data.iMax    := iMax;
  Data.pText   := Text;
  Data.pValue  := pValue;
End;

{********************************************************************}
{ win_ObjectInitBOOL - Object mit INT-Typinformationen verbinden     }
{*------------------------------------------------------------------*}
{ Eingabe: Object     - Typfreies Object                             }
{          Data       - Typinformationen ( PBOOLDATA )               }
{          x, y, w, h - Position, Dimension des Objects              }
{          Text       - Auszugebender Text                           }
{          iDisplay   - Ausgabeart ( YES/NO, TRUE/FALSE, ON/OFF )    }
{          pValue     - Adresse der Variablen, die INT aufnimmt      }
{********************************************************************}
Procedure win_ObjectInitBOOL( var Obj        : OBJ ;
                              var Data       : BOOLDATA;
                                  x, y, w, h : Integer;
                                  Text       : String;
                                  iDisplay   : Integer;
                                  pValue     : Pointer );
Begin
  Obj.X := x;
  Obj.Y := y;
  Obj.W := w; { werden ( noch ) nicht verwendet }
  Obj.H := h;
  Obj.iType   := OT_BOOL;
  Obj.pData   := @Data;
  Data.pText     := Text;
  Data.iDisplay := iDisplay;
  Data.pValue   := pValue;
End;

{********************************************************************}
{ win_ObjectPrint - Object darstellen                                }
{*------------------------------------------------------------------*}
{ Eingabe: Win     - Ausgabefenster                                  }
{          Object  - auszugebendes Object                            }
{*------------------------------------------------------------------*}
{ Info: In dieser Funktion werden die OBJet-Typen ermittelt, um die  }
{       OBJekte ihrer entsprechenden Art nach ausgeben zu knnen.    }
{********************************************************************}
Procedure win_ObjectPrint( var Win : WINDOW; var Obj : OBJ );

var pBuffer   : String;
    pIntData  : ^INTDATA ;
    pBoolData : ^BOOLDATA ;

Begin
  case Obj.iType of
    OT_INT:
      Begin     { Obj dereferenzieren }
        pIntData := Obj.pData;
        str( pIntData^.pValue^:5, pBuffer );
        pBuffer :=pIntData^.pText + pBuffer;
        win_PrintAt( Win, Obj.X, Obj.Y, pBuffer );
      End;

   OT_BOOL:
     Begin     { Obj dereferenzieren }
       pBoolData := Obj.pData;
       case pBoolData^.iDisplay of
         DT_TRUEFALSE:
           Begin
             pBuffer := pBoolData^.pText;
             if pBoolData^.pValue^ then pBuffer := pBuffer + '  WAHR'
                                   else pBuffer := pBuffer + 'FALSCH';
           End;

         DT_ONOFF:
           Begin
             pBuffer := pBoolData^.pText;
             if pBoolData^.pValue^ then pBuffer := pBuffer + ' AN'
                                   else pBuffer := pBuffer + 'AUS';
           End;

         DT_YESNO:
           Begin
             pBuffer := pBoolData^.pText;
             if pBoolData^.pValue^ then pBuffer := pBuffer + '  JA'
                                   else pBuffer := pBuffer + 'NEIN';
           End;
       End;
       win_PrintAt( Win, Obj.X, Obj.Y, pBuffer );
     End;
  End;
End;

{********************************************************************}
{ win_ObjectQueryValue - Objectwert ermitteln                        }
{*------------------------------------------------------------------*}
{ Eingabe: Object    - Object dessen Wert ermittelt werden soll      }
{ Ausgabe: Wert, dessen Typ vom OBJekttyp abhngt, und somit evtl.   }
{          gewandelt werden mu.                                     }
{********************************************************************}
Function win_ObjectQueryValue( var Obj : OBJ ) : Longint;

var pIntData  : ^INTDATA;
    pBoolData : ^BOOLDATA;

Begin
  case Obj.iType of
    OT_INT :
     Begin     { Obj dereferenzieren }
       pIntData := Obj.pData;
       win_ObjectQueryValue := pIntData^.pValue^;
     End;

   OT_BOOL:
     Begin     { Obj dereferenzieren }
       pBoolData := Obj.pData;
       win_ObjectQueryValue := Longint( pBoolData^.pValue^ );
     End;
   else
     win_ObjectQueryValue := 0;
  End;
End;

{********************************************************************}
{ win_ObjectPrintArray - Objectliste ausgeben                        }
{*------------------------------------------------------------------*}
{ Eingabe: Win     - Ausgabefenster                                  }
{          pOArray - Zeiger auf erstes Objekt in Array               }
{          iNum    - Anzahl der OBJekte                              }
{          iAct    - Nummer des aktuellen OBJekts                    }
{********************************************************************}
Procedure win_ObjectPrintArray( var Win        : WINDOW ;
                                    pOArray    : pointer;
                                    iNum, iAct : Integer );
var i     : Integer;
    OaPtr : ObjArrayPtr;

Begin
  OaPtr := pOArray;
  for i := 0 to iNum - 1 do                     { Alles darstellen }
  Begin
    if i = iAct then win_HiVideo( Win )
                else win_LoVideo( Win );
    win_ObjectPrint( Win, OaPtr^[i] );
  End;
End;

{********************************************************************}
{ win_ObjectProcessKey - Tastatureingaben verwalten/bearbeiten       }
{*------------------------------------------------------------------*}
{ Eingabe: Win    - Ausgabefenster                                   }
{          Object - Objekt, das Tastatureingaben bearbeiten soll     }
{          iKey   - Tastaturcode                                     }
{********************************************************************}
Procedure win_ObjectProcessKey( var Win  : WINDOW;
                                    Obj  : OBJ;
                                    iKey : Integer );
var pIntData  : ^INTDATA;
    pBoolData : ^BOOLDATA;

Begin
  case Obj.iType of
    OT_INT:
      Begin   { Object dereferenzieren }
        pIntData := Obj.pData;
        case iKey of
          KBD_PLUS:  Inc( pIntData^.pValue^ );
          KBD_MINUS: Dec( pIntData^.pValue^ );
        End;
        if pIntData^.pValue^ < pIntData^.iMin then
           pIntData^.pValue^ := pIntData^.iMax;
        if pIntData^.pValue^ > pIntData^.iMax then
           pIntData^.pValue^ := pIntData^.iMin;

        win_HiVideo( Win );
        win_ObjectPrint( Win, Obj );
      End;

    OT_BOOL:
      Begin
        pBoolData := Obj.pData; { Object dereferenzieren }
        case iKey of
          KBD_PLUS,KBD_MINUS:
           if pBoolData^.pValue^ then pBoolData^.pValue^ := FALSE
                                 else pBoolData^.pValue^ := TRUE;
        End;
        win_HiVideo( Win );
        win_ObjectPrint( Win, Obj );
      End;
  End;
End;

{********************************************************************}
{ win_ObjectWantsKey - Kann Objekt Tastatureingaben verwenden?       }
{*------------------------------------------------------------------*}
{ Eingabe: Object - Objekt, das Tastatureingaben bearbeiten soll     }
{          iKey   - Tastaturcode                                     }
{ Ausgabe:= 0    - Tastencode nicht verwertbar                       }
{           <> 0 - Tastencode von OBJekt verwertbar                  }
{********************************************************************}
Function win_ObjectWantsKey( Obj : OBJ; iKey : Integer ) : Boolean;

Begin
  case Obj.iType of
    OT_INT, OT_BOOL:
      case iKey of
         KBD_PLUS, KBD_MINUS:
           win_ObjectWantsKey := TRUE;
         else
           win_ObjectWantsKey := FALSE;
      End;
  End;
End;

{********************************************************************}
{ win_ObjectProcessArray - Objektliste ( Dialog ) bearbeiten         }
{*------------------------------------------------------------------*}
{ Eingabe: Win     - Ausgabefenster                                  }
{          pOArray - OBJektliste                                     }
{          iNum    - Anzahl der Objekte                              }
{          lpFunc  - Nachrichtenfunktion                             }
{*------------------------------------------------------------------*}
{ Info: Mit TAB und <SHIFT>+TAB wird der Eingabe-FOCUS verschoben.   }
{       Die Benutzerfunktion pFunc wird aufgerufen, um dem Benutzer  }
{       die Mglichkeit zu geben, direkt auf neue Zustnde der       }
{       OBJekte reagieren zu knnen.                                 }
{********************************************************************}
Procedure win_ObjectProcessArray( var Win    : WINDOW;
                                      pOArray : pointer;
                                      iNum    : Integer;
                                      lpFunc  : winproc );

var iAct   : Integer;
    iLoop  : Boolean;
    ch     : Char;
    c      : Word;
    oldVal : Longint;
    OaPtr  : ObjArrayPtr;

Begin
  OaPtr := pOArray;
  iAct := 0;
  win_ObjectPrintArray( Win, pOArray, iNum, iAct );

  iLoop := TRUE;
  while iLoop do
    Begin
      ch := ReadKey;
      if ch = #0 then c := Word ( ReadKey ) * 256
                 else c := Word( ch );
      if win_ObjectWantsKey( OaPtr^[iAct], c ) then
        Begin
          if @lpFunc <> NIL then
            lpFunc( iAct, MSG_PRECHANGE, 0, 0 );
          oldVal := win_ObjectQueryValue( OaPtr^[iAct] );
          win_ObjectProcessKey( Win, OaPtr^[iAct], c );
          if @lpFunc <> NIL then
            lpFunc( iAct, MSG_CHANGED, 0, oldVal );
        End
      else
        Begin
          win_LoVideo( Win );
          win_ObjectPrint( Win, OaPtr^[iAct] );
          if @lpFunc <> NIL then
            lpFunc( iAct, MSG_LOSTFOCUS, 0, 0 );
          case c of
            KBD_ESC:
              iLoop := FALSE;

            KBD_UP:
              Begin
                Dec( iAct );
                if( iAct < 0 ) then iAct := iNum - 1;
              End;

            KBD_DN:
              Begin
                Inc( iAct );
                if( iAct >= iNum ) then iAct := 0;
              End;
          End;

          win_HiVideo( Win );
          win_ObjectPrint( Win, OaPtr^[iAct] );
          if @lpFunc <> NIL then
            lpFunc( iAct, MSG_GOTFOCUS, 0, 0 );
        End;
      if @lpFunc <> NIL then
        lpFunc( iAct, MSG_KEY, c, 0 );
    End;
End;

End.